!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

program E665_PRD54_sigrCO
 implicit none
 integer,parameter::mE665_PRD54_F2p=91,mE665_PRD54_F2d=91,mCO=mE665_PRD54_F2p+mE665_PRD54_F2d
 integer i
 double precision R,DR
 double precision,dimension(mCO)::logx,logQ2,x,Q2,y,F2,errst,errsy,err,dumx,dumQ2,sigr
 double precision corr(mCO,7)
 open(5,file='f2prot')
 do i=1,3
    read(5,*)
 end do
 do i = 1, mE665_PRD54_F2p
    read(5,*) logx(i),logQ2(i),x(i),Q2(i),F2(i),errst(i),errsy(i)
 end do
 close(5)
 open(5,file='f2deut')
 do i=1,3
    read(5,*)
 end do
 do i = mE665_PRD54_F2p+1,mCO
    read(5,*) logx(i),logQ2(i),x(i),Q2(i),F2(i),errst(i),errsy(i)
 end do
 close(5)
 open(5,file='corr_prot')
 do i = 1, mE665_PRD54_F2p
    read(5,*) dumx(i),dumQ2(i),corr(i,:)
    if((dumx(i)/=logx(i)).or.(dumQ2(i)/=logQ2(i))) then
       write(*,*) "Data error",i
    end if
 end do
 close(5)
 open(5,file='corr_deut')
 do i = mE665_PRD54_F2p+1,mCO
    read(5,*) dumx(i),dumQ2(i),corr(i,:)
    if((dumx(i)/=logx(i)).or.(dumQ2(i)/=logQ2(i))) then
       write(*,*) "Data error",i
    end if
 end do
 close(5)
 do i=1,mCO
    call R1990(x(i),Q2(i),R,DR)
    if(i<=91) then
       y(i) = Q2(i)/x(i)/2d0/0.938272d0/465d0
       sigr(i) = (1d0 - y(i) - x(i)**2d0*y(i)**2d0*0.8803536d0/Q2(i) &
                  + y(i)**2d0/2d0*(1d0 + 4d0*x(i)**2d0*0.8803536d0/Q2(i))/(1d0 + R))*F2(i)
    else
       y(i) = Q2(i)/x(i)/2d0/0.9389185d0/465d0
       sigr(i) = (1d0 - y(i) - x(i)**2d0*y(i)**2d0*0.881565d0/Q2(i) &
                  + y(i)**2d0/2d0*(1d0 + 4d0*x(i)**2d0*0.881565d0/Q2(i))/(1d0 + R))*F2(i)
    end if
 end do
 err=errst*sigr/F2
 do i=1,7
    corr(:,i)=0.01d0*corr(:,i)*sigr
 end do
 corr(:,6)=0d0
 open(7,file='E665_PRD54_sigrCO.dato')
 4 format(2f10.5,3f8.3,7f11.6)
 do i = 1,mCO
    write(7,4) x(i),y(i),Q2(i),sigr(i),err(i),corr(i,:)
 end do
 close(7)
end program E665_PRD54_sigrCO
