      SUBROUTINE R1990(X,QQ2,R,ERR)
C
C     Ref: L.W.Whitlow SLAC Report 357 (1990) and
C          L.W.Whitlow et al.: PL B250 (1990) 193
C
C     for Q2 < 0.35 we extrapolate R as a constant with a rough error of 100%
C
      REAL A(3)  / .06723, .46714, 1.89794 /,
     >     B(3)  / .06347, .57468, -.35342 /,
     >     C(3)  / .05992, .50885, 2.10807 /
C
      DATA QMAX /64./
      Q2=QQ2
      IF(Q2.LT.0.35) Q2=0.34
      FAC   = 1+12.*(Q2/(1.+Q2))*(.125**2/(X**2+.125**2))
      RLOG  = FAC/LOG(Q2/.04)
      Q2THR = 5.*(1.-X)**5
      RA   = A(1)*RLOG + A(2)/SQRT(SQRT(Q2**4+A(3)**4))
      RB   = B(1)*RLOG + B(2)/Q2 + B(3)/(Q2**2+.3**2)
      RC   = C(1)*RLOG + C(2)/SQRT((Q2-Q2THR)**2+C(3)**2)
      R    = (RA+RB+RC)/3.
      IF (Q2.GE.0.35) THEN
       Q = MIN(Q2,QMAX)
       S = .006+.03*X**2
       AA = MAX(.05,8.33*X-.66)
       XLOW  = .020+ABS(S*LOG(Q/AA))
       XHIGH = .1*MAX(.1,X)**20/(.86**20+MAX(.1,X)**20)
C       DR1990 = SQRT(XLOW**2+XHIGH**2)
C       D1    = DR1990(X,Q2)
       D1SQUARE=XLOW**2+XHIGH**2
C       D2    = SQRT(((RA-R)**2+(RB-R)**2+(RC-R)**2)/2.)
       D2SQUARE= ((RA-R)**2+(RB-R)**2+(RC-R)**2)/2.
       D3    = .023*(1.+.5*R)
           IF (Q2.LT.1.OR.X.LT..1) D3 = 1.5*D3
       ERR    = SQRT(D1SQUARE+D2SQUARE+D3**2)
      ELSE
       ERR = R
      ENDIF
      RETURN
      END

