!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program HERA_JHEP0110_sigrCO
 implicit none
 integer i,bin
 integer,parameter::mHERA_JHEP0110_sigrNCp=528,mHERA_JHEP0110_sigrNCm=145,mNC=mHERA_JHEP0110_sigrNCp+mHERA_JHEP0110_sigrNCm
 integer,parameter::mHERA_JHEP0110_sigrCCp=34,mHERA_JHEP0110_sigrCCm=34
 integer,parameter::mHERA_JHEP0110_sigrCO = mHERA_JHEP0110_sigrNCp + mHERA_JHEP0110_sigrNCm + &
                                            mHERA_JHEP0110_sigrCCp + mHERA_JHEP0110_sigrCCm
 double precision, dimension(mHERA_JHEP0110_sigrCO)::Q2l,x,y,sigr,dum,sta,unc,cor,exp,rel,gp,had,tot,err
 double precision, dimension(mHERA_JHEP0110_sigrCO,110)::d
 character header
 open(10,file='d09-158.nce+p.txt')
 read(10,*) header
 do i = 1, mHERA_JHEP0110_sigrNCp
    read(10,*)  bin,Q2l(i),x(i),y(i),sigr(i),dum(i),sta(i),unc(i),cor(i),exp(i),rel(i),gp(i),had(i),tot(i),d(i,:)
    if (bin/=i) write(*,*) "Reading error!"
 end do
 close(10)
 open(10,file='d09-158.nce-p.txt')
 read(10,*) header
 do i = mHERA_JHEP0110_sigrNCp+1,mNC
    read(10,*)  bin,Q2l(i),x(i),y(i),sigr(i),dum(i),sta(i),unc(i),cor(i),exp(i),rel(i),gp(i),had(i),tot(i),d(i,:)
    if (bin/=i-mHERA_JHEP0110_sigrNCp) write(*,*) "Reading error!"
 end do
 close(10)
 open(10,file='d09-158.cce+p.txt')
 read(10,*) header
 do i = mNC+1,mNC+mHERA_JHEP0110_sigrCCp
    read(10,*)  bin,Q2l(i),x(i),y(i),dum(i),sigr(i),sta(i),unc(i),cor(i),exp(i),rel(i),gp(i),had(i),tot(i),d(i,:)
    if (bin/=i-mNC) write(*,*) "Reading error!"
 end do
 open(10,file='d09-158.cce-p.txt')
 read(10,*) header
 do i = mNC+mHERA_JHEP0110_sigrCCp+1,mHERA_JHEP0110_sigrCO
    read(10,*)  bin,Q2l(i),x(i),y(i),dum(i),sigr(i),sta(i),unc(i),cor(i),exp(i),rel(i),gp(i),had(i),tot(i),d(i,:)
    if (bin/=i-mNC-mHERA_JHEP0110_sigrCCp) write(*,*) "Reading error!"
 end do
 err=0.01d0*sigr*sta
 unc=0.01d0*sigr*unc
 do i = 1,110
    d(:,i) = 0.01d0*sigr*d(:,i)
 end do
 rel = 0.01d0*sigr*rel
 gp = 0.01d0*sigr*gp
 had = 0.01d0*sigr*had
 open(11,file='HERA_JHEP0110_sigrCO.dato')
 21 format(E13.3,f8.3,f10.3,f8.3,2f8.4,113f11.6)
 do i = 1, mHERA_JHEP0110_sigrCO
    write(11,21) x(i),y(i),Q2l(i),sigr(i),err(i),unc(i),d(i,:),rel(i),gp(i),had(i)
 end do 
 close(11)
end program HERA_JHEP0110_sigrCO
