!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program fastNLO_fnt2007
 implicit none
 integer,parameter:: mfastNLO_fnt2007=72
 integer i
 double precision bla
 double precision,dimension(mfastNLO_fnt2007)::pt,ptmin,ptmax,sig,sta,sysp,sysm,sys,had,Dhad
 double precision,dimension(mfastNLO_fnt2007)::jetEp,jetEm,nomp,nomm,addp,addm,pilep,pilem,unf,spec,resp,resm
 double precision::corr(24,mfastNLO_fnt2007)=0d0,reljetE(4,mfastNLO_fnt2007)=0d0,reljetEbin(4,16)
 open(5,file='fastNLO_fnt2007.dat')
 do i = 1, mfastNLO_fnt2007
    read(5,*) ptmin(i),ptmax(i),sig(i),sta(i),sysp(i),sysm(i),had(i),Dhad(i)
 end do
 close(5)
 pT = 0.5d0*(ptmin+ptmax)
 sig = sig/had
 sta = sta/had
 sysp = sysp/had
 sysm = sysm/had
 corr(24,:) =  Dhad/had*sig
 sys = 0.5d0*(sysp-sysm)
 open(5,file='fastNLO_fnt2007.jen')
 do i = 1, 16
    read(5,*) ptmin(i),ptmax(i),reljetEbin(:,i)
 end do
 close(5)
 open(5,file='fastNLO_fnt2007.cor')
 do i = 1, mfastNLO_fnt2007
    read(5,*) ptmin(i),ptmax(i),jetEp(i),jetEm(i),nomp(i),nomm(i),addp(i),addm(i),pilep(i),pilem(i),unf(i),spec(i),resp(i),resm(i)
 end do
 close(5)

 reljetE(:,1:16) = reljetEbin(:,1:16)
 reljetE(:,17:32) = reljetEbin(:,1:16)
 reljetE(:,33:47) = reljetEbin(:,1:15)
 reljetE(:,48:61) = reljetEbin(:,1:14)
 reljetE(:,62:72) = reljetEbin(:,1:11)

 corr(1,:) = 0.01d0*0.5d0*(jetEp-jetEm)*sig*0.01d0*reljetE(1,:)
 corr(2,:) = 0.01d0*0.5d0*(jetEp-jetEm)*sig*0.01d0*reljetE(2,:)
 corr(3,:) = 0.01d0*0.5d0*(jetEp-jetEm)*sig*0.01d0*reljetE(3,:)
 corr(4,:) = 0.01d0*0.5d0*(jetEp-jetEm)*sig*0.01d0*reljetE(4,:)

 corr(5,1:16) = 0.01d0*0.5d0*(nomp(1:16)-nomm(1:16))*sig(1:16)
 corr(6,17:32) = 0.01d0*0.5d0*(nomp(17:32)-nomm(17:32))*sig(17:32)
 corr(7,33:47) = 0.01d0*0.5d0*(nomp(33:47)-nomm(33:47))*sig(33:47)
 corr(8,48:61) = 0.01d0*0.5d0*(nomp(48:61)-nomm(48:61))*sig(48:61)
 corr(9,62:72) = 0.01d0*0.5d0*(nomp(62:72)-nomm(62:72))*sig(62:72)

 corr(10,48:61) = 0.01d0*0.5d0*(addp(48:61)-addm(48:61))*sig(48:61)
 corr(11,62:72) = 0.01d0*0.5d0*(addp(62:72)-addm(62:72))*sig(62:72)

 corr(12,:) = 0.01d0*0.5d0*(pilep-pilem)*sig

 corr(13,:) = 0.01d0*unf*sig

 corr(14,1:16) = 0.01d0*spec(1:16)*sig(1:16)
 corr(15,17:32) = 0.01d0*spec(17:32)*sig(17:32)
 corr(16,33:47) = 0.01d0*spec(33:47)*sig(33:47)
 corr(17,48:61) = 0.01d0*spec(48:61)*sig(48:61)
 corr(18,62:72) = 0.01d0*spec(62:72)*sig(62:72)

 corr(19,1:16) = 0.01d0*0.5d0*(resp(1:16)-resm(1:16))*sig(1:16)
 corr(20,17:32) = 0.01d0*0.5d0*(resp(17:32)-resm(17:32))*sig(17:32)
 corr(21,33:47) = 0.01d0*0.5d0*(resp(33:47)-resm(33:47))*sig(33:47)
 corr(22,48:61) = 0.01d0*0.5d0*(resp(48:61)-resm(48:61))*sig(48:61)
 corr(23,62:72) = 0.01d0*0.5d0*(resp(62:72)-resm(62:72))*sig(62:72)

 open(7,file='fastNLO_fnt2007.dato')
 7 format(f6.1,2ES11.3,24ES10.2)
 do i = 1, mfastNLO_fnt2007
    write(7,7) pt(i),sig(i),sta(i),corr(:,i)
 end do
 close(7)
end program fastNLO_fnt2007
