!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program NMC_NPB483_sigrCO
 implicit none
 integer,parameter::m90p=73,m120p=65,m200p=75,m280p=79
 integer,parameter::m90d=73,m120d=65,m200d=75,m280d=79
 integer,parameter::mCOp = m90p + m120p + m200p + m280p
 integer,parameter::mCOd = m90d + m120d + m200d + m280d
 integer,parameter::mCO = mCOp + mCOd
 integer i
 double precision,dimension(mCO)::x,Q2,y,sigma_meas,E,Eprime,AC,RC,RE,R,F2l,errst,errsy,err,sigr,esigr,factor
 double precision,dimension(mCO)::E90=0d0,E120=0d0,E200=0d0,E280=0d0,Ep90=0d0,Ep120=0d0,Ep200=0d0,Ep280=0d0,RCp=0d0,RCd=0d0
 open(5,file='NMC_NPB483_90p.dat')
 do i = 1, m90p
    read(5,*)  x(i),Q2(i),y(i),sigma_meas(i),E(i),Eprime(i),AC(i),RC(i),RE(i),R(i),F2l(i),errst(i),errsy(i)
 end do
 close(5)
 open(5,file='NMC_NPB483_120p.dat')
 do i = m90p + 1, m90p + m120p
    read(5,*)  x(i),Q2(i),y(i),sigma_meas(i),E(i),Eprime(i),AC(i),RC(i),RE(i),R(i),F2l(i),errst(i),errsy(i)
 end do
 close(5)
 open(5,file='NMC_NPB483_200p.dat')
 do i = m90p + m120p + 1, m90p + m120p + m200p
    read(5,*)  x(i),Q2(i),y(i),sigma_meas(i),E(i),Eprime(i),AC(i),RC(i),RE(i),R(i),F2l(i),errst(i),errsy(i)
 end do
 close(5)
 open(5,file='NMC_NPB483_280p.dat')
 do i = m90p + m120p + m200p + 1, mCOp
    read(5,*)  x(i),Q2(i),y(i),sigma_meas(i),E(i),Eprime(i),AC(i),RC(i),RE(i),R(i),F2l(i),errst(i),errsy(i)
 end do
 close(5)
 open(5,file='NMC_NPB483_90d.dat')
 do i = mCOp + 1, mCOp + m90d
    read(5,*)  x(i),Q2(i),y(i),sigma_meas(i),E(i),Eprime(i),AC(i),RC(i),RE(i),R(i),F2l(i),errst(i),errsy(i)
 end do
 close(5)
 open(5,file='NMC_NPB483_120d.dat')
 do i = mCOp + m90d + 1, mCOp + m90d + m120d
    read(5,*)  x(i),Q2(i),y(i),sigma_meas(i),E(i),Eprime(i),AC(i),RC(i),RE(i),R(i),F2l(i),errst(i),errsy(i)
 end do
 close(5)
 open(5,file='NMC_NPB483_200d.dat')
 do i = mCOp + m90d + m120d + 1, mCOp + m90d + m120d + m200d
    read(5,*)  x(i),Q2(i),y(i),sigma_meas(i),E(i),Eprime(i),AC(i),RC(i),RE(i),R(i),F2l(i),errst(i),errsy(i)
 end do
 close(5)
 open(5,file='NMC_NPB483_280d.dat')
 do i = mCOp + m90d + m120d + m200d + 1, mCO
    read(5,*)  x(i),Q2(i),y(i),sigma_meas(i),E(i),Eprime(i),AC(i),RC(i),RE(i),R(i),F2l(i),errst(i),errsy(i)
 end do
 close(5)
 factor(1:mCOp) = (1d0 -y(1:mCOp) -x(1:mCOp)**2d0*y(1:mCOp)**2d0*0.88035d0/Q2(1:mCOp) &
                  + 0.5d0*y(1:mCOp)**2d0*(1d0 + 4d0*x(1:mCOp)**2d0*0.88035d0/Q2(1:mCOp))/(1d0+R(1:mCOp)))
 factor(mCOp+1:mCO) = (1d0 -y(mCOp+1:mCO) -x(mCOp+1:mCO)**2d0*y(mCOp+1:mCO)**2d0*0.881565d0/Q2(mCOp+1:mCO) &
                  + 0.5d0*y(mCOp+1:mCO)**2d0*(1d0 + 4d0*x(mCOp+1:mCO)**2d0*0.881565d0/Q2(mCOp+1:mCO))/(1d0+R(mCOp+1:mCO)))
 sigr = factor*F2l
 esigr = factor*errst
 E = 0.01d0*E*sigr
 E90(1:m90p) = E(1:m90p)
 E120(m90p + 1: m90p + m120p) = E(m90p + 1: m90p + m120p)
 E200(m90p + m120p + 1: m90p + m120p + m200p) = E(m90p + m120p + 1: m90p + m120p + m200p)
 E280(m90p + m120p + m200p + 1: mCOp) = E(m90p + m120p + m200p + 1: mCOp)
 E90(mCOp + 1: mCOp + m90d) = E(mCOp + 1: mCOp + m90d)
 E120(mCOp + m90d + 1: mCOp + m90d + m120d) = E(mCOp + m90d + 1: mCOp + m90d + m120d)
 E200(mCOp + m90d + m120d + 1: mCOp + m90d + m120d + m200d) = E(mCOp + m90d + m120d + 1: mCOp + m90d + m120d + m200d)
 E280(mCOp + m90d + m120d + m200d + 1: mCO) = E(mCOp + m90d + m120d + m200d + 1: mCO)
 Eprime = 0.01d0*Eprime*sigr
 Ep90(1:m90p) = Eprime(1:m90p)
 Ep120(m90p + 1: m90p + m120p) = Eprime(m90p + 1: m90p + m120p)
 Ep200(m90p + m120p + 1: m90p + m120p + m200p) = Eprime(m90p + m120p + 1: m90p + m120p + m200p)
 Ep280(m90p + m120p + m200p + 1: mCOp) = Eprime(m90p + m120p + m200p + 1: mCOp)
 Ep90(mCOp + 1: mCOp + m90d) = Eprime(mCOp + 1: mCOp + m90d)
 Ep120(mCOp + m90d + 1: mCOp + m90d + m120d) = Eprime(mCOp + m90d + 1: mCOp + m90d + m120d)
 Ep200(mCOp + m90d + m120d + 1: mCOp + m90d + m120d + m200d) = Eprime(mCOp + m90d + m120d + 1: mCOp + m90d + m120d + m200d)
 Ep280(mCOp + m90d + m120d + m200d + 1: mCO) = Eprime(mCOp + m90d + m120d + m200d + 1: mCO)
 RC = 0.01d0*RC*sigr
 RCp(1:mCOp) = RC(1:mCOp)
 RCd(mCOp+1:mCO) = RC(mCOp+1:mCO)
 AC = 0.01d0*AC*sigr
 RE = 0.01d0*RE*sigr
 open(7,file='NMC_NPB483_sigrCO.dato')
 10 format(f9.4,f8.3,f7.2,2f10.5,12f11.6)
 do i = 1, mCO
    write(7,10) x(i),y(i),Q2(i),sigr(i),esigr(i),E90(i),E120(i),E200(i),E280(i),&
                                                 Ep90(i),Ep120(i),Ep200(i),Ep280(i),RCp(i),RCd(i),AC(i),RE(i)
 end do
 close(7)
end program NMC_NPB483_sigrCO
