!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program SLAC_PLB282_sigrpCO
 implicit none
 integer,parameter::m1=117,m2=208,m3=32,m4=109,m5=77,m6=118
 integer,parameter::mSLAC_PLB282_sigrpCO=m1+m2+m3+m4+m5+m6
 integer i
 integer,dimension(mSLAC_PLB282_sigrpCO)::point,set
 double precision,parameter::mp=0.938272d0,pbarn=0.3893793d9
 double precision dum
 double precision,dimension(mSLAC_PLB282_sigrpCO)::x,y,Q2,eps,E,Ep,sig,sigr,dST,dSR,dSY,dSE,dRC,dN1,dN2,err
 double precision,dimension(mSLAC_PLB282_sigrpCO,6)::dSYset=0d0,dSEset=0d0,dN1set=0d0,dN2set=0d0
 open(1,file='f2.hydrogen')
 do i = 1,13
    read(1,*)
 end do
 do i = 1, mSLAC_PLB282_sigrpCO
     read(1,*) point(i),set(i),x(i),Q2(i),dum,dST(i),dSR(i),dSY(i),dSE(i),dRC(i),dN1(i),dN2(i),dum,dum,dum
 end do
 close(1)
 open(2,file='sigma.hydrogen')
 do i = 1,12
    read(2,*)
 end do
 do i = 1, mSLAC_PLB282_sigrpCO
     read(2,*) point(i),set(i),E(i),Ep(i),dum,x(i),Q2(i),eps(i),dum,dum,sig(i),dum,dum
 end do
 close(2)
 sigr = x*Q2*mp/2d0*137d0**2d0*(E-Ep)**2d0/E/Ep*sig/pbarn
 y = (E-Ep)/E
 err = sigr*dST
 dSR = sigr*dSR
 dSY = sigr*dSY
 dSE = sigr*dSE
 dRC = sigr*dabs(-0.014d0 + 0.017d0*eps)
 dN1 = sigr*dN1
 dN2 = sigr*dN2
 dSYset(1:m1,1) = dSY(1:m1)
 dSYset(m1+1:m1+m2,2) = dSY(m1+1:m1+m2)
 dSYset(m1+m2+1:m1+m2+m3,3) = dSY(m1+m2+1:m1+m2+m3)
 dSYset(m1+m2+m3+1:m1+m2+m3+m4,4) = dSY(m1+m2+m3+1:m1+m2+m3+m4)
 dSYset(m1+m2+m3+m4+1:m1+m2+m3+m4+m5,5) = dSY(m1+m2+m3+m4+1:m1+m2+m3+m4+m5)
 dSYset(m1+m2+m3+m4+m5+1:m1+m2+m3+m4+m5+m6,6) = dSY(m1+m2+m3+m4+m5+1:m1+m2+m3+m4+m5+m6)
 dSEset(1:m1,1) = dSE(1:m1)
 dSEset(m1+1:m1+m2,2) = dSE(m1+1:m1+m2)
 dSEset(m1+m2+1:m1+m2+m3,3) = dSE(m1+m2+1:m1+m2+m3)
 dSEset(m1+m2+m3+1:m1+m2+m3+m4,4) = dSE(m1+m2+m3+1:m1+m2+m3+m4)
 dSEset(m1+m2+m3+m4+1:m1+m2+m3+m4+m5,5) = dSE(m1+m2+m3+m4+1:m1+m2+m3+m4+m5)
 dSEset(m1+m2+m3+m4+m5+1:m1+m2+m3+m4+m5+m6,6) = dSE(m1+m2+m3+m4+m5+1:m1+m2+m3+m4+m5+m6)
 dN1set(1:m1,1) = dN1(1:m1)
 dN1set(m1+1:m1+m2,2) = dN1(m1+1:m1+m2)
 dN1set(m1+m2+1:m1+m2+m3,3) = dN1(m1+m2+1:m1+m2+m3)
 dN1set(m1+m2+m3+1:m1+m2+m3+m4,4) = dN1(m1+m2+m3+1:m1+m2+m3+m4)
 dN1set(m1+m2+m3+m4+1:m1+m2+m3+m4+m5,5) = dN1(m1+m2+m3+m4+1:m1+m2+m3+m4+m5)
 dN1set(m1+m2+m3+m4+m5+1:m1+m2+m3+m4+m5+m6,6) = dN1(m1+m2+m3+m4+m5+1:m1+m2+m3+m4+m5+m6)
 dN2set(1:m1,1) = dN2(1:m1)
 dN2set(m1+1:m1+m2,2) = dN2(m1+1:m1+m2)
 dN2set(m1+m2+1:m1+m2+m3,3) = dN2(m1+m2+1:m1+m2+m3)
 dN2set(m1+m2+m3+1:m1+m2+m3+m4,4) = dN2(m1+m2+m3+1:m1+m2+m3+m4)
 dN2set(m1+m2+m3+m4+1:m1+m2+m3+m4+m5,5) = dN2(m1+m2+m3+m4+1:m1+m2+m3+m4+m5)
 dN2set(m1+m2+m3+m4+m5+1:m1+m2+m3+m4+m5+m6,6) = dN2(m1+m2+m3+m4+m5+1:m1+m2+m3+m4+m5+m6)
 open(7,file='SLAC_PLB282_sigrpCO.dato')
 10 format(f8.3,f9.4,f8.3,3ES14.5,3x,6ES14.5,3x,6ES14.5,3x,ES14.5,3x,6ES14.5,3x,6ES14.5,a)
 do i = 1, mSLAC_PLB282_sigrpCO
    write(7,10) x(i),y(i),Q2(i),sigr(i),err(i),dSR(i),dSYset(i,:),dSEset(i,:),dRC(i),dN1set(i,:),dN2set(i,:),"   "
 end do
 close(7)
end program SLAC_PLB282_sigrpCO 
