!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! fastNLO CODE FOR JETS CROSS SECTIONS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! PDF interface to the fastNLO usercode.
!!!   input:   X parton momentum fraction
!!!     MUF     factorization scale in GeV
!!!   output:  XPDF(-6:6) array of PDF momentum densities (i.e. x*pdf) using the LHAPDF numbering convention:
!!!     tbar, bbar, cbar, sbar, ubar, dbar, g, d, u, s, c, b, t
!!!      -6 ,  -5 ,  -4 ,  -3 ,  -2 ,  -1 , 0, 1, 2, 3, 4, 5, 6
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine FNPDF(X,MUF,XPDF)
       implicit none
       integer fnscheme,fnsfixed
       double precision X,MUF,XPDF(-6:6),xpa(-6:6)
       common /fnschemec/ fnscheme,fnsfixed
       fnscheme=5
       call pdfs(x,MUF*MUF,xpa)
       fnscheme=fnsfixed
       XPDF(-6)=xpa(-6)
       XPDF(-5)=xpa(-5)
       XPDF(-4)=xpa(-4)
       XPDF(-3)=xpa(-3)
       XPDF(-2)=xpa(-2)
       XPDF(-1)=xpa(-1)
       XPDF(0)=xpa(0)
       XPDF(1)=xpa(2)+xpa(-2)
       XPDF(2)=xpa(1)+xpa(-1)
       XPDF(3)=xpa(3)+xpa(-3)
       XPDF(4)=xpa(4)+xpa(-4)
       XPDF(5)=xpa(5)+xpa(-5)
       XPDF(6)=xpa(6)+xpa(-6)
       return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Alpha_s interface to the fastNLO usercode.
!!!   input: MUR renormalization scale in GeV.
!!!   output: Value of (alpha_s/2Pi) at scale MUR.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      double precision function FNALPHAS(MUR)
       implicit none
       double precision::as,mur
       FNALPHAS = 2*as(MUR*MUR)
       return
      end
