!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function e(func)
 use master
 implicit none
 integer order,errors,i
 double precision funcset(0:nerror)
 double precision,external::func
 common /orderc/ order
 common /errorsc/ errors
 e = 0d0
 if (errors==0) return
 do i=0,nerror
    p = perror(:,i)
    call initialize(0,order)
    funcset(i) = func()
 end do
 p = perror(:,0)
 call initialize(0,order)
 do i=1,nerror
    e = e + (funcset(i) - funcset(0))**2d0
 end do
 e = dsqrt(e)
 return
end function e

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function er(func,arg)
 use master
 implicit none
 integer order,errors,i
 double precision arg,funcset(0:nerror)
 double precision,external::func
 common /orderc/ order
 common /errorsc/ errors
 er = 0d0
 if (errors==0) return
 do i=0,nerror
    p = perror(:,i)
    call initialize(0,order)
    funcset(i) = func(arg)
 end do
 p = perror(:,0)
 call initialize(0,order)
 do i=1,nerror
    er = er + (funcset(i) - funcset(0))**2d0
 end do
 er = dsqrt(er)
 return
end function er

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ei(func,arg)
 use master
 implicit none
 integer order,errors,i,arg
 double precision funcset(0:nerror)
 double precision,external::func
 common /orderc/ order
 common /errorsc/ errors
 ei = 0d0
 if (errors==0) return
 do i=0,nerror
    p = perror(:,i)
    call initialize(0,order)
    funcset(i) = func(arg)
 end do
 p = perror(:,0)
 call initialize(0,order)
 do i=1,nerror
    ei = ei + (funcset(i) - funcset(0))**2d0
 end do
 ei = dsqrt(ei)
 return
end function ei

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function err(func,arg1,arg2)
 use master
 implicit none
 integer order,errors,i
 double precision arg1,arg2,funcset(0:nerror)
 double precision,external::func
 common /orderc/ order
 common /errorsc/ errors
 err = 0d0
 if (errors==0) return
 do i=0,nerror
    p = perror(:,i)
    call initialize(0,order)
    funcset(i) = func(arg1,arg2)
 end do
 p = perror(:,0)
 call initialize(0,order)
 do i=1,nerror
    err = err + (funcset(i) - funcset(0))**2d0
 end do
 err = dsqrt(err)
 return
end function err

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function errr(func,arg1,arg2,arg3)
 use master
 implicit none
 integer order,errors,i
 double precision arg1,arg2,arg3,funcset(0:nerror)
 double precision,external::func
 common /orderc/ order
 common /errorsc/ errors
 errr = 0d0
 if (errors==0) return
 do i=0,nerror
    p = perror(:,i)
    call initialize(0,order)
    funcset(i) = func(arg1,arg2,arg3)
 end do
 p = perror(:,0)
 call initialize(0,order)
 do i=1,nerror
    errr = errr + (funcset(i) - funcset(0))**2d0
 end do
 errr = dsqrt(errr)
 return
end function errr

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function errrr(func,arg1,arg2,arg3,arg4)
 use master
 implicit none
 integer order,errors,i
 double precision arg1,arg2,arg3,arg4,funcset(0:nerror)
 double precision,external::func
 common /orderc/ order
 common /errorsc/ errors
 errrr = 0d0
 if (errors==0) return
 do i=0,nerror
    p = perror(:,i)
    call initialize(0,order)
    funcset(i) = func(arg1,arg2,arg3,arg4)
 end do
 p = perror(:,0)
 call initialize(0,order)
 do i=1,nerror
    errrr = errrr + (funcset(i) - funcset(0))**2d0
 end do
 errrr = dsqrt(errrr)
 return
end function errrr
