!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

module master
 integer,parameter::npara=250,nerror=64
 integer::free(npara)=0
 double precision::p(npara),perror(npara,0:nerror),hp(npara)
end module master

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine setfree
 use master
 implicit none

 free(7)=1

 free(8)=1
 free(9)=1

 free(12)=1
 free(13)=1
 free(14)=1
 free(15)=1

 free(17)=1
 free(18)=1
 free(19)=1
 free(20)=1
 
 free(22)=1
 free(23)=1
 
 free(26)=1
 free(27)=1
 free(28)=1
 free(29)=1
 free(30)=1

 free(31)=1
 free(32)=1
 free(33)=1
 free(34)=1

 free(36)=1
 free(37)=1

 free(41)=1
 free(43)=1

 free(61) = 1
 free(62) = 1
 free(63) = 1
 free(64) = 1
 free(65) = 1

 free(66) = 1
 free(67) = 1
 free(68) = 1
 free(69) = 1
 free(70) = 1

 free(71) = 1

 free(86) = 1

 free(102:105)=1
 free(112:115)=1

 free(122:123)=1
 free(132:133)=1

 free(202:205) = 1
 free(212:215) = 1

 free(222:224) = 1
 free(232:234) = 1

 hp(7) = 0.0001d0

 hp(8) = 0.05d0
 hp(9) = 0.05d0
 hp(12)= 0.002d0
 hp(13)= 0.005d0
 hp(14)= 0.05d0
 hp(15)= 0.05d0
 hp(17)= 0.01d0
 hp(18)= 0.02d0
 hp(19)= 0.05d0
 hp(20)= 0.05d0
 hp(22)= 0.01d0
 hp(23)= 0.1d0
 hp(24)= 0.02d0
 hp(25)= 0.1d0
 hp(26)= 0.002d0
 hp(27)= 0.001d0
 hp(28)= 0.1d0
 hp(29)= 0.05d0
 hp(30)= 0.2d0
 hp(31)= 1d0
 hp(32)= 0.01d0
 hp(33)= 0.5d0
 hp(34)= 1d0
 hp(36)= 0.1d0
 hp(37)= 0.1d0
 hp(41)= 0.01d0
 hp(43)= 1d0

 hp(101:200)= 0.01d0

 hp(58)= 0.5d0
 hp(59)= 0.5d0
 hp(61)= 0.05d0
 hp(62)= 0.03d0
 hp(63)= 0.1d0
 hp(64)= 0.3d0
 hp(65)= 1d0
 hp(66)= 0.05d0
 hp(67)= 0.03d0
 hp(68)= 0.2d0
 hp(69)= 0.5d0
 hp(70)= 1d0
 hp(71)= 0.5d0
 hp(72)= 0.05d0
 hp(73)= 0.1d0 
 hp(75)= 1d0
 hp(76)= 0.01d0
 hp(77)= 0.1d0
 hp(86)= 0.01d0

 hp(201:220)= 0.01d0

 hp(221)= 0.1d0
 hp(222)= 0.1d0
 hp(223)= 0.3d0
 hp(224)= 0.3d0

 hp(231)= 0.1d0
 hp(232)= 0.1d0
 hp(233)= 0.5d0
 hp(234)= 0.5d0

 hp = 0.1d0*hp
end subroutine setfree

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine initialize(inputf,orderf)
 use master
 implicit none
 logical resetPDFs,resetSFs,resetSFCCs,resetPPDFs,resetPSFs
 logical resetPDFsx,resetSFsx,resetSFCCsx,resetPPDFsx,resetPSFsx
 logical::mellin=.false.,gauss=.false.
 integer i,inputf,input,orderf,order,pdfsoform,ppdfsoform
 integer::evolscheme=0,fnscheme=3,fnsfixed=3,errors=0
 double precision Q2o,pQ2o,mW,mZ,mth(4:6),mth2(4:6),pmth2(4:6),pdfsop(8:44),ppdfsop(8:44)
 double precision aso,paso,alphasmZ2,asth(4:6),pasth(4:6)
 double precision,external::as
 double precision dummy,T3g2p,T3g2n
 double precision,dimension(10)::pT4F2p,pT4F2n,pT4FLp,pT4FLn
 double precision,dimension(10)::pT6F2p,pT6F2n,pT6FLp,pT6FLn
 double precision,dimension(10)::pT4g1p,pT4g1n,pT3g2p,pT3g2n
 character*2 file
 common /inputc/ input
 common /orderc/ order
 common /evolschemec/ evolscheme
 common /fnschemec/ fnscheme,fnsfixed
 common /errorsc/ errors
 common /hqmasses/ mth
 common /scalesc/ Q2o,mth2
 common /pscalesc/ pQ2o,pmth2
 common /couplingsc/ aso,asth
 common /pcouplingsc/ paso,pasth
 common /pdfsoc/ pdfsop,pdfsoform
 common /ppdfsoc/ ppdfsop,ppdfsoform
 common /resetPDFsc/ resetPDFs
 common /resetSFsc/ resetSFs
 common /resetSFCCsc/ resetSFCCs
 common /resetPPDFsc/ resetPPDFs
 common /resetPSFsc/ resetPSFs
 common /resetPDFsxc/ resetPDFsx
 common /resetSFsxc/ resetSFsx
 common /resetSFCCsxc/ resetSFCCsx
 common /resetPPDFsxc/ resetPPDFsx
 common /resetPSFsxc/ resetPSFsx
 common /T4F2pc/ pT4F2p
 common /T4F2nc/ pT4F2n
 common /T4FLpc/ pT4FLp
 common /T4FLnc/ pT4FLn
 common /T6F2pc/ pT6F2p
 common /T6F2nc/ pT6F2n
 common /T6FLpc/ pT6FLp
 common /T6FLnc/ pT6FLn
 common /T4g1pc/ pT4g1p
 common /T4g1nc/ pT4g1n
 common /T3g2pc/ pT3g2p
 common /T3g2nc/ pT3g2n
 resetPDFs = .true.
 resetSFs = .true.
 resetSFCCs = .true.
 resetPPDFs = .true.
 resetPSFs = .true.
 resetPDFsx = .true.
 resetSFsx = .true.
 resetSFCCsx = .true.
 resetPPDFsx = .true.
 resetPSFsx = .true.
 input = inputf
 order = orderf
 select case (input)
  case(0:9)
     if(input>0) then
        10 format(2i1)
        write(file,10) input,order
        open(1,file='../../interface/'//file//'.dat')
        select case (errors)
         case(0)
           read(1,*) p
         case(1)
           do i=0,nerror
              read(1,*) perror(:,i)
           end do
           p = perror(:,0)
         case default
            write(6,*) 'INITIALIZE: Bad value of errors = ',errors
            stop
        end select
        close(1)
     end if
     Q2o = p(1)
     mW = p(2)
     mZ = p(3)
     mth(4) = p(4)
     mth(5) = p(5)
     mth(6) = p(6)
     mth2 = mth*mth
     alphasmZ2 = p(7)
     call amatch(order,mth,mZ,alphasmZ2)
     aso = as(Q2o)
     asth = (/as(mth2(4)),as(mth2(5)),as(mth2(6))/)
     if (.not.mellin) then
         call mspace
         call mfactors
         mellin = .true.
     end if
     if (.not.gauss) then
        call wate96
        gauss = .true.
     end if
     if(input==0) then
         p(38:40) = p(28:30)
     end if
     pdfsoform=0
     pdfsop = p(8:44)
     call npdfso
     p(8:44) = pdfsop
     pQ2o = p(50+1)
     pmth2 = mth2
     paso = as(pQ2o)
     pasth = asth
     if(input==0) then
        p(72) = 0.5d0*(p(62) + p(67)) + 1d0
        p(73) = 0.5d0*(p(63) + p(68)) + 2d0
        p(77) = p(62)
        p(82) = p(67)
        p(87) = p(67)
        p(78) = p(73) + 2d0
        p(83) = p(73) + 2d0
        p(88) = p(73) + 2d0
     end if
     ppdfsoform=0
     ppdfsop = p(50+8:50+44)
     call nppdfso
     p(50+8:50+44) = ppdfsop
     call initMGDY
     pT4F2p = p(101:110)
     pT4F2n = p(111:120)
     pT4FLp = p(121:130)
     pT4FLn = p(131:140)
     pT6F2p = p(151:160)
     pT6F2n = p(161:170)
     pT6FLp = p(171:180)
     pT6FLn = p(181:190)
     pT4g1p = p(201:210)
     pT4g1n = p(211:220)
     pT3g2p = p(221:230)
     pT3g2n = p(231:240)
     dummy = T3g2p(0.5d0)
     p(221) = pT3g2p(1)
     pT3g2n = p(231:240)
     dummy = T3g2n(0.5d0)
     p(231) = pT3g2n(1)
  case default
     write(6,*) "INITIALIZATION: Bad value for input =",input
     stop
 end select
 if ((order < 0).or.(order>2)) then
    write(6,*) "INITIALIZATION: Bad value for order =", order
    stop
 end if
 return
end subroutine initialize
