!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function A1p(x,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,gamma2,gp(1:2),g1,g2,F2p,FLp,F2,FL
 external F2p,FLp
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.8803536d0/Q2*x*x
 call pstructurefsp(x,Q2,gp)
 g1 = gp(1)
 g2 = gp(2)
 F2 = F2p(x,Q2)
 FL = FLp(x,Q2)
 A1p = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 tmcflag=0
 return
end function A1p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function A1n(x,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,gamma2,gn(1:2),g1,g2,F2n,FLn,F2,FL
 external F2n,FLn
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.8827831d0/Q2*x*x
 call pstructurefsn(x,Q2,gn)
 g1 = gn(1)
 g2 = gn(2)
 F2 = F2n(x,Q2)
 FL = FLn(x,Q2)
 A1n = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 tmcflag=0
 return
end function A1n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function A1d(x,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,gamma2,gd(1:2),g1,g2,F2d,FLd,F2,FL
 external F2d,FLd
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.881565d0/Q2*x*x
 call pstructurefsd(x,Q2,gd)
 g1 = gd(1)
 g2 = gd(2)
 F2 = 2d0*F2d(x,Q2)
 FL = 2d0*FLd(x,Q2)
 A1d = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 tmcflag=0
 return
end function A1d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function A1He(x,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,gamma2,gHe(1:2),g1,g2,FHe(1:2),F2,FL
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.88116d0/Q2*x*x
 call pstructurefsHe(x,Q2,gHe)
 g1 = gHe(1)
 g2 = gHe(2)
 call structurefsHe(x,Q2,FHe)
 F2 = 3d0*FHe(2)
 FL = 3d0*FHe(1)
 A1He = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 tmcflag=0
 return
end function A1He

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function A2p(x,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,gamma2,gp(1:2),g1,g2,F2p,FLp,F2,FL
 external F2p,FLp
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.8803536d0/Q2*x*x
 call pstructurefsp(x,Q2,gp)
 g1 = gp(1)
 g2 = gp(2)
 F2 = F2p(x,Q2)
 FL = FLp(x,Q2)
 A2p = dsqrt(gamma2)*(g1 + g2)*2d0*x/((1d0+gamma2)*F2-FL)
 tmcflag=0
 return
end function A2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function A2d(x,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,gamma2,gd(1:2),g1,g2,F2d,FLd,F2,FL
 external F2d,FLd
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.8803536d0/Q2*x*x
 call pstructurefsd(x,Q2,gd)
 g1 = gd(1)
 g2 = gd(2)
 F2 = 2d0*F2d(x,Q2)
 FL = 2d0*FLd(x,Q2)
 A2d = dsqrt(gamma2)*(g1 + g2)*2d0*x/((1d0+gamma2)*F2-FL)
 tmcflag=0
 return
end function A2d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function A2He(x,Q2)
 implicit none
 double precision x,Q2,gamma2,gHe(1:2),g1,g2,FHe(1:2),F2,FL
 integer tmcflag
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.88116d0/Q2*x*x
 call pstructurefsHe(x,Q2,gHe)
 g1 = gHe(1)
 g2 = gHe(2)
 call structurefsHe(x,Q2,FHe)
 F2 = 3d0*FHe(2)
 FL = 3d0*FHe(1)
 A2He = dsqrt(gamma2)*(g1 + g2)*2d0*x/((1d0+gamma2)*F2-FL)
 tmcflag=0
 return
end function A2He

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Apap(x,y,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,y,gamma2,R,D,eta,gp(1:2),g1,g2,F2p,FLp,F2,FL,A1,A2
 external F2p,FLp
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.8803536d0/Q2*x*x
 call pstructurefsp(x,Q2,gp)
 g1 = gp(1)
 g2 = gp(2)
 F2 = F2p(x,Q2)
 FL = FLp(x,Q2)
 A1 = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 A2 = dsqrt(gamma2)*(g1 + g2)*2d0*x/((1d0+gamma2)*F2-FL)
 R = FL/((1d0+gamma2)*F2-FL)
 D = (y*(2d0-y)*(1d0+gamma2*y/2d0))/((1d0+gamma2)*y*y+2d0*(1-y-gamma2*y*y/4d0)*(1d0+R))
 eta = dsqrt(gamma2)*(1d0-y-gamma2*y*y/4d0)/(1-y/2d0)/(1d0+gamma2*y/2d0)
 Apap = D*(A1 + eta*A2)
 tmcflag=0
 return
end function Apap

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Apad(x,y,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,y,gamma2,R,D,eta,gd(1:2),g1,g2,F2d,FLd,F2,FL,A1,A2
 external F2d,FLd
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.881565d0/Q2*x*x
 call pstructurefsd(x,Q2,gd)
 g1 = gd(1)
 g2 = gd(2)
 F2 = 2d0*F2d(x,Q2)
 FL = 2d0*FLd(x,Q2)
 A1 = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 A2 = dsqrt(gamma2)*(g1 + g2)*2d0*x/((1d0+gamma2)*F2-FL)
 R = FL/((1d0+gamma2)*F2-FL)
 D = (y*(2d0-y)*(1d0+gamma2*y/2d0))/((1d0+gamma2)*y*y+2d0*(1-y-gamma2*y*y/4d0)*(1d0+R))
 eta = dsqrt(gamma2)*(1d0-y-gamma2*y*y/4d0)/(1-y/2d0)/(1d0+gamma2*y/2d0)
 Apad = D*(A1 + eta*A2)
 tmcflag=0
 return
end function Apad

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ApaHe(x,y,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,y,gamma2,R,D,eta,gHe(1:2),g1,g2,FHe(1:2),F2,FL,A1,A2
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.88116d0/Q2*x*x
 call pstructurefsHe(x,Q2,gHe)
 g1 = gHe(1)
 g2 = gHe(2)
 call structurefsHe(x,Q2,FHe)
 F2 = 3d0*FHe(2)
 FL = 3d0*FHe(1)
 A1 = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 A2 = dsqrt(gamma2)*(g1 + g2)*2d0*x/((1d0+gamma2)*F2-FL)
 R = FL/((1d0+gamma2)*F2-FL)
 D = (y*(2d0-y)*(1d0+gamma2*y/2d0))/((1d0+gamma2)*y*y+2d0*(1-y-gamma2*y*y/4d0)*(1d0+R))
 eta = dsqrt(gamma2)*(1d0-y-gamma2*y*y/4d0)/(1-y/2d0)/(1d0+gamma2*y/2d0)
 ApaHe = D*(A1 + eta*A2)
 tmcflag=0
 return
end function ApaHe

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Apep(x,y,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,y,gamma2,R,D,dsmall,xi,gp(1:2),g1,g2,F2p,FLp,F2,FL,A1,A2
 external F2p,FLp
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.8803536d0/Q2*x*x
 call pstructurefsp(x,Q2,gp)
 g1 = gp(1)
 g2 = gp(2)
 F2 = F2p(x,Q2)
 FL = FLp(x,Q2)
 A1 = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 A2 = dsqrt(gamma2)*(g1 + g2)*2d0*x/((1d0+gamma2)*F2-FL)
 R = FL/((1d0+gamma2)*F2-FL)
 D = (y*(2d0-y)*(1d0+gamma2*y/2d0))/((1d0+gamma2)*y*y+2d0*(1-y-gamma2*y*y/4d0)*(1d0+R))
 dsmall = dsqrt(1d0-y-gamma2*y*y/4d0)*D/(1d0-y/2d0)
 xi = dsqrt(gamma2)*(1d0-y/2d0)/(1d0+gamma2*y/2d0)
 Apep = dsmall*(A2 - xi*A1)
 tmcflag=0
 return
end function Apep

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Aped(x,y,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,y,gamma2,R,D,dsmall,xi,gd(1:2),g1,g2,F2d,FLd,F2,FL,A1,A2
 external F2d,FLd
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.881565d0/Q2*x*x
 call pstructurefsd(x,Q2,gd)
 g1 = gd(1)
 g2 = gd(2)
 F2 = 2d0*F2d(x,Q2)
 FL = 2d0*FLd(x,Q2)
 A1 = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 A2 = dsqrt(gamma2)*(g1 + g2)*2d0*x/((1d0+gamma2)*F2-FL)
 R = FL/((1d0+gamma2)*F2-FL)
 D = (y*(2d0-y)*(1d0+gamma2*y/2d0))/((1d0+gamma2)*y*y+2d0*(1-y-gamma2*y*y/4d0)*(1d0+R))
 dsmall = dsqrt(1d0-y-gamma2*y*y/4d0)*D/(1d0-y/2d0)
 xi = dsqrt(gamma2)*(1d0-y/2d0)/(1d0+gamma2*y/2d0)
 Aped = dsmall*(A2 - xi*A1)
 tmcflag=0
 return
end function Aped

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ApeHe(x,y,Q2)
 implicit none
 integer tmcflag
 double precision x,Q2,y,gamma2,R,D,dsmall,xi,gHe(1:2),g1,g2,FHe(1:2),F2,FL,A1,A2
 common /tmcc/ tmcflag
 tmcflag=3
 gamma2 = 4d0*0.88116d0/Q2*x*x
 call pstructurefsHe(x,Q2,gHe)
 g1 = gHe(1)
 g2 = gHe(2)
 call structurefsHe(x,Q2,FHe)
 F2 = 3d0*FHe(2)
 FL = 3d0*FHe(1)
 A1 = (g1 - gamma2*g2)*2d0*x/((1d0+gamma2)*F2-FL)
 A2 = dsqrt(gamma2)*(g1 + g2)*2d0*x/((1d0+gamma2)*F2-FL)
 R = FL/((1d0+gamma2)*F2-FL)
 D = (y*(2d0-y)*(1d0+gamma2*y/2d0))/((1d0+gamma2)*y*y+2d0*(1-y-gamma2*y*y/4d0)*(1d0+R))
 dsmall = dsqrt(1d0-y-gamma2*y*y/4d0)*D/(1d0-y/2d0)
 xi = dsqrt(gamma2)*(1d0-y/2d0)/(1d0+gamma2*y/2d0)
 ApeHe = dsmall*(A2 - xi*A1)
 tmcflag=0
 return
end function ApeHe

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ApeE155xp(x,y,Q2)
 implicit none
 integer tmcflag
 double precision,parameter::alpha=92.4d0/90d0*acos(-1d0)/2d0,cosPhi=1d0
 double precision x,Q2,y,gamma2,nu,E,Eprime,theta,eps,cosTheta,R,gp(1:2),g1,g2,F2,FL,F1
 double precision,external::F2p,FLp
 common /tmcc/ tmcflag
 tmcflag=3
 nu = Q2/2d0/0.938272d0/x
 E = nu/y
 Eprime = E - nu
 theta = 2d0*dasin(dsqrt(Q2/4d0/E/Eprime))
 gamma2 = Q2/nu/nu
 eps = 1d0/(1d0 + 2d0*(1d0 + 1d0/gamma2)*(dtan(theta/2d0))**2d0)
 cosTheta = dsin(alpha)*dsin(theta)*cosPhi + dcos(alpha)*dcos(theta)
 call pstructurefsp(x,Q2,gp)
 g1 = gp(1)
 g2 = gp(2)
 F2 = F2p(x,Q2)
 FL = FLp(x,Q2)
 R = FL/((1d0+gamma2)*F2-FL)
 F1 = FL/2d0/x/R
 ApeE155xp = (1d0 - eps)/nu/(1d0+eps*R)*(2d0*Eprime*(cosTheta - dcos(alpha))*g2 + (E*dcos(alpha) + Eprime*cosTheta)*y*g1)/y/F1
 tmcflag=0
 return
end function ApeE155xp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ApeE155xd(x,y,Q2)
 implicit none
 integer tmcflag
 double precision,parameter::alpha=92.4d0/90d0*acos(-1d0)/2d0,cosPhi=1d0
 double precision x,Q2,y,gamma2,nu,E,Eprime,theta,eps,cosTheta,R,gd(1:2),g1,g2,F2,FL,F1
 double precision,external::F2d,FLd
 common /tmcc/ tmcflag
 tmcflag=3
 nu = Q2/2d0/0.93891805d0/x
 E = nu/y
 Eprime = E - nu
 theta = 2d0*dasin(dsqrt(Q2/4d0/E/Eprime))
 gamma2 = Q2/nu/nu
 eps = 1d0/(1d0 + 2d0*(1d0 + 1d0/gamma2)*(dtan(theta/2d0))**2d0)
 cosTheta = dsin(alpha)*dsin(theta)*cosPhi + dcos(alpha)*dcos(theta)
 call pstructurefsd(x,Q2,gd)
 g1 = gd(1)
 g2 = gd(2)
 F2 = 2d0*F2d(x,Q2)
 FL = 2d0*FLd(x,Q2)
 R = FL/((1d0+gamma2)*F2-FL)
 F1 = FL/2d0/x/R
 ApeE155xd = (1d0 - eps)/nu/(1d0+eps*R)*(2d0*Eprime*(cosTheta - dcos(alpha))*g2 + (E*dcos(alpha) + Eprime*cosTheta)*y*g1)/y/F1
 tmcflag=0
 return
end function ApeE155xd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine pstructurefsp(x,Q2,gp)
 implicit none
 double precision x,Q2,g(-2:2),gp(1:2)
 double precision,external::T3g1p,T4g1p,T3g2p
 call pstructurefs(x,Q2,g)
 gp(1) = g(1) + T3g1p(x,Q2) +  T4g1p(x)/Q2
 gp(2) = g(2) + T3g2p(x)
 return
end subroutine pstructurefsp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine pstructurefsn(x,Q2,gn)
 implicit none
 double precision x,Q2,g(-2:2),gn(1:2)
 double precision,external::T3g1n,T4g1n,T3g2n
 call pstructurefs(x,Q2,g)
 gn(1) = g(-1) + T3g1n(x,Q2) +  T4g1n(x)/Q2
 gn(2) = g(-2) + T3g2n(x)
 return
end subroutine pstructurefsn

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine pstructurefsd(x,Q2,gd)
 implicit none
 logical::nuclear=.true.
 double precision,parameter::wd=0.06d0
 double precision x,Q2,g(-2:2),gd(1:2)
 double precision,external::T3g1d,T4g1d,T3g2d
 if(nuclear) then
    call deuteronPSF(x,Q2,gd)
 else
    call pstructurefs(x,Q2,g)
    gd(1) = (1d0-1.5d0*wd)*(g(1) + g(-1) + T3g1d(x,Q2) +  T4g1d(x)/Q2)
    gd(2) = (1d0-1.5d0*wd)*(g(2) + g(-2) + T3g2d(x))
 end if
 return
end subroutine pstructurefsd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine pstructurefsHe(x,Q2,gHe)
 implicit none
 logical::nuclear=.true.
 double precision,parameter::Pn=0.86d0,Pp=-0.059d0
 double precision x,Q2,g(-2:2),gHe(1:2)
 double precision,external::T3g1p,T4g1p,T3g2p
 double precision,external::T3g1n,T4g1n,T3g2n
 if(nuclear) then
    call heliumPSF(x,Q2,gHe)
 else
    call pstructurefs(x,Q2,g)
    gHe(1) = Pp*(g(1) + T3g1p(x,Q2) +  T4g1p(x)/Q2) + Pn*(g(-1) + T3g1n(x,Q2) +  T4g1n(x)/Q2)
    gHe(2) = Pp*(g(2) + T3g2p(x)) + Pn*(g(-2) + T3g2n(x))
 end if
 return
end subroutine pstructurefsHe

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigpl(beam,x,y,E,aceptance)
 implicit none
 integer order,beam
 double precision::x,y,E,aceptance,sigCCCnu,Bc=0.099d0,GF=1.16637d-5,pbarn=0.389379304d9,mN=0.938955d0
 external sigCCCnu
 common /orderc/ order
 sigpl = dacos(-1d0)/GF/GF/mN/E/pbarn*aceptance*Bc*sigCCCnu(beam,x,y,E)
 return
end function sigpl

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigCCCnu(beam,x,y,E)
 integer beam,hadron,boson,order,orderl
 double precision,parameter::mN=0.938955d0,pi=dacos(-1d0),pbarn=0.3893793d9
 double precision,parameter::MW=80.399d0,MW2=MW*MW,GF=1.16637d-5,GF2=GF*GF
 double precision x,y,E,Q2,mth(4:6),Yp,Ym,FT,F2,FL,xF3
 double precision mheavy,FCCcharm
 external FCCcharm
 common /orderc/ order
 common /hqmasses/ mth
 hadron = 50
 boson = beam
 orderl = order
 if (order==2) orderl=1
 mheavy = mth(4)
 Yp=1d0+(1d0-y)*(1d0-y)
 Ym=1d0-(1d0-y)*(1d0-y)
 Q2=2d0*E*mN*x*y
 FT = FCCcharm(1,hadron,boson,orderl,mheavy,x,Q2)
 F2 = FCCcharm(2,hadron,boson,orderl,mheavy,x,Q2)
 FL = F2-FT
 xF3 = x*FCCcharm(3,hadron,boson,orderl,mheavy,x,Q2)
 sigCCCnu = (Yp*F2 - y*y*FL + beam*Ym*xF3)/2d0
 sigCCCnu = GF2*Q2/2d0/pi/x/y*(MW2/(MW2+Q2))**2d0*pbarn*sigCCCnu
 return
end function sigCCCnu

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigrCCp(x,y,Q2)
 implicit none
 integer order,fnscheme,fnsfixed
 double precision x,Q2,y,Yp,Ym,F(-3:3),sigrCCCep
 external sigrCCCep
 common /fnschemec/ fnscheme,fnsfixed
 common /orderc/ order
 if((abs(x)>1).or.(abs(y)>1)) then
    sigrCCp = 0d0
    sigrCCp = sigrCCp/0d0
    return
 end if
 Yp=1d0+(1d0-y)*(1d0-y)
 Ym=1d0-(1d0-y)*(1d0-y)
 select case (fnscheme)
  case(3)
     call structurefscc(x,Q2,F)
     sigrCCp = (Yp*F(2) - y*y*F(1) - Ym*F(3))/4d0
     sigrCCp = sigrCCp + sigrCCCep(1,x,y,Q2)
  case default
     write(6,*) 'SIGMARP: Bad value of fnscheme = ',fnscheme
     stop
 end select
 return
end function sigrCCp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigrCCm(x,y,Q2)
 implicit none
 integer order,fnscheme,fnsfixed
 double precision x,Q2,y,Yp,Ym,F(-3:3),sigrCCCep
 external sigrCCCep
 common /fnschemec/ fnscheme,fnsfixed
 common /orderc/ order
 if((abs(x)>1).or.(abs(y)>1)) then
    sigrCCm = 0d0
    sigrCCm = sigrCCm/0d0
    return
 end if
 Yp=1d0+(1d0-y)*(1d0-y)
 Ym=1d0-(1d0-y)*(1d0-y)
 select case (fnscheme)
  case(3)
     call structurefscc(x,Q2,F)
     sigrCCm = (Yp*F(-2) - y*y*F(-1) + Ym*x*F(-3))/4d0
     sigrCCm = sigrCCm + sigrCCCep(-1,x,y,Q2)
  case default
     write(6,*) 'SIGMARP: Bad value of fnscheme = ',fnscheme
     stop
 end select
 return
end function sigrCCm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigrCCCep(beam,x,y,Q2)
 integer beam,hadron,boson,order,orderl
 double precision x,y,Q2,mth(4:6),Yp,Ym,FT,F2,FL,xF3
 double precision mheavy,FCCcharm
 external FCCcharm
 common /orderc/ order
 common /hqmasses/ mth
 hadron = 1
 boson = beam
 orderl = order
 if (order==2) orderl=1
 mheavy = mth(4)
 Yp=1d0+(1d0-y)*(1d0-y)
 Ym=1d0-(1d0-y)*(1d0-y)
 FT = FCCcharm(1,hadron,boson,orderl,mheavy,x,Q2)
 F2 = FCCcharm(2,hadron,boson,orderl,mheavy,x,Q2)
 FL = F2-FT
 xF3 = x*FCCcharm(3,hadron,boson,orderl,mheavy,x,Q2)
 sigrCCCep = (Yp*F2 - y*y*FL - beam*Ym*xF3)/4d0
 return
end function sigrCCCep

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigrNCp(x,y,Q2)
 implicit none
 integer fnscheme,fnsfixed,tmcflag,nccflag
 double precision x,Q2,y,Yp,Ym,F(-3:3)
 double precision,external::F2NCpc,F2NCpb,FLNCpc,FLNCpb,T4F2p,T4FLp,T6F2p,T6FLp
 common /fnschemec/ fnscheme,fnsfixed
 common /tmcc/ tmcflag
 common /nccflagc/ nccflag
 nccflag=1
 tmcflag=3
 if((abs(x)>1).or.(abs(y)>1)) then
    sigrNCp = 0d0
    sigrNCp = sigrNCp/0d0
    return
 end if
 Yp=1d0+(1d0-y)*(1d0-y)+2d0*x*x*y*y*0.88035d0/Q2
 Ym=1d0-(1d0-y)*(1d0-y)
 select case (fnscheme)
  case(3)
     call structurefs(x,Q2,F)
     sigrNCp = F(2) + F2NCpc(x,Q2) + F2NCpb(x,Q2) + T4F2p(x)/Q2 + T6F2p(x)/Q2/Q2
     sigrNCp = sigrNCp - y*y/Yp*(F(1) + FLNCpc(x,Q2) + FLNCpb(x,Q2) + T4FLp(x)/Q2 + T6FLp(x)/Q2/Q2)
     sigrNCp = sigrNCp - Ym/Yp*F(3)
  case(5)
     call structurefs(x,Q2,F)
     sigrNCp =  F(2) - y*y/Yp*F(1) - Ym/Yp*F(3)
  case default
     write(6,*) 'SIGMARP: Bad value of fnscheme = ',fnscheme
     stop
 end select
 nccflag=0
 tmcflag=0
 return
end function sigrNCp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigrNCm(x,y,Q2)
 implicit none
 integer fnscheme,fnsfixed,tmcflag,nccflag
 double precision x,Q2,y,Yp,Ym,F(-3:3)
 double precision,external::F2NCpc,F2NCpb,FLNCpc,FLNCpb,T4F2p,T4FLp,T6F2p,T6FLp
 common /fnschemec/ fnscheme,fnsfixed
 common /tmcc/ tmcflag
 common /nccflagc/ nccflag
 nccflag=1
 tmcflag=3
 if((abs(x)>1).or.(abs(y)>1)) then
    sigrNCm = 0d0
    sigrNCm = sigrNCm/0d0
    return
 end if
 Yp=1d0+(1d0-y)*(1d0-y)+2d0*x*x*y*y*0.88035d0/Q2
 Ym=1d0-(1d0-y)*(1d0-y)
 select case (fnscheme)
  case(3)
     call structurefs(x,Q2,F)
     sigrNCm = (F(2) + F2NCpc(x,Q2) + F2NCpb(x,Q2)) + T4F2p(x)/Q2 + T6F2p(x)/Q2/Q2
     sigrNCm = sigrNCm - y*y/Yp*(F(1) + FLNCpc(x,Q2) + FLNCpb(x,Q2) + T4FLp(x)/Q2 + T6FLp(x)/Q2/Q2)
     sigrNCm = sigrNCm + Ym/Yp*F(3)
  case(5)
     call structurefs(x,Q2,F)
     sigrNCm =  F(2) - y*y/Yp*F(1) + Ym/Yp*F(3)
  case default
     write(6,*) 'SIGMARM: Bad value of fnscheme = ',fnscheme
     stop
 end select
 nccflag=0
 tmcflag=0
 return
end function sigrNCm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigdp(x,y,Q2)
 implicit none
 double precision x,y,Q2,sigFTd,sigFTp
 external sigFTd,sigFTp
 sigdp = sigFTd(x,y,Q2)/sigFTp(x,y,Q2)
 return
end function sigdp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigFTp(x,y,Q2)
 implicit none
 double precision x,y,Q2,F2p,FLp
 external F2p,FLp
 sigFTp = 0.5d0*((1d0+(1d0-y)**2d0+2d0*x*x*y*y*0.88035d0/Q2)*F2p(x,Q2) - y*y*FLp(x,Q2))
 return
end function sigFTp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigFTd(x,y,Q2)
 implicit none
 double precision x,y,Q2,F2d,FLd
 external F2d,FLd
 sigFTd = 0.5d0*((1d0+(1d0-y)**2d0+2d0*x*x*y*y*0.881565d0/Q2)*F2d(x,Q2) - y*y*FLd(x,Q2))
 return
end function sigFTd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Rp(x,Q2)
 implicit none
 double precision x,Q2,F2p,FLp,F2l,FLl
 external F2p,FLp
 F2l = F2p(x,Q2)
 FLl = FLp(x,Q2)
 Rp = FLl/((1d0+4d0*x*x*0.88035d0/Q2)*F2l-FLl)
 return
end function Rp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Rd(x,Q2)
 implicit none
 double precision x,Q2,F2d,FLd,F2l,FLl
 external F2d,FLd
 F2l = F2d(x,Q2)
 FLl = FLd(x,Q2)
 Rd = FLl/((1d0+4d0*x*x*0.881565d0/Q2)*F2l-FLl)
 return
end function Rd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2dpn(x,Q2)
 implicit none
 double precision x,Q2,F2d,F2p,F2n
 external F2d,F2p,F2n
 F2dpn = 2d0*F2d(x,Q2)/(F2p(x,Q2) + F2n(x,Q2))
 return
end function F2dpn

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2np(x,Q2)
 implicit none
 double precision x,Q2,F2dp
 external F2dp
 F2np = 2d0*F2dp(x,Q2)-1d0
 return
end function F2np

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2dp(x,Q2)
 implicit none
 double precision x,Q2,F2d,F2p
 external F2d,F2p
 F2dp = F2d(x,Q2)/F2p(x,Q2)
 return
end function F2dp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2d(x,Q2)
 implicit none
 logical::nuclear=.true.
 double precision x,Q2
 double precision,external::F2de,F2dc,F2db
 if(nuclear) then
    call deuteronF2(x,Q2,F2d)
 else
    F2d = F2de(x,Q2)
 end if
 F2d = F2d + F2dc(x,Q2) + F2db(x,Q2)
 return
end function F2d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2de(x,Q2)
 implicit none
 integer tmcflag,nccflag
 double precision x,Q2,F(-3:3)
 double precision,external::T4F2d,T6F2d
 common /tmcc/ tmcflag
 common /nccflagc/ nccflag
 nccflag=0
 tmcflag=3
 call structurefs(x,Q2,F)
 F2de = (F(2) + F(-2))/2d0
 nccflag=0
 tmcflag=0
 F2de = F2de + T4F2d(x)/Q2 + T6F2d(x)/Q2/Q2
 return
end function F2de

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLd(x,Q2)
 implicit none
 logical::nuclear=.true.
 double precision x,Q2
 double precision,external::FLde,FLdc,FLdb
 if(nuclear) then
    call deuteronFL(x,Q2,FLd)
 else
    FLd = FLde(x,Q2)
 end if
 FLd = FLd + FLdc(x,Q2) + FLdb(x,Q2)
 return
end function FLd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLde(x,Q2)
 implicit none
 integer tmcflag,nccflag
 double precision x,Q2,F(-3:3)
 double precision,external::T4FLd,T6FLd
 common /tmcc/ tmcflag
 common /nccflagc/ nccflag
 nccflag=0
 tmcflag=3
 call structurefs(x,Q2,F)
 FLde = (F(1) + F(-1))/2d0
 nccflag=0
 tmcflag=0
 FLde = FLde + T4FLd(x)/Q2 + T6FLd(x)/Q2/Q2
 return
end function FLde

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine structurefsHe(x,Q2,FHe)
 implicit none
 logical::nuclear=.true.
 double precision x,Q2,FHe(1:2)
 double precision,external::F2Hec,F2Heb,FLHec,FLHeb
 if (nuclear) then
    call heliumSF(x,Q2,FHe)
 else
    call structurefsHe3(x,Q2,FHe)
 end if
 FHe(1) = FHe(1) + FLHec(x,Q2) + FLHeb(x,Q2)
 FHe(2) = FHe(2) + F2Hec(x,Q2) + F2Heb(x,Q2)
 return
end subroutine structurefsHe

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine structurefsHe3(x,Q2,FHe3)
 implicit none
 integer tmcflag,nccflag
 double precision x,Q2,FHe3(1:2),F(-3:3)
 double precision,external::T4F2He,T6F2He,T4FLHe,T6FLHe
 common /tmcc/ tmcflag
 common /nccflagc/ nccflag
 nccflag=0
 tmcflag=3
 call structurefs(x,Q2,F)
 FHe3(1) = (2d0*F(1) + F(-1))/3d0
 FHe3(2) = (2d0*F(2) + F(-2))/3d0
 nccflag=0
 tmcflag=0
 FHe3(1) = FHe3(1) + T4FLHe(x)/Q2 + T6FLHe(x)/Q2/Q2
 FHe3(2) = FHe3(2) + T4F2He(x)/Q2 + T6F2He(x)/Q2/Q2
 return
end subroutine structurefsHe3

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2p(x,Q2)
 implicit none
 integer fnscheme,fnsfixed,tmcflag,nccflag
 double precision x,Q2,F(-3:3)
 double precision,external::F2pc,F2pb,T4F2p,T6F2p
 common /fnschemec/ fnscheme,fnsfixed
 common /tmcc/ tmcflag
 common /nccflagc/ nccflag
 nccflag=0
 tmcflag=3
 select case (fnscheme)
  case(3)
     call structurefs(x,Q2,F)
     F2p = F(2) + F2pc(x,Q2) + F2pb(x,Q2)
  case(5)
     call structurefs(x,Q2,F)
     F2p = F(2)
  case default
     write(6,*) 'F2p: Bad value of fnscheme = ',fnscheme
     stop
 end select
 nccflag=0
 tmcflag=0
 F2p = F2p + T4F2p(x)/Q2 + T6F2p(x)/Q2/Q2
 return
end function F2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLp(x,Q2)
 implicit none
 integer fnscheme,fnsfixed,tmcflag,nccflag
 double precision x,Q2,F(-3:3)
 double precision,external::FLpc,FLpb,T4FLp,T6FLp
 common /fnschemec/ fnscheme,fnsfixed
 common /tmcc/ tmcflag
 common /nccflagc/ nccflag
 nccflag=0
 tmcflag=3
 select case (fnscheme)
  case(3)
     call structurefs(x,Q2,F)
     FLp = F(1) + FLpc(x,Q2) + FLpb(x,Q2)
  case(5)
     call structurefs(x,Q2,F)
     FLp = F(1)
  case default
     write(6,*) 'FLp: Bad value of fnscheme = ',fnscheme
     stop
 end select
 nccflag=0
 tmcflag=0
 FLp = FLp + T4FLp(x)/Q2 + T6FLp(x)/Q2/Q2
 return
end function FLp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2n(x,Q2)
 implicit none
 integer fnscheme,fnsfixed,tmcflag,nccflag
 double precision x,Q2,F(-3:3)
 double precision,external::F2nc,F2nb,T4F2n,T6F2n
 common /fnschemec/ fnscheme,fnsfixed
 common /tmcc/ tmcflag
 common /nccflagc/ nccflag
 nccflag=0
 tmcflag=3
 select case (fnscheme)
  case(3)
     call structurefs(x,Q2,F)
     F2n = F(-2) + F2nc(x,Q2) + F2nb(x,Q2)
  case(5)
     call structurefs(x,Q2,F)
     F2n = F(-2)
  case default
     write(6,*) 'F2n: Bad value of fnscheme = ',fnscheme
     stop
 end select
 nccflag=0
 tmcflag=0
 F2n = F2n + T4F2n(x)/Q2 + T6F2n(x)/Q2/Q2
 return
end function F2n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLn(x,Q2)
 implicit none
 integer fnscheme,fnsfixed,tmcflag,nccflag
 double precision x,Q2,F(-3:3)
 double precision,external::FLnc,FLnb,T4FLn,T6FLn
 common /fnschemec/ fnscheme,fnsfixed
 common /tmcc/ tmcflag
 common /nccflagc/ nccflag
 nccflag=0
 tmcflag=3
 select case (fnscheme)
  case(3)
     call structurefs(x,Q2,F)
     FLn = F(-1) + FLnc(x,Q2) + FLnb(x,Q2)
  case(5)
     call structurefs(x,Q2,F)
     FLn = F(-1)
  case default
     write(6,*) 'FLn: Bad value of fnscheme = ',fnscheme
     stop
 end select
 nccflag=0
 tmcflag=0
 FLn = FLn + T4FLn(x)/Q2 + T6FLn(x)/Q2/Q2
 return
end function FLn

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function sigrc(x,y,Q2)
 implicit none
 integer nccflag
 double precision x,Q2,y,Yp
 double precision,external::F2pc,FLpc
 common /nccflagc/ nccflag
 nccflag=0
 if((abs(x)>1).or.(abs(y)>1)) then
    sigrc = 0d0
    sigrc = sigrc/0d0
    return
 end if
 Yp=1d0+(1d0-y)*(1d0-y)+2d0*x*x*y*y*0.88035d0/Q2
 sigrc = F2pc(x,Q2) - y*y/Yp*FLpc(x,Q2)
 nccflag=0
 return
end function sigrc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2pc(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2pc = Fhq(2,1,4,0,x,Q2)
 return
end function F2pc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2pb(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2pb = Fhq(2,1,5,0,x,Q2)
 return
end function F2pb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLpc(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLpc = Fhq(1,1,4,0,x,Q2)
 return
end function FLpc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLpb(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLpb = Fhq(1,1,5,0,x,Q2)
 return
end function FLpb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2nc(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2nc = Fhq(2,-1,4,0,x,Q2)
 return
end function F2nc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2nb(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2nb = Fhq(2,-1,5,0,x,Q2)
 return
end function F2nb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLnc(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLnc = Fhq(1,-1,4,0,x,Q2)
 return
end function FLnc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLnb(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLnb = Fhq(1,-1,5,0,x,Q2)
 return
end function FLnb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2dc(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2dc = Fhq(2,2,4,0,x,Q2)
 return
end function F2dc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2db(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2db = Fhq(2,2,5,0,x,Q2)
 return
end function F2db

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLdc(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLdc = Fhq(1,2,4,0,x,Q2)
 return
end function FLdc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLdb(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLdb = Fhq(1,2,5,0,x,Q2)
 return
end function FLdb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2Hec(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2Hec = Fhq(2,3,4,0,x,Q2)
 return
end function F2Hec

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2Heb(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2Heb = Fhq(2,3,5,0,x,Q2)
 return
end function F2Heb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLHec(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLHec = Fhq(1,3,4,0,x,Q2)
 return
end function FLHec

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLHeb(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLHeb = Fhq(1,3,5,0,x,Q2)
 return
end function FLHeb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2Fec(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2Fec = Fhq(2,56,4,0,x,Q2)
 return
end function F2Fec

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2NCpc(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2NCpc = Fhq(2,1,4,1,x,Q2)
 return
end function F2NCpc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function F2NCpb(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 F2NCpb = Fhq(2,1,5,1,x,Q2)
 return
end function F2NCpb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLNCpc(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLNCpc = Fhq(1,1,4,1,x,Q2)
 return
end function FLNCpc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function FLNCpb(x,Q2)
 implicit none
 double precision Fhq,x,Q2
 external Fhq
 FLNCpb = Fhq(1,1,5,1,x,Q2)
 return
end function FLNCpb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Fhq(nfunction,hadron,nq,nccflagl,xl,Q2l)
 implicit none
 integer nfunction,hadron,nq,order,fnscheme,fnsfixed,nccflag,nccflagl
 double precision xl,Q2l,Fheavy,F(2,4:5),mth(4:6),mpole,mheavy
 external Fheavy,mpole
 common /orderc/ order
 common /fnschemec/ fnscheme,fnsfixed
 common /nccflagc/ nccflag
 common /hqmasses/ mth
 nccflag=nccflagl
 select case(fnscheme)
  case(3)
     mheavy = mth(nq)
     Fhq = Fheavy(nfunction,hadron,nq,nccflag,order,mheavy,xl,Q2l)
  case(5)
     call heavfs(xl,Q2l,F)
     Fhq = F(nfunction,nq)
  case default
     write(6,*) 'FHQ: Bad value of fnscheme = ',fnscheme
     stop
  end select
 nccflag=0
 return
end function Fhq

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ADY(x1,x2,m2)
 implicit none
 double precision x1,x2,m2,DYppl,DYpnl,DYpp,DYpn
 external DYpd,DYpp
 DYppl = DYpp(x1,x2,m2)
 DYpnl = DYpn(x1,x2,m2)
 ADY = (DYppl-DYpnl)/(DYppl+DYpnl)
 return
end function ADY

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function DYd2p(x1,x2,m2)
 implicit none
 double precision x1,x2,m2,DYpd,DYpp
 external DYpd,DYpp
 DYd2p = DYpd(x1,x2,m2)/DYpp(x1,x2,m2)
 return
end function DYd2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function DYpp(x1,x2,m2)
 implicit none
 integer order
 double precision x1,x2,m2,DYdMdxF
 external DYdMdxF
 common /orderc/ order
 DYpp = DYdMdxF(1,order,x1,x2,m2)
 return
end function DYpp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function DYpn(x1,x2,m2)
 implicit none
 integer order
 double precision x1,x2,m2,DYdMdxF
 external DYdMdxF
 common /orderc/ order
 DYpn = DYdMdxF(2,order,x1,x2,m2)
 return
end function DYpn

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function DYpd(x1,x2,m2)
 implicit none
 integer order
 double precision x1,x2,m2,DYdMdxF
 external DYdMdxF
 common /orderc/ order
 DYpd = DYdMdxF(3,order,x1,x2,m2)
 return
end function DYpd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function DYpCu(x1,x2,m2)
 implicit none
 integer order
 double precision x1,x2,m2,DYdMdxF
 external DYdMdxF
 common /orderc/ order
 DYpCu = DYdMdxF(4,order,x1,x2,m2)
 return
end function DYpCu

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine fastNLO(jetset,m,output)
       implicit none
       integer::jetset,m,orderl
       double precision::output(m)
       double precision::xst1001(33,3),xst1002(90,3),xst2002(20,3)
       double precision::xsh2001(30,3),xsh2003(24,3)
       double precision::xst2007(77,3),xst2009(110,3)
       common /orderc/ orderl
       select case(jetset)
        case(1)!fnt1001: hep-ph/0102074 - Run I CDF incl. jets (ET)
           if(m/=33) then
              write(6,*) "fastNLO: Bad value for m", m
              stop
           end if
           call FT1001CC('../../code/fastNLO/fnt1001midp.tab',1.0d0,1.0d0,0,XST1001)
           output = XST1001(:,1)
           if(orderl>=1) output = output + XST1001(:,2)
           if(orderl>=2) output = output + XST1001(:,3)
        case(2)!fnt1002: hep-ex/0011036 - Run I D0 incl. jets (ET, eta)
           if(m/=90) then
              write(6,*) "fastNLO: Bad value for m", m
              stop
           end if
           call FT1002CC('../../code/fastNLO/fnt1002midp.tab',1.0d0,1.0d0,0,XST1002)
           output = XST1002(:,1)
           if(orderl>=1) output = output + XST1002(:,2)
           if(orderl>=2) output = output + XST1002(:,3)
        case(3)!fnt2002: hep-ex/0512020 - Run II CDF incl. jets cone (pT)
           if(m/=20) then
              write(6,*) "fastNLO: Bad value for m", m
              stop
           end if
           call FT2002CC('../../code/fastNLO/fnt2002midp.tab',1.0d0,1.0d0,0,XST2002)
           output = XST2002(:,1)
           if(orderl>=1) output = output + XST2002(:,2)
           if(orderl>=2) output = output + XST2002(:,3)
        case(4)!fnh2001: S. Chekanov et al., Nucl. Phys. B765 (2007) 1 - ZEUS
           if(m/=30) then
              write(6,*) "fastNLO: Bad value for m", m
              stop
           end if
           call FH2001CC('../../code/fastNLO/fnh2001.tab',1.0d0,1.0d0,0,XSH2001)
           output = XSH2001(:,1)
           if(orderl>=1) output = output + XSH2001(:,2)
        case(5)!fnh2003: A. Aktas et al., Phys. Lett. B653 (2007) 134 - H1
           if(m/=24) then
              write(6,*) "fastNLO: Bad value for m", m
              stop
           end if
           call FH2003CC('../../code/fastNLO/fnh2003.tab',1.0d0,1.0d0,0,XSH2003)
           output = XSH2003(:,1)
           if(orderl>=1) output = output + XSH2003(:,2)
        case(6)!fnt2007: T. Aaltonen et al., Phys. Rev. D78 (2008) 052006 - CDF
           if(m/=77) then
              write(6,*) "fastNLO: Bad value for m", m
              stop
           end if
           call FT2007CC('../../code/fastNLO/fnt2007midp.tab',1.0d0,1.0d0,0,XST2007)
           output = XST2007(:,1)
           if(orderl>=1) output = output + XST2007(:,2)
           if(orderl>=2) output = output + XST2007(:,3)
        case(7)!fnt2009: V. M. Abazov et al., Phys. Rev. Lett. 101 (2008) 062001 - D0
           if(m/=110) then
              write(6,*) "fastNLO: Bad value for m", m
              stop
           end if
           call FT2009CC('../../code/fastNLO/fnt2009midp.tab',1.0d0,1.0d0,0,XST2009)
           output = XST2009(:,1)
           if(orderl>=1) output = output + XST2009(:,2)
           if(orderl>=2) output = output + XST2009(:,3)
        case default
          write(6,*) "fastNLO: Bad value for jetset",jetset
          stop
        end select
       return
      end subroutine fastNLO
