!PJD! CERNLIB F011 (only some of them): Repeated Solution of Linear Equations, Matrix Inversion, Determinant

          SUBROUTINE          DFINV(N,A,IDIM,IR)
          INTEGER             IR(*)
          DOUBLE PRECISION    A(IDIM,*),ZERO,     X, Y, TI
          DOUBLE PRECISION    S31, S32, S33, S34, DOTF
          DOTF(X,Y,S31)  =  X*Y + S31
          DATA      ZERO      /  0.D0  /
          IF(IDIM .GE. N  .AND.  N .GT. 0)  GOTO 310
             write(*,*) "DFINV: Problems with the dimensions",N,IDIM
             stop
 310      IF(N .EQ. 1)  RETURN
          A(2,1)  =  -A(2,2) * DOTF(A(1,1),A(2,1),ZERO)
          A(1,2)  =  -A(1,2)
          IF(N .EQ. 2)  GOTO 330
          DO 314    I  =  3, N
             IM2  =  I-2
             DO 312 J  =  1, IM2
                S31  =  ZERO
                S32  =  A(J,I)
                DO 311  K  =  J, IM2
                   S31  =  DOTF(A(K,J),A(I,K),S31)
                   S32  =  DOTF(A(J,K+1),A(K+1,I),S32)
 311               CONTINUE
                A(I,J)  =  -A(I,I) * DOTF(A(I-1,J),A(I,I-1),S31)
                A(J,I)  =  -S32
 312            CONTINUE
             A(I,I-1)  =  -A(I,I) * DOTF(A(I-1,I-1),A(I,I-1),ZERO)
             A(I-1,I)  =  -A(I-1,I)
 314         CONTINUE
 330      NM1  =  N-1
          DO 335   I  =  1, NM1
             NMI  =  N-I
             DO 332   J  =  1, I
                S33  =  A(I,J)
                DO 331   K  =  1, NMI
                   S33  =  DOTF(A(I+K,J),A(I,I+K),S33)
 331               CONTINUE
                A(I,J)  =  S33
 332            CONTINUE
             DO 334   J  =  1, NMI
                S34  =  ZERO
                DO 333   K  =  J, NMI
                   S34  =  DOTF(A(I+K,I+J),A(I,I+K),S34)
 333               CONTINUE
                A(I,I+J)  =  S34
 334            CONTINUE
 335         CONTINUE
          NXCH  =  IR(N)
          IF(NXCH .EQ. 0)  RETURN
            DO 342 M  =  1, NXCH
             K   =  NXCH - M+1
             IJ  =  IR(K)
             I   =  IJ / 4096
             J   =  MOD(IJ,4096)
             DO 341  K  =  1, N
                TI      =  A(K,I)
                A(K,I)  =  A(K,J)
                A(K,J)  =  TI
 341            CONTINUE
 342         CONTINUE
          RETURN
          END

          SUBROUTINE          DFACT(N,A,IDIM,IR,IFAIL,DET,JFAIL)
          INTEGER             IR(*),    IPAIRF
          DOUBLE PRECISION    A(IDIM,*),DET,      ZERO,     ONE,X,Y,TF
          DOUBLE PRECISION    G1,       G2
          DOUBLE PRECISION    PIVOTF,   P,        Q,        SIZEF,  T
          DOUBLE PRECISION    S11, S12, DOTF
          IPAIRF(J,K)  =  J*2**12 + K
          PIVOTF(X)    =  ABS(SNGL(X))
          SIZEF(X)     =  ABS(SNGL(X))
          DOTF(X,Y,S11)  =  X * Y + S11
          DATA      G1, G2              /  1.E-139, 1.E139  /
          DATA      ZERO, ONE           /  0.D0, 1.D0  /
          DATA      NORMAL, IMPOSS      /  0, -1  /
          DATA      JRANGE, JOVER, JUNDER  /  0, +1, -1  /
          IF(IDIM .GE. N  .AND.  N .GT. 0)  GOTO 110
             write(*,*) "DFACT: Problems with the dimensions",N,IDIM
             stop
 110      IFAIL  =  NORMAL
          JFAIL  =  JRANGE
          NXCH   =  0
          DET    =  ONE
          DO 144    J  =  1, N
 120         K  =  J
             P  =  PIVOTF(A(J,J))
             IF(J .EQ. N)  GOTO 122
             JP1  =  J+1
             DO 121    I  =  JP1, N
                Q  =  PIVOTF(A(I,J))
                IF(Q .LE. P)  GOTO 121
                   K  =  I
                   P  =  Q
 121            CONTINUE
             IF(K .NE. J)  GOTO 123
 122         IF(P .GT. 0.)  GOTO 130
                DET    =  ZERO
                IFAIL  =  IMPOSS
                JFAIL  =  JRANGE
                RETURN
 123         DO 124    L  =  1, N
                TF      =  A(J,L)
                A(J,L)  =  A(K,L)
                A(K,L)  =  TF
 124            CONTINUE
             NXCH      =  NXCH + 1
             IR(NXCH)  =  IPAIRF(J,K)
 130         DET     =  DET * A(J,J)
             A(J,J)  =  ONE / A(J,J)
             T  =  SIZEF(DET)
             IF(T .LT. G1)  THEN
                DET    =  ZERO
                IF(JFAIL .EQ. JRANGE)  JFAIL  =  JUNDER
             ELSEIF(T .GT. G2)  THEN
                DET    =  ONE
                IF(JFAIL .EQ. JRANGE)  JFAIL  =  JOVER
             ENDIF
             IF(J .EQ. N)  GOTO 144
             JM1  =  J-1
             JP1  =  J+1
             DO 143   K  =  JP1, N
                S11  =  -A(J,K)
                S12  =  -A(K,J+1)
                IF(J .EQ. 1)  GOTO 142
                DO 141  I  =  1, JM1
                   S11  =  DOTF(A(I,K),A(J,I),S11)
                   S12  =  DOTF(A(I,J+1),A(K,I),S12)
 141               CONTINUE
 142            A(J,K)    =  -S11 * A(J,J)
                A(K,J+1)  =  -DOTF(A(J,J+1),A(K,J),S12)
 143            CONTINUE
 144         CONTINUE
 150      IF(MOD(NXCH,2) .NE. 0)  DET  =  -DET
          IF(JFAIL .NE. JRANGE)   DET  =  ZERO
          IR(N)  =  NXCH
          RETURN
          END

          SUBROUTINE          DFEQN(N,A,IDIM,IR,K,B)
          INTEGER             IR(*)
          DOUBLE PRECISION    A(IDIM,*),B(IDIM,*),X,Y,TE
          DOUBLE PRECISION    S21, S22, DOTF
          DOTF(X,Y,S21)  =  X*Y + S21
          IF(IDIM .GE. N  .AND.  N .GT. 0  .AND.  K .GT. 0)  GOTO 210
             write(*,*) "DFEQN: Problems with the dimensions",N,IDIM,K
             stop
 210      NXCH  =  IR(N)
          IF(NXCH .EQ. 0)  GOTO 220
          DO 212    M  =  1, NXCH
             IJ  =  IR(M)
             I   =  IJ / 4096
             J   =  MOD(IJ,4096)
             DO 211   L  =  1, K
                TE      =  B(I,L)
                B(I,L)  =  B(J,L)
                B(J,L)  =  TE
 211            CONTINUE
 212         CONTINUE
 220      DO 221    L  =  1, K
             B(1,L)  =  A(1,1)*B(1,L)
 221         CONTINUE
          IF(N .EQ. 1)  GOTO 299
          DO 243    L  =  1, K
             DO 232   I  =  2, N
                IM1  =  I-1
                S21  =  - B(I,L)
                DO 231   J  =  1, IM1
                   S21  =  DOTF(A(I,J),B(J,L),S21)
 231               CONTINUE
                B(I,L)  =  - A(I,I)*S21
 232            CONTINUE
             NM1  =  N-1
             DO 242   I  =  1, NM1
                NMI  =  N-I
                S22  =  - B(NMI,L)
                DO 241   J  =  1, I
                   NMJP1  =  N - J+1
                   S22    =  DOTF(A(NMI,NMJP1),B(NMJP1,L),S22)
 241               CONTINUE
                B(NMI,L)  =  - S22
 242            CONTINUE
 243         CONTINUE
 299      CONTINUE
          RETURN
          END
