!PJD! CERNLIB D102: Adaptive Gaussian Quadrature
      SUBROUTINE DADAPT(F,A,B,NSEG,RELTOL,ABSTOL,RES,ERR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      EXTERNAL F
      PARAMETER (NDIM=10000)
      PARAMETER (R1 = 1, HF = R1/2)
      DIMENSION XLO(NDIM),XHI(NDIM),TVAL(NDIM),TERS(NDIM)
      SAVE XLO,XHI,TVAL,TERS,NTER
      DATA NTER /0/
      IF(NSEG .LE. 0)  THEN
       IF(NTER .EQ. 0) THEN
        NSEGD=1
        GO TO 2
       ENDIF
       TVALS=0
       TERSS=0
       DO 1 I = 1,NTER
       CALL DGS56P(F,XLO(I),XHI(I),TVAL(I),TE)
       TERS(I)=TE**2
       TVALS=TVALS+TVAL(I)
       TERSS=TERSS+TERS(I)
    1  CONTINUE
       ROOT= SQRT(2*TERSS)
       GO TO 9
      ENDIF
      NSEGD=MIN(NSEG,NDIM)
    2 XHIB=A
      BIN=(B-A)/NSEGD
      DO 3 I = 1,NSEGD
      XLO(I)=XHIB
      XLOB=XLO(I)
      XHI(I)=XHIB+BIN
      IF(I .EQ. NSEGD) XHI(I)=B
      XHIB=XHI(I)
      CALL DGS56P(F,XLOB,XHIB,TVAL(I),TE)
      TERS(I)=TE**2
    3 CONTINUE
      NTER=NSEGD
      DO 4 ITER = 1,NDIM
      TVALS=TVAL(1)
      TERSS=TERS(1)
      DO 5 I = 2,NTER
      TVALS=TVALS+TVAL(I)
      TERSS=TERSS+TERS(I)
    5 CONTINUE
      ROOT= SQRT(2*TERSS)
      IF(ROOT .LE. ABSTOL .OR. ROOT .LE. RELTOL*ABS(TVALS)) GO TO 9
      IF(NTER .EQ. NDIM) GO TO 9
      BIGE=TERS(1)
      IBIG=1
      DO 6 I = 2,NTER
      IF(TERS(I) .GT. BIGE) THEN
       BIGE=TERS(I)
       IBIG=I
      ENDIF
    6 CONTINUE
      NTER=NTER+1
      XHI(NTER)=XHI(IBIG)
      XNEW=HF*(XLO(IBIG)+XHI(IBIG))
      XHI(IBIG)=XNEW
      XLO(NTER)=XNEW
      CALL DGS56P(F,XLO(IBIG),XHI(IBIG),TVAL(IBIG),TE)
      TERS(IBIG)=TE**2
      CALL DGS56P(F,XLO(NTER),XHI(NTER),TVAL(NTER),TE)
      TERS(NTER)=TE**2
    4 CONTINUE
    9 RES=TVALS
      ERR=ROOT
!      if (NTER==NDIM) then
!         write(*,*) "DADAPT: TOO HIGH ACCURACY REQUIRED",RES,ERR
!      end if   
      RETURN
      END


!PJD! CERNLIB D106: Gaussian Quadrature with Five- and Six-Point Rules
      SUBROUTINE DGS56P(F,A,B,RES,ERR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (R1 = 1, HF = R1/2)
      DIMENSION X5(5),W5(5),X6(6),W6(6)
      DATA (X5(I),W5(I),I=1,5)
     1/4.6910077030668004D-02, 1.1846344252809454D-01,
     2 2.3076534494715846D-01, 2.3931433524968324D-01,
     3 5.0000000000000000D-01, 2.8444444444444444D-01,
     4 7.6923465505284154D-01, 2.3931433524968324D-01,
     5 9.5308992296933200D-01, 1.1846344252809454D-01/
      DATA (X6(I),W6(I),I=1,6)
     1/3.3765242898423989D-02, 8.5662246189585178D-02,
     2 1.6939530676686775D-01, 1.8038078652406930D-01,
     3 3.8069040695840155D-01, 2.3395696728634552D-01,
     4 6.1930959304159845D-01, 2.3395696728634552D-01,
     5 8.3060469323313225D-01, 1.8038078652406930D-01,
     6 9.6623475710157601D-01, 8.5662246189585178D-02/
      RANG=B-A
      E5=0
      E6=0
      DO 1 I = 1,5
      E5=E5+W5(I)*F(A+RANG*X5(I))
      E6=E6+W6(I)*F(A+RANG*X6(I))
    1 CONTINUE
      E6=E6+W6(6)*F(A+RANG*X6(6))
      RES=HF*(E6+E5)*RANG
      ERR=ABS((E6-E5)*RANG)
      RETURN
      END
