!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Commutator of 2x2 matrices !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function comm(a,b)
 implicit none
 double complex,dimension(2,2)::a,b,comm
 interface
    function prod(a,b)
     double complex,intent(in)::a(2,2),b(2,2)
     double complex::prod(2,2)
    end function prod
 end interface
 comm = prod(a,b) - prod(b,a)
 return
end function comm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Product of 2x2 matrices !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function prod(a,b)
 implicit none
 double complex,intent(in)::a(2,2),b(2,2)
 double complex::prod(2,2)
 prod(1,1) = a(1,1)*b(1,1) + a(1,2)*b(2,1)
 prod(1,2) = a(1,1)*b(1,2) + a(1,2)*b(2,2)
 prod(2,1) = a(2,1)*b(1,1) + a(2,2)*b(2,1)
 prod(2,2) = a(2,1)*b(1,2) + a(2,2)*b(2,2)
 return
end function prod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Product of 2x2 matrix times a column 2-vector !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function pro(A,q)
 implicit none
 double complex,dimension(2)::pro,q
 double complex,dimension(2,2)::A
 pro(1) = a(1,1)*q(1) + a(1,2)*q(2)
 pro(2) = a(2,1)*q(1) + a(2,2)*q(2)
 return
end function pro
