!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine initMGNC
 implicit none
 logical::saved=.false.
 integer i,j,order,fnscheme,fnsfixed
 double precision mth(4:6)
 integer,parameter::xdimMGNC=4001,Q2dimMGNC=2
 double precision MGridHQ(xdimMGNC+Q2dimMGNC),MGridHQ_save(xdimMGNC+Q2dimMGNC),xpaMGNC(-6:6,xdimMGNC,Q2dimMGNC),mc2,mb2
 double precision,dimension(xdimMGNC,Q2dimMGNC)::xsbMGNC,xdbMGNC,xubMGNC,xglMGNC,xuvMGNC,xdvMGNC,xsmMGNC
 save MGridHQ_save
 common /orderc/ order
 common /fnschemec/ fnscheme,fnsfixed
 common /hqmasses/ mth
 common /MGNCc/ xsbMGNC,xdbMGNC,xubMGNC,xglMGNC,xuvMGNC,xdvMGNC,xsmMGNC,MGridHQ
 if (.not.saved) then
    open(10, file="../../code/memory/MGxNC_4001.dat")
    read(10,*) MGridHQ(1:xdimMGNC)
    close(10)
    mc2 = mth(4)**2d0
    mb2 = mth(5)**2d0
    MGridHQ(xdimMGNC+1) = 4d0*mc2
    MGridHQ(xdimMGNC+2) = 4d0*mb2
    MGridHQ_save=MGridHQ
    saved = .true.
 end if
 MGridHQ=MGridHQ_save
 fnscheme=3
 do j=1,Q2dimMGNC
    do i=1,xdimMGNC
       call pdfs(MGridHQ(i),MGridHQ(xdimMGNC+j),xpaMGNC(:,i,j))
    end do
 end do
 fnscheme=fnsfixed
 xsbMGNC = xpaMGNC(-3,:,:)
 xdbMGNC = xpaMGNC(-2,:,:)
 xubMGNC = xpaMGNC(-1,:,:)
 xglMGNC = xpaMGNC(0,:,:)
 xuvMGNC = xpaMGNC(1,:,:)
 xdvMGNC = xpaMGNC(2,:,:)
 xsmMGNC = xpaMGNC(3,:,:)
 return
end subroutine initMGNC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine pdfsMGNC(x,Q2,xpa)
 implicit none
 integer,parameter::xdimMGNC=4001,Q2dimMGNC=2,shapeMGNC(2)=(/xdimMGNC,Q2dimMGNC/)
 double precision::xminMGNC=1d-5,xmaxMGNC=1d0
 double precision x,Q2,arg(2),xpa(-6:6),dfint
 double precision MGridHQ(xdimMGNC+Q2dimMGNC)
 double precision,dimension(xdimMGNC,Q2dimMGNC)::xsbMGNC,xdbMGNC,xubMGNC,xglMGNC,xuvMGNC,xdvMGNC,xsmMGNC
 common /MGNCc/ xsbMGNC,xdbMGNC,xubMGNC,xglMGNC,xuvMGNC,xdvMGNC,xsmMGNC,MGridHQ
 external dfint
 if ((x<xminMGNC).or.((x>xmaxMGNC).and.((x-xmaxMGNC)>1d-2))) then
    write(6,*) " PDFSMGNC: x out of range!",x
    stop
 end if
 if (((Q2<MgridHQ(xdimMGNC+1)).and.(Q2-MgridHQ(xdimMGNC+1)>1d-10)) .or. &
     ((Q2>MgridHQ(xdimMGNC+Q2dimMGNC)).and.(Q2-MgridHQ(xdimMGNC+Q2dimMGNC))>1d-10)) then
    write(6,*) " PDFSMGNC: Q2 out of range!",Q2
    stop
 end if
 arg=(/x,Q2/)
 xpa=0d0
 xpa(-3) = dfint(2,arg,shapeMGNC,MgridHQ,xsbMGNC)
 xpa(-2) = dfint(2,arg,shapeMGNC,MgridHQ,xdbMGNC)
 xpa(-1) = dfint(2,arg,shapeMGNC,MgridHQ,xubMGNC)
 xpa(0) = dfint(2,arg,shapeMGNC,MgridHQ,xglMGNC)
 xpa(1) = dfint(2,arg,shapeMGNC,MgridHQ,xuvMGNC)
 xpa(2) = dfint(2,arg,shapeMGNC,MgridHQ,xdvMGNC)
 xpa(3) = dfint(2,arg,shapeMGNC,MgridHQ,xsmMGNC)
 return
end subroutine pdfsMGNC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine initMGCC
 implicit none
 logical::saved=.false.
 integer i,j,fnscheme,fnsfixed
 double precision mth(4:6)
 integer,parameter::xdimMGCC=3201,Q2dimMGCC=57
 double precision::MGridSPL(xdimMGCC+Q2dimMGCC),MGridSPL_save(xdimMGCC+Q2dimMGCC),xpaMGCC(-6:6,xdimMGCC,Q2dimMGCC)=0d0,mc2
 double precision,dimension(xdimMGCC,Q2dimMGCC)::xsbMGCC,xdbMGCC,xubMGCC,xglMGCC,xuvMGCC,xdvMGCC,xsmMGCC
 save MGridSPL_save
 common /fnschemec/ fnscheme,fnsfixed
 common /hqmasses/ mth
 common /MGCCc/ xsbMGCC,xdbMGCC,xubMGCC,xglMGCC,xuvMGCC,xdvMGCC,xsmMGCC,MGridSPL
 if (.not.saved) then
    open(10,file="../../code/memory/MGxCC_3201.dat")
    read(10,*) MGridSPL(1:xdimMGCC)
    close(10)
    open(10,file="../../code/memory/MGQ2CC_reduced_57.dat")
    read(10,*) MGridSPL(xdimMGCC+1:xdimMGCC+Q2dimMGCC)
    close(10)
    mc2 = mth(4)**2d0
    MGridSPL(xdimMGCC+1:xdimMGCC+Q2dimMGCC) = MGridSPL(xdimMGCC+1:xdimMGCC+Q2dimMGCC) + mc2
    MGridSPL_save=MGridSPL
    saved = .true.
 end if
 MGridSPL=MGridSPL_save
 fnscheme=3
 do j=1,Q2dimMGCC
    do i=1,xdimMGCC
       call pdfs(MGridSPL(i),MGridSPL(xdimMGCC+j),xpaMGCC(:,i,j))
    end do
 end do
 fnscheme=fnsfixed
 xsbMGCC = xpaMGCC(-3,:,:)
 xdbMGCC = xpaMGCC(-2,:,:)
 xubMGCC = xpaMGCC(-1,:,:)
 xglMGCC = xpaMGCC(0,:,:)
 xuvMGCC = xpaMGCC(1,:,:)
 xdvMGCC = xpaMGCC(2,:,:)
 xsmMGCC = xpaMGCC(3,:,:)
 return
end subroutine initMGCC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine pdfsMGCC(x,Q2,xpa)
 implicit none
 integer,parameter::xdimMGCC=3201,Q2dimMGCC=57,shapeMGCC(2)=(/xdimMGCC,Q2dimMGCC/)
 double precision::xminMGCC=1d-4,xmaxMGCC=1d0
 double precision x,Q2,arg(2),xpa(-6:6),dfint
 double precision MGridSPL(xdimMGCC+Q2dimMGCC)
 double precision,dimension(xdimMGCC,Q2dimMGCC)::xsbMGCC,xdbMGCC,xubMGCC,xglMGCC,xuvMGCC,xdvMGCC,xsmMGCC
 common /MGCCc/ xsbMGCC,xdbMGCC,xubMGCC,xglMGCC,xuvMGCC,xdvMGCC,xsmMGCC,MGridSPL
 external dfint
 if ((x<xminMGCC).or.((x>xmaxMGCC).and.((x-xmaxMGCC)>1d-10))) then
    write(6,*) " PDFSMGCC: x out of range!",x
    stop
 end if
 if (((Q2<MgridSPL(xdimMGCC+1)).and.(Q2-MgridSPL(xdimMGCC+1)>1d-10)) .or. &
    ((Q2>MgridSPL(xdimMGCC+Q2dimMGCC)).and.(Q2-MgridSPL(xdimMGCC+Q2dimMGCC))>1d-10)) then
    write(6,*) " PDFSMGCC: Q2 out of range!",Q2
    stop
 end if
 arg=(/x,Q2/)
 xpa=0d0
 xpa(-3) = dfint(2,arg,shapeMGCC,MgridSPL,xsbMGCC)
 xpa(-2) = dfint(2,arg,shapeMGCC,MgridSPL,xdbMGCC)
 xpa(-1) = dfint(2,arg,shapeMGCC,MgridSPL,xubMGCC)
 xpa(0) = dfint(2,arg,shapeMGCC,MgridSPL,xglMGCC)
 xpa(1) = dfint(2,arg,shapeMGCC,MgridSPL,xuvMGCC)
 xpa(2) = dfint(2,arg,shapeMGCC,MgridSPL,xdvMGCC)
 xpa(3) = dfint(2,arg,shapeMGCC,MgridSPL,xsmMGCC)
 return
end subroutine pdfsMGCC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine initMGDY
 implicit none
 logical::saved=.false.
 integer i,j,input,fnscheme,fnsfixed
 integer,parameter::xdimMGDY=1601,Q2dimMGDY=73
 double precision::MGridDY(xdimMGDY+Q2dimMGDY),MGridDY_save(xdimMGDY+Q2dimMGDY),xpaMGDY(-6:6,xdimMGDY,Q2dimMGDY)=0d0
 double precision,dimension(xdimMGDY,Q2dimMGDY)::xcbMGDY,xsbMGDY,xdbMGDY,xubMGDY,xglMGDY,xuvMGDY,xdvMGDY,xsmMGDY,xcmMGDY
 save MGridDY_save
 common /inputc/ input
 common /fnschemec/ fnscheme,fnsfixed
 common /MGDYc/ xcbMGDY,xsbMGDY,xdbMGDY,xubMGDY,xglMGDY,xuvMGDY,xdvMGDY,xsmMGDY,xcmMGDY,MGridDY
 if (.not.saved) then
    open(10,file="../../code/memory/MGxDY_1601.dat")
    read(10,*) MGridDY(1:xdimMGDY)
    close(10)
    open(10,file="../../code/memory/MGQ2DY_reduced_73.dat")
    read(10,*) MGridDY(xdimMGDY+1:xdimMGDY+Q2dimMGDY)
    close(10)
    MGridDY_save=MGridDY
    saved = .true.
 end if
 MGridDY=MGridDY_save
 fnscheme=5
 do j=1,Q2dimMGDY
    do i=1,xdimMGDY
       call pdfs(MGridDY(i),MGridDY(xdimMGDY+j),xpaMGDY(:,i,j))
    end do
 end do
 fnscheme=fnsfixed
 xcbMGDY = xpaMGDY(-4,:,:)
 xsbMGDY = xpaMGDY(-3,:,:)
 xdbMGDY = xpaMGDY(-2,:,:)
 xubMGDY = xpaMGDY(-1,:,:)
 xglMGDY = xpaMGDY(0,:,:)
 xuvMGDY = xpaMGDY(1,:,:)
 xdvMGDY = xpaMGDY(2,:,:)
 xsmMGDY = xpaMGDY(3,:,:)
 xcmMGDY = xpaMGDY(4,:,:)
 return
end subroutine initMGDY

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine pdfsMGDY(x,Q2,xpa)
 implicit none
 integer,parameter::xdimMGDY=1601,Q2dimMGDY=73,shapeMGDY(2)=(/xdimMGDY,Q2dimMGDY/)
 double precision::xminMGDY=1d-2,xmaxMGDY=1d0
 double precision x,Q2,arg(2),xpa(-6:6),dfint
 double precision MGridDY(xdimMGDY+Q2dimMGDY)
 double precision,dimension(xdimMGDY,Q2dimMGDY)::xcbMGDY,xsbMGDY,xdbMGDY,xubMGDY,xglMGDY,xuvMGDY,xdvMGDY,xsmMGDY,xcmMGDY
 common /MGDYc/ xcbMGDY,xsbMGDY,xdbMGDY,xubMGDY,xglMGDY,xuvMGDY,xdvMGDY,xsmMGDY,xcmMGDY,MGridDY
 external dfint
 if ((x<xminMGDY).or.((x>xmaxMGDY).and.((x-xmaxMGDY)>1d-10))) then
    write(6,*) " PDFSMGDY: x out of range!",x
    stop
 end if
 if (((Q2<MgridDY(xdimMGDY+1)).and.(Q2-MgridDY(xdimMGDY+1)>1d-10)) .or. &
     ((Q2>MgridDY(xdimMGDY+Q2dimMGDY)).and.(Q2-MgridDY(xdimMGDY+Q2dimMGDY))>1d-10)) then
    write(6,*) " PDFSMGDY: Q2 out of range!",Q2
    stop
 end if
 arg=(/x,Q2/)
 xpa=0d0
 xpa(-4) = dfint(2,arg,shapeMGDY,MgridDY,xcbMGDY)
 xpa(-3) = dfint(2,arg,shapeMGDY,MgridDY,xsbMGDY)
 xpa(-2) = dfint(2,arg,shapeMGDY,MgridDY,xdbMGDY)
 xpa(-1) = dfint(2,arg,shapeMGDY,MgridDY,xubMGDY)
 xpa(0) = dfint(2,arg,shapeMGDY,MgridDY,xglMGDY)
 xpa(1) = dfint(2,arg,shapeMGDY,MgridDY,xuvMGDY)
 xpa(2) = dfint(2,arg,shapeMGDY,MgridDY,xdvMGDY)
 xpa(3) = dfint(2,arg,shapeMGDY,MgridDY,xsmMGDY)
 xpa(4) = dfint(2,arg,shapeMGDY,MgridDY,xcmMGDY)
 return
end subroutine pdfsMGDY
