!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4g1d(x)
 implicit none
 double precision x
 double precision,external::T4g1p,T4g1n
 T4g1d = T4g1p(x) + T4g1n(x)
 return
end function T4g1d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T3g1d(x,Q2)
 implicit none
 double precision x,Q2
 double precision,external::T3g1p,T3g1n
 T3g1d = T3g1p(x,Q2) + T3g1n(x,Q2)
 return
end function T3g1d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T3g2d(x)
 implicit none
 double precision x
 double precision,external::T3g2p,T3g2n
 T3g2d = T3g2p(x) + T3g2n(x)
 return
end function T3g2d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4g1He(x)
 implicit none
 double precision x
 double precision,external::T4g1p,T4g1n
 T4g1He = 2d0*T4g1p(x) + T4g1n(x)
 return
end function T4g1He

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T3g1He(x,Q2)
 implicit none
 double precision x,Q2
 double precision,external::T3g1p,T3g1n
 T3g1He = 2d0*T3g1p(x,Q2) + T3g1n(x,Q2)
 return
end function T3g1He

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T3g2He(x)
 implicit none
 double precision x
 double precision,external::T3g2p,T3g2n
 T3g2He = 2d0*T3g2p(x) + T3g2n(x)
 return
end function T3g2He

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4g1p(x)
 implicit none
 integer,parameter::n=5,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/0d0,0.1d0,0.3d0,0.5d0,0.7d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT4g1p(10)
 common /T4g1pc/ pT4g1p
 y(0:n-1,1) = pT4g1p(1:n)
 if((x<=0d0).or.(x>=1d0)) then
    T4g1p = 0d0
    T4g1p = T4g1p/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >=xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T4g1p = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T4g1p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4g1n(x)
 implicit none
 integer,parameter::n=5,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/0d0,0.1d0,0.3d0,0.5d0,0.7d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT4g1n(10)
 common /T4g1nc/ pT4g1n
 y(0:n-1,1) = pT4g1n(1:n)
 if((x<=0d0).or.(x>=1d0)) then
    T4g1n = 0d0
    T4g1n = T4g1n/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >=xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T4g1n = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T4g1n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T3g1p(x,Q2)
 implicit none
 double precision x,Q2,IntT3g2p,err
 double precision,external::T3g2p,iT3g2p
 if((x<=0d0).or.(x>=1d0)) then
    T3g1p = 0d0
    T3g1p = T3g1p/0d0
    return
 end if
 call dadapt(iT3g2p,x,1d0,1,1d-6,1d-6,IntT3g2p,err)
 T3g1p = 4d0*x*x*0.8803536d0/Q2*(T3g2p(x) - 2d0*IntT3g2p)
 return
end function T3g1p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T3g1n(x,Q2)
 implicit none
 double precision x,Q2,IntT3g2n,err
 double precision,external::T3g2n,iT3g2n
 if((x<=0d0).or.(x>=1d0)) then
    T3g1n = 0d0
    T3g1n = T3g1n/0d0
    return
 end if
 call dadapt(iT3g2n,x,1d0,1,1d-6,1d-6,IntT3g2n,err)
 T3g1n = 4d0*x*x*0.8803536d0/Q2*(T3g2n(x) - 2d0*IntT3g2n)
 return
end function T3g1n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function iT3g2p(y)
 implicit none
 double precision y
 double precision,external::T3g2p
 if((y<=0d0).or.(y>=1d0)) then
    iT3g2p = 0d0
    iT3g2p = iT3g2p/0d0
    return
 end if
 iT3g2p = T3g2p(y)/y
 return
end function iT3g2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function iT3g2n(y)
 implicit none
 double precision y
 double precision,external::T3g2n
 if((y<=0d0).or.(y>=1d0)) then
    iT3g2n = 0d0
    iT3g2n = iT3g2n/0d0
    return
 end if
 iT3g2n = T3g2n(y)/y
 return
end function iT3g2n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T3g2p(x)
 implicit none
! double precision x,alpha,beta,pT3g2p(10)
 double precision x,A,B,C,D,E,pT3g2p(10)
 common /T3g2pc/ pT3g2p
! alpha = pT3g2p(1)
! beta = pT3g2p(2)
! A = pT3g2p(1)
 B = pT3g2p(2)
 C = pT3g2p(3)
 D = pT3g2p(4)
 E = pT3g2p(5)
 A = (105d0*B+84d0*C+70d0*D+60d0*E)/140d0
 pT3g2p(1) = A
 if((x<=0d0).or.(x>=1d0)) then
    T3g2p = 0d0
    T3g2p = T3g2p/0d0
    return
 end if
! T3g2p = alpha*(1d0-x)**beta*((beta+2d0)*x - 1d0)
 T3g2p = A*( dlog(x) + (1d0-x) + 0.5d0*(1d0-x)**2d0 ) + (1d0-x)**3d0*( B + C*(1d0-x) + D*(1d0-x)**2d0 + E*(1d0-x)**3d0 )
 return
end function T3g2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T3g2n(x)
 implicit none
! double precision x,alpha,beta,pT3g2n(10)
 double precision x,A,B,C,D,E,pT3g2n(10)
 common /T3g2nc/ pT3g2n
! alpha = pT3g2n(1)
! beta = pT3g2n(2)
! A = pT3g2n(1)
 B = pT3g2n(2)
 C = pT3g2n(3)
 D = pT3g2n(4)
 E = pT3g2n(5)
 A = (105d0*B+84d0*C+70d0*D+60d0*E)/140d0
 pT3g2n(1) = A
 if((x<=0d0).or.(x>=1d0)) then
    T3g2n = 0d0
    T3g2n = T3g2n/0d0
    return
 end if
! T3g2n = alpha*(1d0-x)**beta*((beta+2d0)*x - 1d0)
 T3g2n = A*( dlog(x) + (1d0-x) + 0.5d0*(1d0-x)**2d0 ) + (1d0-x)**3d0*( B + C*(1d0-x) + D*(1d0-x)**2d0 + E*(1d0-x)**3d0 )
 return
end function T3g2n
