!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4F2d(x)
 implicit none
 double precision x
 double precision,external::T4F2p,T4F2n
 T4F2d = (T4F2p(x) + T4F2n(x))/2d0
 return
end function T4F2d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4FLd(x)
 implicit none
 double precision x
 double precision,external::T4FLp,T4FLn
 T4FLd = (T4FLp(x) + T4FLn(x))/2d0
 return
end function T4FLd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4F2He(x)
 implicit none
 double precision x
 double precision,external::T4F2p,T4F2n
 T4F2He = (2d0*T4F2p(x) + T4F2n(x))/3d0
 return
end function T4F2He

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4FLHe(x)
 implicit none
 double precision x
 double precision,external::T4FLp,T4FLn
 T4FLHe = (2d0*T4FLp(x) + T4FLn(x))/3d0
 return
end function T4FLHe

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4F2p(x)
 implicit none
 integer,parameter::n=5,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/0d0,0.1d0,0.3d0,0.5d0,0.7d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT4F2p(n)
 common /T4F2pc/ pT4F2p
 y(0:n-1,1) = pT4F2p
 if((x<1.5d-5).or.(x>1d0)) then
    T4F2p = 0d0
    T4F2p = T4F2p/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >= xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T4F2p = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T4F2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4F2n(x)
 implicit none
 integer,parameter::n=5,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/0d0,0.1d0,0.3d0,0.5d0,0.7d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT4F2n(n)
 common /T4F2nc/ pT4F2n
 y(0:n-1,1) = pT4F2n
 if((x<1d-3).or.(x>1d0)) then
    T4F2n = 0d0
    T4F2n = T4F2n/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >= xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T4F2n = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T4F2n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4FLp(x)
 implicit none
 integer,parameter::n=5,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/0d0,0.1d0,0.3d0,0.5d0,0.7d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT4FLp(n)
 common /T4FLpc/ pT4FLp
 y(0:n-1,1) = pT4FLp
 if((x<1.5d-5).or.(x>1d0)) then
    T4FLp = 0d0
    T4FLp = T4FLp/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >= xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T4FLp = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T4FLp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T4FLn(x)
 implicit none
 integer,parameter::n=5,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/0d0,0.1d0,0.3d0,0.5d0,0.7d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT4FLn(n)
 common /T4FLnc/ pT4FLn
 y(0:n-1,1) = pT4FLn
 if((x<1d-3).or.(x>1d0)) then
    T4FLn = 0d0
    T4FLn = T4FLn/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >= xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T4FLn = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T4FLn
