!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T6F2d(x)
 implicit none
 double precision x
 double precision,external::T6F2p,T6F2n
 T6F2d = (T6F2p(x) + T6F2n(x))/2d0
 return
end function T6F2d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T6FLd(x)
 implicit none
 double precision x
 double precision,external::T6FLp,T6FLn
 T6FLd = (T6FLp(x) + T6FLn(x))/2d0
 return
end function T6FLd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T6F2He(x)
 implicit none
 double precision x
 double precision,external::T6F2p,T6F2n
 T6F2He = (2d0*T6F2p(x) + T6F2n(x))/3d0
 return
end function T6F2He

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T6FLHe(x)
 implicit none
 double precision x
 double precision,external::T6FLp,T6FLn
 T6FLHe = (2d0*T6FLp(x) + T6FLn(x))/3d0
 return
end function T6FLHe

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T6F2p(x)
 implicit none
 integer,parameter::n=10,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/1d-5,1d-4,1d-3,1d-2,0.1d0,0.2d0,0.35d0,0.5d0,0.65d0,0.8d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT6F2p(n)
 common /T6F2pc/ pT6F2p
 y(0:n-1,1) = pT6F2p
 if((x<1d-5).or.(x>1d0)) then
    T6F2p = 0d0
    T6F2p = T6F2p/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >= xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T6F2p = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T6F2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T6F2n(x)
 implicit none
 integer,parameter::n=8,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/1d-3,1d-2,0.1d0,0.2d0,0.35d0,0.5d0,0.65d0,0.8d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT6F2n(n)
 common /T6F2nc/ pT6F2n
 y(0:n-1,1) = pT6F2n
 if((x<1d-3).or.(x>1d0)) then
    T6F2n = 0d0
    T6F2n = T6F2n/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >= xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T6F2n = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T6F2n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T6FLp(x)
 implicit none
 integer,parameter::n=10,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/1d-5,1d-4,1d-3,1d-2,0.1d0,0.2d0,0.35d0,0.5d0,0.65d0,0.8d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT6FLp(n)
 common /T6FLpc/ pT6FLp
 y(0:n-1,1) = pT6FLp
 if((x<1d-5).or.(x>1d0)) then
    T6FLp = 0d0
    T6FLp = T6FLp/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >= xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T6FLp = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T6FLp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T6FLn(x)
 implicit none
 integer,parameter::n=8,m=1,mode=0
 integer::i,j=0
 double precision::xgrid(0:n)=(/1d-3,1d-2,0.1d0,0.2d0,0.35d0,0.5d0,0.65d0,0.8d0,1d0/)
 double precision::y(0:n,m)=0d0
 double precision,dimension(n,m)::A,B,C,D
 double precision::x,xp=0d0,xps=0d0,xpc=0d0,pT6FLn(n)
 common /T6FLnc/ pT6FLn
 y(0:n-1,1) = pT6FLn
 if((x<1d-3).or.(x>1d0)) then
    T6FLn = 0d0
    T6FLn = T6FLn/0d0
    return
 end if
 call dcspln(n,xgrid,m,y,n,mode,A,B,C,D)
 do i = 1,n
    if (x >= xgrid(i)) cycle
    j = i
    xp = x-xgrid(i-1)
    xps = xp*xp
    xpc = xps*xp
    exit
 end do
 T6FLn = A(j,1) + B(j,1)*xp + C(j,1)*xps + D(j,1)*xpc
 return
end function T6FLn
