!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!! Some simple x-integrals (integer moments) of PDFs !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function d2p()
 use master
 implicit none
 double precision Q2,err
 double precision,external::id2p
 common /arguments/ Q2
 Q2 = p(51)
 call dadapt(id2p,0d0,1d0,1,1d-3,1d-3,d2p,err)
 return
end function d2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function d2n()
 use master
 implicit none
 double precision Q2,err
 double precision,external::id2n
 common /arguments/ Q2
 Q2 = p(51)
 call dadapt(id2n,0d0,1d0,1,1d-3,1d-3,d2n,err)
 return
end function d2n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intg2p()
 use master
 implicit none
 double precision Q2,err
 double precision,external::ig2p
 common /arguments/ Q2
 Q2 = p(51)
 call dadapt(ig2p,0d0,1d0,1,1d-6,1d-6,Intg2p,err)
 return
end function Intg2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intg2n()
 use master
 implicit none
 double precision Q2,err
 double precision,external::ig2n
 common /arguments/ Q2
 Q2 = p(51)
 call dadapt(ig2n,0d0,1d0,1,1d-6,1d-6,Intg2n,err)
 return
end function Intg2n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function IntDg(Q2,xmin,xmax)
 use master
 implicit none
 double precision Q2,Q2c,xmin,xmax,err
 double precision,external::iDg
 common /arguments/ Q2c
 Q2c=Q2
 call dadapt(iDg,xmin,xmax,1,1d-6,1d-6,IntDg,err)
 return
end function IntDg

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function IntxDg()
 use master
 implicit none
! double precision Q2,err
! double precision,external::ixDg
 double precision,external::dbeta
! common /arguments/ Q2
! Q2 = p(51)
! call dadapt(ixDg,0d0,1d0,1,5d-4,1d-6,IntxDg,err)
 IntxDg = p(71)*(dbeta(p(72),p(73)+1d0) + p(74)*dbeta(p(72)+0.5d0,p(73)+1d0) + p(75)*dbeta(p(72)+1d0,p(73)+1d0))
 return
end function IntxDg

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function IntxDub()
 use master
 implicit none
! double precision Q2,err
! double precision,external::iDub
 double precision,external::dbeta
! common /arguments/ Q2
! Q2 = p(51)
! call dadapt(ixDub,0d0,1d0,1,5d-4,1d-6,IntxDub,err)
 IntxDub = p(76)*(dbeta(p(77)+1d0,p(78)+1d0) + p(79)*dbeta(p(77)+1.5d0,p(78)+1d0) + p(80)*dbeta(p(77)+2d0,p(78)+1d0))
 return
end function IntxDub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function IntxDdb()
 use master
 implicit none
! double precision Q2,err
! double precision,external::ixDdb
 double precision,external::dbeta
! common /arguments/ Q2
! Q2 = p(51)
! call dadapt(ixDdb,0d0,1d0,1,5d-4,1d-6,IntxDdb,err)
 IntxDdb = p(81)*(dbeta(p(82)+1d0,p(83)+1d0) + p(84)*dbeta(p(82)+1.5d0,p(83)+1d0) + p(85)*dbeta(p(82)+2d0,p(83)+1d0))
 return
end function IntxDdb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function IntxDsb()
 use master
 implicit none
! double precision Q2,err
! double precision,external::ixDsb
 double precision,external::dbeta
! common /arguments/ Q2
! Q2 = p(51)
! call dadapt(ixDsb,0d0,1d0,1,5d-4,1d-6,IntxDsb,err)
 IntxDsb = p(86)*(dbeta(p(87)+1d0,p(88)+1d0) + p(89)*dbeta(p(87)+1.5d0,p(88)+1d0) + p(90)*dbeta(p(87)+2d0,p(88)+1d0))
 return
end function IntxDsb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function IntSU2()
 use master
 implicit none
! double precision Q2,err
! double precision,external::iSU2
 double precision,external::dbeta
! common /arguments/ Q2
! Q2 = p(51)
! call dadapt(iSU2,0d0,1d0,1,5d-4,1d-6,IntSU2,err)
 IntSU2 = p(61)*(dbeta(p(62),p(63)+1d0) + p(64)*dbeta(p(62)+0.5d0,p(63)+1d0) + p(65)*dbeta(p(62)+1d0,p(63)+1d0)) &
        - p(66)*(dbeta(p(67),p(68)+1d0) + p(69)*dbeta(p(67)+0.5d0,p(68)+1d0) + p(70)*dbeta(p(67)+1d0,p(68)+1d0))
! IntSU2 = 1.269d0
 return
end function IntSU2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function IntSU3()
 use master
 implicit none
! double precision Q2,err
! double precision,external::iSU3
 double precision,external::dbeta
! common /arguments/ Q2
! Q2 = p(51)
! call dadapt(iSU3,0d0,1d0,1,2d-3,1d-6,IntSU3,err)
 IntSU3 = p(61)*(dbeta(p(62),p(63)+1d0) + p(64)*dbeta(p(62)+0.5d0,p(63)+1d0) + p(65)*dbeta(p(62)+1d0,p(63)+1d0)) &
        + p(66)*(dbeta(p(67),p(68)+1d0) + p(69)*dbeta(p(67)+0.5d0,p(68)+1d0) + p(70)*dbeta(p(67)+1d0,p(68)+1d0)) &
     -4d0*p(86)*(dbeta(p(87),p(88)+1d0) + p(89)*dbeta(p(87)+0.5d0,p(88)+1d0) + p(90)*dbeta(p(87)+1d0,p(88)+1d0))
! IntSU3 =0.586d0
 return
end function IntSU3

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine IntPDFs(Q2l)
 implicit none
 double precision Q2l
 double precision,external::Intuv,Intdv,Intxuv,Intxdv,Intxub,Intxdb,Intxgl,Intxproton
 double precision,external::Ints,Intsb,Intsp,Intsm,Intxs,Intxsb,Intxsm,Intxsp
 10 format (2x,a,f7.4)
 11 format (2x,a,f4.2,a)
 write(6,*)
 write(6,11) "IntPDFS: Q2 = ",Q2l," GeV2"
 write(6,10) "Intuv = ",Intuv(Q2l)
 write(6,10) "Intdv = ",Intdv(Q2l)
 write(6,10) "Intsm = ",Intsm(Q2l)
 write(6,10) "Intxub = ",Intxub(Q2l)
 write(6,10) "Intxdb = ",Intxdb(Q2l)
 write(6,10) "Intxsb = ",Intxsb(Q2l)
 write(6,10) "Intxsm = ",Intxsm(Q2l)
 write(6,10) "Intxgl = ",Intxgl(Q2l)
 write(6,10) "Intxproton = ",Intxproton(Q2l)
end subroutine IntPDFs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intuv(Q2l)
 implicit none
 double precision Q2,Q2l
 double precision err
 double precision,external::iuv
 common /arguments/ Q2
 Q2 = Q2l
 call dadapt(iuv,0d0,1d0,1,1d-6,1d-6,Intuv,err)
 return
end function Intuv

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intdv(Q2l)
 implicit none
 double precision Q2,Q2l
 double precision err
 double precision,external::idv
 common /arguments/ Q2
 Q2 = Q2l
 call dadapt(idv,0d0,1d0,1,1d-6,1d-6,Intdv,err)
 return
end function Intdv

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intsm(Q2l)
! use master
 implicit none
 double precision Q2,Q2l
 double precision err
 double precision,external::ism
 common /arguments/ Q2
 Q2 = Q2l
 call dadapt(ism,0d0,1d0,1,1d-6,5d-6,Intsm,err)
 return
end function Intsm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intxub(Q2l)
 implicit none
 double precision Q2,Q2l
 double precision err
 double precision,external::ixub
 common /arguments/ Q2
 Q2 = Q2l
 call dadapt(ixub,0d0,1d0,1,1d-6,1d-6,Intxub,err)
 return
end function Intxub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intxdb(Q2l)
 implicit none
 double precision Q2,Q2l
 double precision err
 double precision,external::ixdb
 common /arguments/ Q2
 Q2 = Q2l
 call dadapt(ixdb,0d0,1d0,1,1d-6,1d-6,Intxdb,err)
 return
end function Intxdb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intxsb(Q2l)
 implicit none
 double precision Q2,Q2l
 double precision err
 double precision,external::ixsb
 common /arguments/ Q2
 Q2 = Q2l
 call dadapt(ixsb,0d0,1d0,1,1d-6,1d-6,Intxsb,err)
 return
end function Intxsb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intxsm(Q2l)
 implicit none
 double precision Q2,Q2l
 double precision err
 double precision,external::ixsm
 common /arguments/ Q2
 Q2 = Q2l
 call dadapt(ixsm,0d0,1d0,1,1d-6,1d-6,Intxsm,err)
 return
end function Intxsm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intxgl(Q2l)
 implicit none
 double precision Q2,Q2l
 double precision err
 double precision,external::ixgl
 common /arguments/ Q2
 Q2 = Q2l
 call dadapt(ixgl,0d0,1d0,1,1d-6,1d-6,Intxgl,err)
 return
end function Intxgl

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Intxproton(Q2l)
 implicit none
 double precision Q2,Q2l
 double precision err
 double precision,external::ixproton
 common /arguments/ Q2
 Q2 = Q2l
 call dadapt(ixproton,0d0,1d0,1,1d-6,1d-6,Intxproton,err)
 return
end function Intxproton

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Auxiliary functions (integrands) !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function id2p(x)
 implicit none
 double precision x,Q2,g1,g2
 double precision,external::T3g1p,T4g1p,T3g2p
 common /arguments/ Q2
 g1 = T3g1p(x,Q2) +  T4g1p(x)/Q2
 g2 = T3g2p(x)
 id2p = x*x*(2d0*g1 + 3d0*g2)
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function id2n(x)
 implicit none
 double precision x,Q2,g1,g2
 double precision,external::T3g1n,T4g1n,T3g2n
 common /arguments/ Q2
 g1 = T3g1n(x,Q2) + T4g1n(x)/Q2
 g2 = T3g2n(x)
 id2n = x*x*(2d0*g1 + 3d0*g2)
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ig2p(x)
 implicit none
 double precision x,Q2
 double precision,external::T3g2p
 common /arguments/ Q2
 ig2p = T3g2p(x)
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ig2n(x)
 implicit none
 double precision x,Q2
 double precision,external::T3g2n
 common /arguments/ Q2
 ig2n = T3g2n(x,Q2)
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function iSU2(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call ppdfs(x,Q2,xpa)
 iSU2 = (xpa(1) + 2d0*xpa(-1) - xpa(2) - 2d0*xpa(-2))/x
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function iSU3(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call ppdfs(x,Q2,xpa)
 iSU3 = (xpa(1) + 2d0*xpa(-1) + xpa(2) + 2d0*xpa(-2) - 2d0*xpa(3) - 4d0*xpa(-3))/x
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function iuv(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 iuv = xpa(1)/x
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function idv(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 idv = xpa(2)/x
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ism(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 ism = xpa(3)/x
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function isp(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 isp = (xpa(3)+2d0*xpa(-3))/x
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ixub(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 ixub = xpa(-1)
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ixdb(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 ixdb = xpa(-2)
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ixsb(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 ixsb = xpa(-3)
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ixsm(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 ixsm = xpa(3)
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ixgl(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 ixgl = xpa(0)
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function iDg(x)
 implicit none
 double precision x,Q2,xpa(-6:6)
 common /arguments/ Q2
 call ppdfs(x,Q2,xpa)
 iDg = xpa(0)/x
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function ixproton(x)
 implicit none
 double precision x,Q2,xuv,xdv,xsm,xca,xba,xta,xub,xdb,xsb,xcm,xbm,xtm,xgl,xpa(-6:6)
 common /arguments/ Q2
 call pdfs(x,Q2,xpa)
 xtm = xpa(-6)
 xbm = xpa(-5)
 xcm = xpa(-4)
 xsb = xpa(-3)
 xdb = xpa(-2)
 xub = xpa(-1)
 xgl = xpa(0)
 xuv = xpa(1)
 xdv = xpa(2)
 xsm = xpa(3)
 xca = xpa(4)
 xba = xpa(5)
 xta = xpa(6)
 ixproton = xuv+xdv+xsm+xca+xba+xta+2d0*(xub+xdb+xsb+xcm+xbm+xtm)+xgl
 return
end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
