!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function mpole(order,nh,mmsb)
 implicit none
 integer order,nh,nl
 double precision::mmsb,beta0,beta1,alphas,as,ratio
 double precision,parameter::pi=dacos(-1d0)
 external as
 nl=nh-1
 beta0 = 1d0/4d0*(11d0 - 2d0/3d0*nl)
 beta1 = 1d0/16d0*(102d0 - 38d0/3d0*nl)
 alphas = 4d0*pi*as(mmsb**2d0)
 ratio = 1d0 + 4d0/3d0*alphas/pi
 if (order<0) then
    write(*,*) "MPOLE: Bad value for order:",order
    stop
 end if
 if (order>=0) ratio = 1d0 + 4d0/3d0*alphas/pi
 if (order>=1) ratio = ratio + (alphas/pi)**2d0*(6.248d0*beta0 - 3.739d0)
 if (order>=2) ratio = ratio + (alphas/pi)**3d0*(23.497d0*beta0**2d0 + 6.248d0*beta1 + 1.019d0*beta0 -29.94d0)
 if (order>=3) then
    write(*,*) "MPOLE: Bad value for order:",order
    stop
 end if
 mpole = ratio*mmsb
end function mpole 
