!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T2g1p(x,Q2)
 use master
 implicit none
 double precision x,Q2,g(-2:2)
 call pstructurefs(x,Q2,g)
 T2g1p = g(1)
 return
end function T2g1p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T2g1n(x,Q2)
 use master
 implicit none
 double precision x,Q2,g(-2:2)
 call pstructurefs(x,Q2,g)
 T2g1n = g(-1)
 return
end function T2g1n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T2g2p(x,Q2)
 use master
 implicit none
 double precision x,Q2,g(-2:2)
 call pstructurefs(x,Q2,g)
 T2g2p = g(2)
 return
end function T2g2p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function T2g2n(x,Q2)
 use master
 implicit none
 double precision x,Q2,g(-2:2)
 call pstructurefs(x,Q2,g)
 T2g2n = g(-2)
 return
end function T2g2n

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function pgg(x,Q2)
 use master
 implicit none
 double precision x,Q2,xpa(-6:6),xDpa(-6:6)
 call pdfs(x,Q2,xpa)
 call ppdfs(x,Q2,xDpa)
 pgg = xDpa(0)/xpa(0)
 return
end function pgg

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function pupup(x,Q2)
 use master
 implicit none
 double precision x,Q2,xpa(-6:6),xDpa(-6:6)
 call pdfs(x,Q2,xpa)
 call ppdfs(x,Q2,xDpa)
 pupup = (xDpa(1)+2d0*xDpa(-1))/(xpa(1)+2d0*xpa(-1))
 return
end function pupup

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function pdpdp(x,Q2)
 use master
 implicit none
 double precision x,Q2,xpa(-6:6),xDpa(-6:6)
 call pdfs(x,Q2,xpa)
 call ppdfs(x,Q2,xDpa)
 pdpdp = (xDpa(2)+2d0*xDpa(-2))/(xpa(2)+2d0*xpa(-2))
 return
end function pdpdp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function pxup(x,Q2)
 use master
 implicit none
 double precision x,Q2,xpa(-6:6)
 call ppdfs(x,Q2,xpa)
 pxup = xpa(1)+2d0*xpa(-1)
 return
end function pxup

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function pxdp(x,Q2)
 use master
 implicit none
 double precision x,Q2,xpa(-6:6)
 call ppdfs(x,Q2,xpa)
 pxdp = xpa(2)+2d0*xpa(-2)
 return
end function pxdp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function pxub(x,Q2)
 use master
 implicit none
 double precision x,Q2,xpa(-6:6)
 call ppdfs(x,Q2,xpa)
 pxub = xpa(-1)
 return
end function pxub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function pxdb(x,Q2)
 use master
 implicit none
 double precision x,Q2,xpa(-6:6)
 call ppdfs(x,Q2,xpa)
 pxdb = xpa(-2)
 return
end function pxdb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function pxsb(x,Q2)
 use master
 implicit none
 double precision x,Q2,xpa(-6:6)
 call ppdfs(x,Q2,xpa)
 pxsb = xpa(-3)
 return
end function pxsb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function pxg(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call ppdfs(x,Q2,xpa)
 pxg = xpa(0)
 return
end function pxg

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xuv(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xuv = xpa(1)
 return
end function xuv

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xdv(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xdv = xpa(2)
 return
end function xdv

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xub(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xub = xpa(-1)
 return
end function xub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xdb(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xdb = xpa(-2)
 return
end function xdb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xsb(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xsb = xpa(-3)
 return
end function xsb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xsm(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xsm = xpa(3)
 return
end function xsm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xup(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xup = xpa(1)+2d0*xpa(-1)
 return
end function xup

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xdp(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xdp = xpa(2)+2d0*xpa(-2)
 return
end function xdp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xsp(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xsp = xpa(3)+2d0*xpa(-3)
 return
end function xsp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xu(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xu = xpa(1)+xpa(-1)
 return
end function xu

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xd(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xd = xpa(2)+xpa(-2)
 return
end function xd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xcb(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xcb = xpa(-4)
 return
end function xcb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xbb(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xbb = xpa(-5)
 return
end function xbb

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xgl(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xgl = xpa(0)
 return
end function xgl

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xDgl(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call ppdfs(x,Q2,xpa)
 xDgl = xpa(0)
 return
end function xDgl

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xqs(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xqs = xpa(1) + 2d0*xpa(-1) + xpa(2) + 2d0*xpa(-2) + xpa(3) + 2d0*xpa(-3)
 xqs = xqs
 return
end function xqs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function Lgg(sqrttau,sqrts)
 implicit none
 double precision sqrttau,sqrts,tau,shat,iLgg,err
 external iLgg
 common/Lggc/tau,shat
 tau = sqrttau*sqrttau
 shat = tau*sqrts*sqrts
 call dadapt(iLgg,tau,1d0,1,1d-4,1d-14,Lgg,err)
 Lgg = tau*Lgg
 return
end function Lgg

double precision function iLgg(x)
 implicit none
 double precision x,tau,shat,xpa(-6:6),gx,gtaux
 common/Lggc/tau,shat
 call pdfs(x,shat,xpa)
 gx = xpa(0)
 call pdfs(tau/x,shat,xpa)
 gtaux = xpa(0)
 iLgg = gx/x*gtaux/x/x
 return
end function iLgg

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function du(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 du = (xpa(2)+xpa(-2))/(xpa(1)+xpa(-1))
 return
end function du

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function dvuv(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 dvuv = xpa(2)/xpa(1)
 return
end function dvuv

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function dbub(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 dbub = xpa(-2)/xpa(-1)
 return
end function dbub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function db_ub(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 db_ub = (xpa(-2)-xpa(-1))/x
 return
end function db_ub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xdelta(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xdelta = xpa(-2)-xpa(-1)
 return
end function xdelta

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function xsea(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 xsea = xpa(-1)+xpa(-2)
 return
end function xsea

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function db_ubu_d(x,Q2)
 implicit none
 double precision x,Q2,xpa(-6:6)
 call pdfs(x,Q2,xpa)
 db_ubu_d = (xpa(-2)-xpa(-1))/(xpa(1)+xpa(-1)-xpa(2)-xpa(-2))
 return
end function db_ubu_d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DIS invariant mass !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
double precision function W2(x,Q2)
 implicit none
 double precision x,Q2
 W2 = 0.88d0 + Q2*(1d0/x-1d0)
 return
end function W2
