!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

subroutine s78HERA_JHEP0110_sigrCCp
 implicit none
 integer::i,j,n=20,orderp=3
 integer,parameter::m78HERA_JHEP0110_sigrCCp=34
 double precision,parameter::Q2bins(10)=(/300d0,500d0,1000d0,1500d0,2000d0,3000d0,5000d0,8000d0,15000d0,30000d0/),sqrts=319d0
 double precision,dimension(34)::x,y,Q2,data,err
 double precision xlp,ylp,sigrCCpl,sigrCCp
 external sigrCCp
 5 format(E10.3,f10.4,f10.0,2f10.4)
 6 format(i2,E10.3,f10.4,f10.0,2f10.4)
 !Predictions
 write(*,*)
 write(*,*) 'sigrCCp predictions:'
 open(101,file='Tag/78HERA_JHEP0110_sigrCCp/GJR_sigrCCp_300.dat')
 open(102,file='Tag/78HERA_JHEP0110_sigrCCp/GJR_sigrCCp_500.dat')
 open(103,file='Tag/78HERA_JHEP0110_sigrCCp/GJR_sigrCCp_1000.dat')
 open(104,file='Tag/78HERA_JHEP0110_sigrCCp/GJR_sigrCCp_1500.dat')
 open(105,file='Tag/78HERA_JHEP0110_sigrCCp/GJR_sigrCCp_2000.dat')
 open(106,file='Tag/78HERA_JHEP0110_sigrCCp/GJR_sigrCCp_3000.dat')
 open(107,file='Tag/78HERA_JHEP0110_sigrCCp/GJR_sigrCCp_5000.dat')
 open(108,file='Tag/78HERA_JHEP0110_sigrCCp/GJR_sigrCCp_8000.dat')
 open(109,file='Tag/78HERA_JHEP0110_sigrCCp/GJR_sigrCCp_15000.dat')
 do j = 1,9
    do i = 5,n-1
       xlp = 10**(orderp*(dble(i)/dble(n)-1.))!n points logarithmically distributed up to orderp 
       ylp = Q2bins(j)/xlp/sqrts**2d0
       if (ylp>1d0) cycle
       sigrCCpl = sigrCCp(xlp,ylp,Q2bins(j))
       write(*,5) xlp,ylp,Q2bins(j),sigrCCpl,0d0
       write(100+j,5) xlp,ylp,Q2bins(j),sigrCCpl,0d0
    end do
 end do
 close(101)
 close(102)
 close(103)
 close(104)
 close(105)
 close(106)
 close(107)
 close(108)
 close(109)
 !Reading and writing data
 write(*,*) 
 write(*,*) '78HERA_JHEP0110_sigrCCp data:'
 write(*,*) '  Reading...'
 write(*,*)   
 open(11,file='../../.dato/78HERA_JHEP0110_sigrCCp.dato')
 open(101,file='Tag/78HERA_JHEP0110_sigrCCp/78HERA_JHEP0110_sigrCCp_300.dat')
 open(102,file='Tag/78HERA_JHEP0110_sigrCCp/78HERA_JHEP0110_sigrCCp_500.dat')
 open(103,file='Tag/78HERA_JHEP0110_sigrCCp/78HERA_JHEP0110_sigrCCp_1000.dat')
 open(104,file='Tag/78HERA_JHEP0110_sigrCCp/78HERA_JHEP0110_sigrCCp_1500.dat')
 open(105,file='Tag/78HERA_JHEP0110_sigrCCp/78HERA_JHEP0110_sigrCCp_2000.dat')
 open(106,file='Tag/78HERA_JHEP0110_sigrCCp/78HERA_JHEP0110_sigrCCp_3000.dat')
 open(107,file='Tag/78HERA_JHEP0110_sigrCCp/78HERA_JHEP0110_sigrCCp_5000.dat')
 open(108,file='Tag/78HERA_JHEP0110_sigrCCp/78HERA_JHEP0110_sigrCCp_8000.dat')
 open(109,file='Tag/78HERA_JHEP0110_sigrCCp/78HERA_JHEP0110_sigrCCp_15000.dat')
 do i = 1, m78HERA_JHEP0110_sigrCCp
    read(11,*) x(i),y(i),Q2(i),data(i),err(i)
    write(*,6) i,x(i),y(i),Q2(i),data(i),err(i)
    do j = 1,9
       if (dabs(Q2(i)-Q2bins(j))<1d-10) write(100+j,5) x(i),y(i),Q2(i),data(i),err(i)
    end do
 end do
 close(101)
 close(102)
 close(103)
 close(104)
 close(105)
 close(106)
 close(107)
 close(108)
 close(109)
 return
end subroutine s78HERA_JHEP0110_sigrCCp
