!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

subroutine nonsinglet
 use master
 implicit none
 integer::i
 integer,parameter::n=100,orderp=5
 double precision::x,Q2=1d4
 double precision::xuvl,xdvl,xdeltal,xsml
 double precision::Dxuv,Dxdv,Dxdelta,Dxsm
 double precision,external::xuv,xdv,xdelta,xsm,err
 10 format(E11.4,4x,8ES13.5)
 write(*,*)
 write(*,*) "  NONSINGLET:"
 open(11,file='Tag/nonsinglet/nonsinglet.dat')
 do i = 1,n
    x = 10d0**(orderp*(dble(i)/dble(n)-1d0))!n points logarithmically distributed up to orderp 
    xuvl = xuv(x,Q2)
    xdvl = xdv(x,Q2)
    xdeltal = xdelta(x,Q2)
    xsml = xsm(x,Q2)
    Dxuv = err(xuv,x,Q2)
    Dxdv = err(xdv,x,Q2)
    Dxdelta = err(xdelta,x,Q2)
    Dxsm = err(xsm,x,Q2)
    write(11,10) x,xuvl,Dxuv,xdvl,Dxdv,xdeltal,Dxdelta,xsml,Dxsm
    write(*,10)  x,xuvl,Dxuv,xdvl,Dxdv,xdeltal,Dxdelta,xsml,Dxsm
 end do 
 close(11)      
end subroutine nonsinglet
