!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

subroutine singlet
 use master
 implicit none
 integer::i
 integer,parameter::n=100,orderp=5
 double precision::x,Q2=1d4
 double precision::xupl,xdpl,xspl,xgll,xqSl
 double precision::Dxup,Dxdp,Dxsp,Dxgl,DxqS
 double precision,external::xup,xdp,xsp,xgl,xqS,err
 10 format(E11.4,4x,10ES13.5)
 write(*,*)
 write(*,*) "  singlet:"
 open(11,file='Tag/singlet/singlet.dat')
 do i = 1,n
    x = 10d0**(orderp*(dble(i)/dble(n)-1d0))!n points logarithmically distributed up to orderp
    xupl = xup(x,Q2)
    xdpl = xdp(x,Q2)
    xspl = xsp(x,Q2)
    xgll = xgl(x,Q2)
    xqSl = xqS(x,Q2)
    Dxup = err(xup,x,Q2)
    Dxdp = err(xdp,x,Q2)
    Dxsp = err(xsp,x,Q2)
    Dxgl = err(xgl,x,Q2)
    DxqS = err(xqS,x,Q2)
    write(11,10) x,xupl,Dxup,xdpl,Dxdp,xspl,Dxsp,xgll,Dxgl,xqSl,DxqS
    write(*,10)  x,xupl,Dxup,xdpl,Dxdp,xspl,Dxsp,xgll,Dxgl,xqSl,DxqS
 end do 
 close(11)      
end subroutine singlet
