!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

program fitter
 use database
 use master
 implicit none
 logical::lmreset,done(nerror)=.false.
 integer,parameter::lwa=nlm*nerror+5*nerror+nlm
 integer::nused,i,j,k,m,n,iflag=0,iwa(nerror),info,ierr,iteration,iscale
 double precision::chi2,xlm(nerror),fvec(nlm),fvec0(nlm),wa(lwa),tol=1d-5,change=1d0,fjac(nlm,nerror)=0d0,wafjac(nlm)
 double precision::fv1(nerror),fv2(nerror)
 double precision::H(nerror,nerror),evalue(nerror),evector(nerror,nerror),MM(nerror,nerror)
 double precision::ep(nerror),Dhat(nerror,nerror),cor(nerror,nerror),Dchi2=1d0,errmax,sum1,sum2,grad(nerror)
 double precision::fveci(nlm,nerror),Dchi2error(nerror),HI(nerror,nerror)
 character*2 file
 character*18 time
 save change
 external fcn
 common /lmresetc/ lmreset
 open(6,file="../../interface/fitter.log")
 write(6,*)
 3 format(a,i3,a,ES6.0)
 write(6,3) " FITTER: initializing with ",nerror," parameters, tolerance ",tol
 call setfree
 write(6,*)
 if (sum(free)/=nerror) then
    write(6,*) "FITTER: problems with number of free parameters",sum(free),nerror
    stop
 end if
 call dater(0,nused)
!  write(6,*)
!  open(1,file='../../../free.dat')
!  read(1,*) p
!  close(1)
!  call initialize(0,Tagorder)
!  call predice
!  call chisq(0,nused,chi2)
 1 format(2i1)
 write(file,1) 0,0
 open(1,file='../../interface/'//file//'.dat')
 read(1,*) p
 close(1)
 write(6,*)
 call initialize(0,Tagorder)
 call predice
 call chisq(1,nused,chi2)
 flush(6)
 !goto 101
 open(1,file='../../interface/'//file//'.dat')
 2 format(f30.10)
 write(1,2) p
 close(1)
 write(6,*)
 write(6,*) "FITTER: searching for the minimum ..."
 j = 0
 do i = 1,npara
    if (free(i)/= 1) cycle
    j = j+1
    xlm(j)=p(i)
 end do
 9 format(a,i1)
 do while(change>tol)
    write(6,*)
    rescaled=.false.
    lmreset=.true.
    change=sum(fvec**2d0)
    call lmdif1(fcn,nlm,nerror,xlm,fvec,tol,info,iwa,wa,lwa)
    write(6,9) " FITTER: iteration finished with info = ",info
    change=dabs((sum(fvec**2d0)-change)/change)
 end do
 write(6,*)
 write(6,*) "FITTER: search finished"
 write(6,*)
 j = 0
 do i = 1,npara
    if (free(i) == 1) then
       j = j+1
       p(i)=xlm(j)
    end if
 end do
 call initialize(0,Tagorder)
 rescaled=.false.
 call predice
 call chisq(1,nused,chi2)
 open(1,file='../../interface/'//file//'.dat')
 write(1,2) p
 close(1)
 !goto 201
 !101 continue
 perror=0d0
 perror(:,0) =  p
 write(6,*)
 write(6,*) "FITTER: gradient in parameter space"
 j = 0
 do i = 1,npara
    if (free(i)/= 1) cycle
    j = j+1
    xlm(j)=p(i)
 end do
 call fcn(nlm,nerror,xlm,fvec0,iflag)
 call fdjac2(fcn,nlm,nerror,xlm,fvec0,fjac,nlm,iflag,0d0,wafjac)
 grad=0d0
 do i = 1,nlm
    do j = 1,nerror
       grad(j) = grad(j) + 2d0*fvec0(i)*fjac(i,j)
    end do
 end do
 12 format(250ES9.1)
 write(*,12) grad
 write(6,*)
 write(6,*) "FITTER: eigenvalues of the Hessian"
 H=0d0
 do i = 1,nlm
    do j = 1,nerror
       do k = 1,nerror
          H(j,k) = H(j,k) + 2d0*fjac(i,j)*fjac(i,k)
       end do
    end do
 end do
 call rs(nerror,nerror,H,evalue,1,evector,fv1,fv2,ierr)
 if (ierr/=0) then
    write(6,*) "FITTER: error in eigencalculation"
    stop
 end if
 do i=1,nerror
    if(evalue(i)>0d0) cycle
    write(6,*) "FITTER: Hessian not positive definite"
    stop
 end do
 errmax = 0.d0
 do i = 1, nerror
    do j = 1, nerror
       sum1 = 0.d0
       sum2 = 0.d0
       do k = 1, nerror
          sum1 = sum1 + evector(k,i)*evector(k,j)
          sum2 = sum2 + evector(i,k)*evector(j,k)
       end do
       if(i/=j) then
          errmax = max(errmax,abs(sum1),abs(sum2))
       else
          errmax = max(errmax,abs(sum1-1.d0),abs(sum2-1.d0))
       end if
    end do
 end do
 if(abs(errmax) .gt. 1.e-5) then
    write(*,*) "FITTER: eigenvectors not orthogonal, zero = ",errmax
    stop
 end if
 MM=0d0
 do i = 1,nerror
    do k = 1,nerror
       MM(i,k) = evector(i,k)*dsqrt(2d0/evalue(k))
    end do
 end do
 write(6,12) evalue
 write(6,*)
 write(6,*) "FITTER: delta chisq values for the eigenvector sets"
 do iteration=0,99
    Dchi2error=0d0
    done = .false.
    do iscale=0,99
       do i=1,nerror
          if (dabs(Dchi2error(i)-1d0)<0.01d0) done(i) = .true.
       end do
       if((sum(merge(1,0,done)) == nerror).and.(iscale==1)) goto 1000
       if (sum(merge(1,0,done)) == nerror) exit
       do k = 1,nerror
          if(done(k)) cycle
          if(iscale>0) MM(:,k)=MM(:,k)/dsqrt(dsqrt(Dchi2error(k)))
          j=0
          do i=1,npara
             perror(i,k)= perror(i,0)
             if(free(i)/=1) cycle
                j = j + 1
                perror(i,k)= perror(i,k) + dsqrt(Dchi2)*MM(j,k)
          end do
          p=perror(:,k)
          n=0
          do m = 1,npara
             if (free(m)/= 1) cycle
             n = n + 1
             xlm(n)=p(m)
          end do
          call fcn(nlm,nerror,xlm,fveci(:,k),iflag)
          perror(:,k)=p
       end do
       do i = 1,nerror
          do k = 1, nlm
             fjac(k,i) = (fveci(k,i) - fvec0(k))/dsqrt(Dchi2)
          end do
       end do
       Dchi2error=(/(sum(fveci(:,i)**2d0)-sum(fvec0**2d0),i=1,nerror)/)/Dchi2
       62 format(250f9.2)
       write(6,62) Dchi2error(1:nerror)
       flush(6)
    end do
    write(*,*)
    if(iteration == 0) goto 1000
    HI=0d0
    do i = 1,nlm
       do j = 1,nerror
          do k = 1,nerror
             HI(j,k) = HI(j,k) + 2d0*fjac(i,j)*fjac(i,k)
          end do
       end do
    end do
    H = 0d0
    do i = 1,nerror
       do j = 1,nerror
          do m = 1,nerror
             do n = 1,nerror
                H(i,j) = H(i,j) + 0.5d0*dsqrt(evalue(m)*evalue(n))*HI(m,n)*evector(i,m)*evector(j,n)
             end do
          end do
       end do
    end do
    call rs(nerror,nerror,H,evalue,1,evector,fv1,fv2,ierr)
    if (ierr/=0) then
       write(6,*) "FITTER: error in eigencalculation"
       stop
    end if
    do i=1,nerror
       if(evalue(i)>0d0) cycle
       write(6,*) "FITTER: Hessian not positive definite"
       stop
    end do
    errmax = 0.d0
    do i = 1, nerror
       do j = 1, nerror
          sum1 = 0.d0
          sum2 = 0.d0
          do k = 1, nerror
             sum1 = sum1 + evector(k,i)*evector(k,j)
             sum2 = sum2 + evector(i,k)*evector(j,k)
          end do
          if(i/=j) then
             errmax = max(errmax,abs(sum1),abs(sum2))
          else
             errmax = max(errmax,abs(sum1-1.d0),abs(sum2-1.d0))
          end if
       end do
    end do
    if(abs(errmax) .gt. 1.e-5) then
       write(*,*) "FITTER: eigenvectors not orthogonal, zero = ",errmax
       stop
    end if
    MM=0d0
    do i = 1,nerror
       do k = 1,nerror
          MM(i,k) = evector(i,k)*dsqrt(2d0/evalue(k))
       end do
    end do
 end do
 1000 continue
 40 format(f30.10)
 open(10,file='../../interface/00.dat')
 do j=0,nerror
    write(10,40) perror(:,j)
    write(10,*)
 end do
 close(10)
 ep=0d0
 do i=1,nerror
    ep(i) = dsqrt(Dchi2)*dsqrt(sum(MM(i,:)**2d0))
 end do
 cor=0d0
 do k = 1,nerror
    do i = 1,nerror
       do j = 1,nerror
          cor(i,j) = cor(i,j) + Dchi2*MM(i,k)*MM(j,k)/ep(i)/ep(j)
       end do
    end do
 end do
 Dhat=0d0
 do i=1,nerror
    do k=1,nerror
       Dhat(i,k)=MM(i,k)/ep(i)
    end do
 end do
 102 format(a)
 write(6,*)
 write(6,*) "FITTER: components of the unit gradient of the parameters"
 write(6,102) " indices    Dhat01 Dhat02 Dhat03 Dhat04 Dhat05 Dhat06 Dhat07 Dhat08 Dhat09 Dhat10 ..."
 j=0
 do i=1,npara
    if(free(i)/=1) cycle
    j = j + 1
    51 format(i3,1x,i3,3x,150f7.2)
    write(6,51) i,j,Dhat(j,:)
 end do
 write(6,*)
 write(6,*) "FITTER: parameter errors and correlation coefficients"
 write(6,102) " indices  parameter    error    cori01 cori02 cori03 cori04 cori05 cori06 cori07 cori08 cori09 cori10 ..."
 j=0
 do i=1,npara
    if(free(i)/=1) cycle
    j = j + 1
    50 format(i3,1x,i3,3x,f9.4,1x,f9.4,1x,150f7.2)
    write(6,50) i,j,perror(i,0),ep(j),cor(j,:)
 end do
 !201 continue
 call ccpu_time(time)
 write(6,*)
 500 format(a,a18)
 write(6,500) " FITTER: finished, time = ",time
 write(6,*)
 close(6)
 stop
end program fitter

subroutine fdjac2(fcn,m,n,x,fvec,fjac,ldfjac,iflag,epsfcn,wa)
 use master
 use database
 implicit none
 integer m,n,ldfjac,iflag,i,j,k,nstepc
 logical stepout
 integer,save::nstep=0
 double precision epsfcn,temp
 double precision x(n),fvec(m),fjac(ldfjac,n),wa(m)
 common /stepc/ stepout,nstepc
 epsfcn = epsfcn
 nstep = nstepc
 stepout = .false.
 if ((m/=nlm).or.(ldfjac/=nlm)) then
    write(*,*) "FDJAC2: Problems with number of points",m,nlm,ldfjac
    stop
 end if
 if (n/=nerror) then
    write(*,*) "FDJAC2: Problems with number of parameters",n,nerror
    stop
 end if
 j = 0
 do i = 1,npara
    if (free(i)/= 1) cycle
    if (hp(i) == 0d0) then
       write(*,*) "FDJAC2: Set step for derivatives of parameter ",i
       stop
    end if
    j = j+1
    temp = x(j)
    x(j) = temp + hp(i)
    call fcn(m,n,x,wa,iflag)
    x(j) = temp
    do k = 1, m
       fjac(k,j) = (wa(k) - fvec(k))/hp(i)
    end do
 end do
 nstep = nstep+1
 nstepc = nstep
 stepout = .true.
 return
end subroutine fdjac2

subroutine fcn(m,n,x,fvec,iflag)
 use master
 use database
 implicit none
 logical::lmreset,stepout=.true.
 integer m,n,iflag,nusedl,i,j,nstepc
 integer,save::ncall=0
 double precision::x(n),fvec(m),chi2,f,fbest=1d10
 character*2 file
 character*18 time
 common /lmresetc/ lmreset
 common /stepc/ stepout,nstepc
 iflag = iflag
 if(lmreset) then
    nstepc = 0
    ncall = 0
    fbest = 1d10
    lmreset = .false.
 end if
 j = 0
 do i = 1,npara
    if (free(i) /= 1) cycle
    j = j+1
    p(i) = x(j)
 end do
 call initialize(0,Tagorder)
 call predice
 call chisq(0,nusedl,chi2)
! write(6,*) ncall,chi2
! flush(6)
 if (m/=lmcount) then
    write(6,*) "LMFCN: Problems with point counters",m,lmcount
    stop
 end if
 fvec=lmfvec
 f = chi2
 if (f <= fbest) then
     1 format(2i1)
     write(file,1) 0,0
     open(10,file='../../interface/'//file//'.dat')
     50 format(f30.10)
     write(10,50) p
     close(10)
     call ccpu_time(time)
     if ((fbest-f)/dble(nusedl) > 1d-5) then
        500 format(a,i2,a,i3,a,f6.4,a,a18)
        if (stepout) write(6,500) " CHISQ: step ",nstepc,", call ",ncall,", chi2 = ",chi2/dble(nusedl),", time = ",time
        flush(6)
     end if
     fbest = f
  end if
  ncall = ncall+1
 return
end subroutine fcn
