!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright 2005 - 2014 Pedro Jimenez-Delgado
! 
! This file is part of Chromopolis.
! 
! Chromopolis is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Chromopolis is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Chromopolis.  If not, see <http://www.gnu.org/licenses/>.

module database
 implicit none
 logical::rescaled=.false.
 integer,parameter::nsets=158,ntotal=27698,nlm=6074
 integer::npoints(nsets)=0,ncumul(0:nsets),ncorra(nsets)=0,ncorrm(nsets)=0,lmcount=0
 double precision::corr(-2:113,ntotal)=0d0,unc(-1:1,ntotal)=0d0,lmfvec(nlm)=0d0
 double precision,dimension(ntotal)::xdata,ydata,x1data,x2data,Q2data,m2data,Edata,aceptance,ETdata,pTdata,pTmindata,pTmaxdata,&
                                     theory,data,rescale
 logical::touse(nsets),used(ntotal)=.false.
 character*132::text(nsets)
end module database

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine dater(oflag,nused)
 use database
 implicit none
 integer oflag,i,ncount,nused
 double precision::Q2cut=1d0,W2cut=3.5d0,pQ2cut=1d0,pW2cut=3.5d0
 double precision,external::W2
 logical,external::logic
 11 format(a16,i5,2f10.3)
 12 format(i5,f10.6,f10.3,2f9.4)
 13 format(i5,2f10.6,f10.3,2f12.6)
 14 format(i5,2f10.6,f10.3,2f9.4)
 16 format(i5,5d12.4)
 17 format(i5,6d12.5)
 18 format(a13,i5,a8,i4,a17,i4,a)
 nused=0
 ncount=0
 !01SLAC_PLB282_F2p
 text(1) = "01SLAC_PLB282_F2p              ; L. W. Whitlow et al., Phys. Lett., B282 (1992) 475"
 npoints(1) = 211
 touse(1) = .false.
 if (oflag==2) then
     write(6,*)
     write(6,*) " 01SLAC_PLB282_F2p data:"
 end if
 open(11,file="../../.dato/01SLAC_PLB282_F2p.dato")
 do i = ncount+1,ncount+npoints(1)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(1)
       corr(0,i) = 0.01d0*2.1d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(1))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(1))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(1)
 !02BCDMS_PLB223_F2p
 text(2) = "02BCDMS_PLB223_F2p             ;A. C. Benvenuti et al., Phys. Lett., B223 (1989) 485"
 npoints(2) = 178
 touse(2) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 02BCDMS_PLB223_F2p data:"
 end if
 open(11,file="../../.dato/02BCDMS_PLB223_F2p.dato")
 do i = ncount+1,ncount+npoints(2)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(2)
       corr(0,i) = 0.01d0*3d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(2))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(2))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(2)
 !03E665_PRD54_F2p
 text(3) = "03E665_PRD54_F2p               ;M. R. Adams et al. Phys. Rev., D54 (1996) 3006"
 npoints(3) = 91
 touse(3) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 03E665_PRD54_F2p data:"
 end if
 open(11,file="../../.dato/03E665_PRD54_F2p.dato")
 do i = ncount+1,ncount+npoints(3)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(3)
       corr(0,i) = 0.01d0*1.8d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(3))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(3))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(3)
 !04NMC_NPB483_F2p
 text(4) = "04NMC_NPB483_F2p               ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(4) = 158
 touse(4) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 04NMC_NPB483_F2p data:"
 end if
 open(11,file="../../.dato/04NMC_NPB483_F2p.dato")
 do i = ncount+1,ncount+npoints(4)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(4)
       corr(0,i) = 0.01d0*2.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(4))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(4))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(4)
 !05H1_NPB470_F2p
 text(5) = "05H1_NPB470_F2p                ;S. Aid et al., Nucl. Phys., B470 (1996) 3"
 npoints(5) = 193
 touse(5) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 05H1_NPB470_F2p data:"
 end if
 open(11,file="../../.dato/05H1_NPB470_F2p.dato")
 do i = ncount+1,ncount+npoints(5)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(5)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(5))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(5))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(5)
 !06H1_NPB497_F2p
 text(6) = "06H1_NPB497_F2p                ;C. Adloff et al., Nucl. Phys., B497 (1997) 3"
 npoints(6) = 44
 touse(6) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 06H1_NPB497_F2p data:"
 end if
 open(11,file="../../.dato/06H1_NPB497_F2p.dato")
 do i = ncount+1,ncount+npoints(6)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(6)
       corr(0,i) = 0.01d0*3d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(6))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(6))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(6)
 !07H1_EPJC13_F2p
 text(7) = "07H1_EPJC13_F2p                ;C. Adloff et al., Eur. Phys. J., C13 (2000) 609"
 npoints(7) = 130
 touse(7) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 07H1_EPJC13_F2p data:"
 end if
 open(11,file="../../.dato/07H1_EPJC13_F2p.dato")
 do i = ncount+1,ncount+npoints(7)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(7)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(7))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(7))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(7)
 !08H1_EPJC19_F2p
 text(8) = "08H1_EPJC19_F2p                ;C. Adloff et al., Eur. Phys. J., C19 (2001) 269"
 npoints(8) = 126
 touse(8) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 08H1_EPJC19_F2p data:"
 end if
 open(11,file="../../.dato/08H1_EPJC19_F2p.dato")
 do i = ncount+1,ncount+npoints(8)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(8)
       corr(0,i) = 0.01d0*1.8d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(8))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(8))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(8)
 !09H1_EPJC21_F2p
 text(9) = "09H1_EPJC21_F2p                ;C. Adloff et al., Eur. Phys. J., C21 (2001) 33"
 npoints(9) = 133
 touse(9) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 09H1_EPJC21_F2p data:"
 end if
 open(11,file="../../.dato/09H1_EPJC21_F2p.dato")
 do i = ncount+1,ncount+npoints(9)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(9)
       corr(0,i) = 0.01d0*1.7d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(9))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(9))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(9)
 !10H1_EPJC30_F2p
 text(10) = "10H1_EPJC30_F2p               ;C. Adloff et al., Eur. Phys. J., C30 (2003) 1"
 npoints(10) = 132
 touse(10) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 10H1_EPJC30_F2p data:"
 end if
 open(11,file="../../.dato/10H1_EPJC30_F2p.dato")
  do i = ncount+1,ncount+npoints(10)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(10)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(10))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(10))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(10)
 !11ZEUS_ZPC69_F2p
 text(11) = "11ZEUS_ZPC69_F2p              ;M. Derrick et al., Z. Phys., C69 (1996) 607"
 npoints(11) = 23
 touse(11) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 11ZEUS_ZPC69_F2p data:"
 end if
 open(11,file="../../.dato/11ZEUS_ZPC69_F2p.dato")
 do i = ncount+1,ncount+npoints(11)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(11)
       corr(0,i) = 0.01d0*3d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(11))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(11))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(11)
 !12ZEUS_ZPC72_F2p
 text(12) = "12ZEUS_ZPC72_F2p              ;M. Derrick et al., Z. Phys., C72 (1996) 399"
 npoints(12) = 188
 touse(12) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 12ZEUS_ZPC72_F2p data:"
 end if
 open(11,file="../../.dato/12ZEUS_ZPC72_F2p.dato")
 do i = ncount+1,ncount+npoints(12)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(12)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(12))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(12))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(12)
 !13ZEUS_EPJC21_F2p
 text(13) = "13ZEUS_EPJC21_F2p             ;S. Chekanov et al., Eur. Phys. J., C21 (2001) 443"
 npoints(13) = 242
 touse(13) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 13ZEUS_EPJC21_F2p data:"
 end if
 open(11,file="../../.dato/13ZEUS_EPJC21_F2p.dato")
 do i = ncount+1,ncount+npoints(13)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(13)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(13))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(13))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
  end do
 close(11)
 ncount=ncount+npoints(13)
 !14BCDMS_PLB237_F2np
 text(14) = "14BCDMS_PLB237_F2np           ;A. C. Benvenuti et al., Phys. Lett., B237 (1990) 599"
 npoints(14) = 11
 touse(14) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 14BCDMS_PLB237_F2np data:"
 end if
 open(11,file="../../.dato/14BCDMS_PLB237_F2np.dato")
 do i = ncount+1,ncount+npoints(14)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(14)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(14))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(14))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(14)
 !15E665_PRL75_F2np
 text(15) = "15E665_PRL75_F2np             ;M. R. Adams et al., Phys. Rev. Lett, 75 (1995) 1466"
 npoints(15) = 22
 touse(15) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 15E665_PRL75_F2np data:"
 end if
 open(11,file="../../.dato/15E665_PRL75_F2np.dato")
 do i = ncount+1,ncount+npoints(15)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(15)
       corr(0,i) = 0.01d0*1d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(15))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(15))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(15)
 !16NMC_NPB487_F2dp
 text(16) = "16NMC_NPB487_F2dp             ;M. Arneodo et al, Nucl. Phys., B487 (1997) 3"
 npoints(16) = 20
 touse(16) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 16NMC_NPB487_F2dp data:"
 end if
 open(11,file="../../.dato/16NMC_NPB487_F2dp.dato")
 do i = ncount+1,ncount+npoints(16)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(16)
       corr(0,i) = 0.01d0*0.15d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(16))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(16))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(16)
 !17EMC_NPB213_F2Fec
 text(17) = "17EMC_NPB213_F2Fec            ;J. J . Aubert et al., Nucl. Phys., B213 (1983) 31"
 npoints(17) = 21
 touse(17) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 17EMC_NPB213_F2Fec data:"
 end if
 open(11,file="../../.dato/17EMC_NPB213_F2Fec.dato")
 do i = ncount+1,ncount+npoints(17)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) > 10d0).and.(Q2data(i) < 70d0)) then
       used(i) = touse(17)
       corr(0,i) = 0.01d0*11d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(17))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(17))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
  ncount=ncount+npoints(17)
 !18ZEUS_EPJC12_F2pc
 text(18) = "18ZEUS_EPJC12_F2pc            ;J. Breitweg et al., Eur. Phys. J., C12 (2000) 35"
 npoints(18) = 21
 touse(18) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 18ZEUS_EPJC12_F2pc data:"
 end if
 open(11,file="../../.dato/18ZEUS_EPJC12_F2pc.dato")
 do i = ncount+1,ncount+npoints(18)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(18)
       corr(0,i) = 0.01d0*9d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(18))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(18))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(18)
 !19ZEUS_PRD69_F2pc
 text(19) = "19ZEUS_PRD69_F2pc             ;S. Chekanov et al., Phys. Rev., D69 (2004) 012004"
 npoints(19) = 31
 touse(19) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 19ZEUS_PRD69_F2pc data:"
 end if
 open(11,file="../../.dato/19ZEUS_PRD69_F2pc.dato")
 do i = ncount+1,ncount+npoints(19)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(19)
       corr(0,i) = 0.01d0*2.2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(19))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(19))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(19)
 !20H1_PLB528_F2pc
 text(20) = "20H1_PLB528_F2pc              ;C. Adloff et al., Phys. Lett., B528 (2002) 199"
 npoints(20) = 12
 touse(20) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 20H1_PLB528_F2pc data:"
 end if
 open(11,file="../../.dato/20H1_PLB528_F2pc.dato")
 do i = ncount+1,ncount+npoints(20)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(20)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(20))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(20))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(20)
 !21H1_EPJC40_F2pc
 text(21) = "21H1_EPJC40_F2pc              ;A. Atkas et al., Eur. Phys. J., C40 (2005) 349"
 npoints(21) = 4
 touse(21) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 21H1_EPJC40_F2pc data:"
 end if
 open(11,file="../../.dato/21H1_EPJC40_F2pc.dato")
 do i = ncount+1,ncount+npoints(21)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(21)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(21))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(21))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(21)
 !22H1_EPJC45_F2pc
 text(22) = "22H1_EPJC45_F2pc              ;A. Atkas et al., Eur. Phys. J., C45 (2006) 23"
 npoints(22) = 6
 ncorrm(22) = 8
 touse(22) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 22H1_EPJC45_F2pc data:"
 end if
 open(11,file="../../.dato/22H1_EPJC45_F2pc.dato")
 do i = ncount+1,ncount+npoints(22)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i),corr(1:8,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(22)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(22))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(22))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(22)
 !23H1_EPJC40_F2pb
 text(23) = "23H1_EPJC40_F2pb              ;A. Atkas et al., Eur. Phys. J., C40 (2005) 349"
 npoints(23) = 4
 touse(23) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 23H1_EPJC40_F2pb data:"
 end if
 open(11,file="../../.dato/23H1_EPJC40_F2pb.dato")
 do i = ncount+1,ncount+npoints(23)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(23)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(23))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(23))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(23)
 !24H1_EPJC45_F2pb
 text(24) = "24H1_EPJC45_F2pb              ;A. Atkas et al., Eur. Phys. J., C45 (2006) 23"
 npoints(24) = 6
 ncorrm(24) = 8
 touse(24) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 24H1_EPJC45_F2pb data:"
 end if
 open(11,file="../../.dato/24H1_EPJC45_F2pb.dato")
 do i = ncount+1,ncount+npoints(24)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i),corr(1:8,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(24)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(24))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(24))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(24)
 !25E605_PRD43_DYpCu
 text(25) = "25E605_PRD43_DYpCu            ;G. Moreno et al. Phys. Rev., D43 (1991) 2815"
 npoints(25) = 136
 touse(25) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 25E605_PRD43_DYpCu data:"
 end if
 open(11,file="../../.dato/25E605_PRD43_DYpCu.dato")
 do i = ncount+1,ncount+npoints(25)
    read(11,*) x1data(i),x2data(i),m2data(i),data(i),unc(0,i),unc(1,i)
    used(i) = touse(25)
    corr(0,i) = 0.01d0*15d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(25))) write(6,13) i,x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(25)
 !26E866_Private_DYpp
 text(26) = "26E866_Private_DYpp           ;J. Webb, FERMILAB-THESIS-2002-56,hep-ex/0301031; P. E. Reimer,Private comm.,rad. corr.)"
 npoints(26) = 184
 touse(26) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 26E866_Private_DYpp data:"
 end if
 open(11,file="../../.dato/26E866_Private_DYpp.dato")
 do i = ncount+1,ncount+npoints(26)
    read(11,*) x1data(i),x2data(i),m2data(i),data(i),unc(0,i),unc(1,i)
    if(unc(0,i)/data(i)<=0.25d0) then
       used(i) = touse(26)
       corr(0,i) = 0.01d0*6.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(26))) write(6,13) i,x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(26))) write(6,11) " Data rejected: ",i,Q2data(i),unc(0,i)
    end if
 end do
 close(11)
 ncount=ncount+npoints(26)
 !27E866_Private_DYpd
 text(27) = "27E866_Private_DYpd           ;J. Webb FERMILAB-THESIS-2002-56,hep-ex/0301031; P. E. Reimer,Private comm., rad. corr.)"
 npoints(27) = 191
 touse(27) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 27E866_Private_DYpd data:"
 end if
 open(11,file="../../.dato/27E866_Private_DYpd.dato")
 do i = ncount+1,ncount+npoints(27)
    read(11,*) x1data(i),x2data(i),m2data(i),data(i),unc(0,i),unc(1,i)
    if(unc(0,i)/data(i)<=0.25d0) then
       used(i) = touse(27)
       corr(0,i) = 0.01d0*6.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(27))) write(6,13) i,x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(27))) write(6,11) " Data rejected: ",i,Q2data(i),unc(0,i)
    end if
 end do
 close(11)
 ncount=ncount+npoints(27)
 !28NA51_PLB332_ADY
 text(28) = "28NA51_PLB332_ADY             ;A. Baldit et al., Phys. Lett., B332 (1994) 244"
 npoints(28) = 1
 touse(28) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 28NA51_PLB332_ADY data:"
 end if
 open(11,file="../../.dato/28NA51_PLB332_ADY.dato")
 do i = ncount+1,ncount+npoints(28)
    read(11,*) x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
    used(i) = touse(28)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(28))) write(6,14) i,x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(28)
 !29E866_PRL80_DYd2p
 text(29) = "29E866_PRL80_DYd2p            ;E. A. Hawker et al., Phys. Rev. Lett., 80 (1998) 3715"
 npoints(29) = 11
 touse(29) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 29E866_PRL80_DYd2p data:"
 end if
 open(11,file="../../.dato/29E866_PRL80_DYd2p.dato")
 do i = ncount+1,ncount+npoints(29)
    read(11,*) x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
    used(i) = touse(29)
    corr(0,i) = 0.01d0*1d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(29))) write(6,14) i,x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(29)
 !30E866_PRD64_DYd2p
 text(30) = "30E866_PRD64_DYd2p            ;R. S. Towell et al., Phys. Rev., D64 (2001) 052002"
 npoints(30) = 15
 touse(30) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 30E866_PRD64_DYd2p data:"
 end if
 open(11,file="../../.dato/30E866_PRD64_DYd2p.dato")
 do i = ncount+1,ncount+npoints(30)
    read(11,*) x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
    used(i) = touse(30)
    corr(0,i) = 0.01d0*0.6d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(30))) write(6,14) i,x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(30)
 !31CDHSW_ZPC25_dvuv
 text(31) = "31CDHSW_ZPC25_dvuv            ;H. Abramowicz et al. Z. Phys., C25 (1984) 29"
 npoints(31) = 7
 touse(31) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 31CDHSW_ZPC25_dvuv data:"
 end if
 open(11,file="../../.dato/31CDHSW_ZPC25_dvuv.dato")
 do i = ncount+1,ncount+npoints(31)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(31)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(31))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(31)
 !32WA21_ZPC62_dvuv
 text(32) = "32WA21_ZPC62_dvuv             ;G. T. Jones et al., Z. Phys., C62 (1994) 601"
 npoints(32) = 10
 touse(32) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 32WA21_ZPC62_dvuv data:"
 end if
 open(11,file="../../.dato/32WA21_ZPC62_dvuv.dato")
 do i = ncount+1,ncount+npoints(32)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(32)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(32))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(32)
 !33NA51_PLB332_dbub
 text(33) = "33NA51_PLB332_dbub            ;A. Baldit et al., Phys. Lett., B332 (1994) 244"
 npoints(33) = 1
 touse(33) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 33NA51_PLB332_dbub data:"
 end if
 open(11,file="../../.dato/33NA51_PLB332_dbub.dato")
 do i = ncount+1,ncount+npoints(33)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(33)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(33))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(33)
 !34HERMES_PRL81_db-ub
 text(34) = "34HERMES_PRL81_db-ub          ;K. Ackerstaff et al., Phys. Rev. Lett., 81 (1998) 5519"
 npoints(34) = 5
 touse(34) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 34HERMES_PRL81_db-ub data:"
 end if
 open(11,file="../../.dato/34HERMES_PRL81_db-ub.dato")
 do i = ncount+1,ncount+npoints(34)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(34)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(34))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(34)
 !35HERMES_PRL81_db-ubu-d
 text(35) = "35HERMES_PRL81_db-ubu-d       ;K. Ackerstaff et al., Phys. Rev. Lett., 81 (1998) 5519"
 npoints(35) = 5
 touse(35) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 35HERMES_PRL81_db-ubu-d data:"
 end if
 open(11,file="../../.dato/35HERMES_PRL81_db-ubu-d.dato")
 do i = ncount+1,ncount+npoints(35)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(35)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(35))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(35)
 !36E866_PRD64_dbub
 text(36) = "36E866_PRD64_dbub             ;R. S. Towell et al., Phys. Rev., D64 (2001) 052002"
 npoints(36) = 15
 touse(36) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 36E866_PRD64_dbub data:"
 end if
 open(11,file="../../.dato/36E866_PRD64_dbub.dato")
 do i = ncount+1,ncount+npoints(36)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(36)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(36))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(36)
 !37E866_PRD64_db-ub
 text(37) = "37E866_PRD64_db-ub            ;R. S. Towell et al., Phys. Rev., D64 (2001) 052002"
 npoints(37) = 15
 touse(37) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 37E866_PRD64_db-ub data:"
 end if
 open(11,file="../../.dato/37E866_PRD64_db-ub.dato")
 do i = ncount+1,ncount+npoints(37)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(37)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(37))) write(6,16) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(37)
 !38H1EPJC21_FLpp
 text(38) = "38H1EPJC21_FLpp               ;C. Adloff et al., Eur. Phys. J., C21 (2001) 33"
 npoints(38) = 17
 touse(38) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 38H1EPJC21_FLpp data:"
 end if
 open(11,file="../../.dato/38H1_EPJC21_FLpp.dato")
 do i = ncount+1,ncount+npoints(38)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(38)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(38))) write(6,16) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(38)
 !39H1EPJC30_FLpp
 text(39) = "39H1EPJC30_FLpp               ;C. Adloff et al., Eur. Phys. J., C30 (2003) 1"
 npoints(39) = 5
 touse(39) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 39H1EPJC30_FLpp data:"
 end if
 open(11,file="../../.dato/39H1_EPJC30_FLpp.dato")
 do i = ncount+1,ncount+npoints(39)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(39)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(39))) write(6,16) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(39)
 !40H1EPJC30_FLpm
 text(40) = "40H1EPJC30_FLpm               ;C. Adloff et al., Eur. Phys. J., C30 (2003) 1"
 npoints(40) = 5
 touse(40) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 40H1EPJC30_FLpm data:"
 end if
 open(11,file="../../.dato/40H1_EPJC30_FLpm.dato")
 do i = ncount+1,ncount+npoints(40)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    used(i) = touse(40)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(40))) write(6,16) i,xdata(i),Q2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(40)
 !41H1_EPJC13_sigrp
 text(41) = "41H1_EPJC13_sigrp             ;C. Adloff et al., Eur. Phys. J., C13 (2000) 609"
 npoints(41) = 130
 touse(41) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 41H1_EPJC13_sigrp data:"
 end if
 open(11,file="../../.dato/41H1_EPJC13_sigrp.dato")
 do i = ncount+1,ncount+npoints(41)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(41)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(41))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(41))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(41)
 !42H1_EPJC19_sigrm
 text(42) = "42H1_EPJC19_sigrm             ;C. Adloff et al., Eur. Phys. J., C19 (2001) 269"
 npoints(42) = 126
 touse(42) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 42H1_EPJC19_sigrm data:"
 end if
 open(11,file="../../.dato/42H1_EPJC19_sigrm.dato")
 do i = ncount+1,ncount+npoints(42)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(42)
       corr(0,i) = 0.01d0*1.8d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(42))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(42))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(42)
 !43H1_EPJC21_sigrp
 text(43) = "43H1_EPJC21_sigrp             ;C. Adloff et al., Eur. Phys. J., C21 (2001) 33"
 npoints(43) = 147
 touse(43) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 43H1_EPJC21_sigrp data:"
 end if
 open(11,file="../../.dato/43H1_EPJC21_sigrp.dato")
 do i = ncount+1,ncount+npoints(43)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(43)
       corr(0,i) = 0.01d0*1.7d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(43))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(43))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(43)
 !44H1_EPJC30_sigrp
 text(44) = "44H1_EPJC30_sigrp             ;C. Adloff et al., Eur. Phys. J., C30 (2003) 1"
 npoints(44) = 147
 touse(44) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 44H1_EPJC30_sigrp data:"
 end if
 open(11,file="../../.dato/44H1_EPJC30_sigrp.dato")
  do i = ncount+1,ncount+npoints(44)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(44)
       corr(0,i) = 0.01d0*1.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(44))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(44))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(44)
 !45ZEUS_EPJC21_sigrp
 text(45) = "45ZEUS_EPJC21_sigrp           ;S. Chekanov et al., Eur. Phys. J., C21 (2001) 443"
 npoints(45) = 242
 touse(45) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 45ZEUS_EPJC21_sigrp data:"
 end if
 open(11,file="../../.dato/45ZEUS_EPJC21_sigrp.dato")
 do i = ncount+1,ncount+npoints(45)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(45)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(45))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(45))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
  end do
 close(11)
 ncount=ncount+npoints(45)
 !46fastNLO_fnt1001
 text(46) = "46fastNLO_fnt1001             ;A. A. Affolder et al., Phys. Rev., D64 (2001) 032001"
 npoints(46) = 33
! ncorrm(46) = 7
 touse(46) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 46fastNLO_fnt1001 data:"
 end if
 open(11,file="../../.dato/46fastNLO_fnt1001.dato")
 do i = ncount+1,ncount+npoints(46)
    read(11,*) ETdata(i),data(i),unc(0,i),unc(1,i)!corr(1:7,i)
    used(i) = touse(46)
    corr(0,i) = 0.01d0*4.6d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(46))) write(6,16) i,ETdata(i),data(i),unc(0,i)
  end do
 close(11)
 ncount=ncount+npoints(46)
 !47fastNLO_fnt1002
 text(47) = "47fastNLO_fnt1002             ;B. Abbott et al., Phys. Rev. Lett., 86 (2001) 1707"
 npoints(47) = 90
 touse(47) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 47fastNLO_fnt1002 data:"
 end if
 open(11,file="../../.dato/47fastNLO_fnt1002.dato")
 do i = ncount+1,ncount+npoints(47)
    read(11,*) ETdata(i),data(i),unc(0,i),unc(1,i)
    used(i) = touse(47)
    corr(0,i) = 0.01d0*6d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(47))) write(6,16) i,ETdata(i),data(i)
  end do
 close(11)
 ncount=ncount+npoints(47)
 !48fastNLO_fnt2002
 text(48) = "48fastNLO_fnt2002             ;A. Abulencia et al., Phys. Rev. D74 (2006) 071103"
 npoints(48) = 20
 touse(48) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 48fastNLO_fnt2002 data:"
 end if
 open(11,file="../../.dato/48fastNLO_fnt2002.dato")
 do i = ncount+1,ncount+npoints(48)
    read(11,*) pTdata(i),data(i),unc(0,i),unc(1,i)
    used(i) = touse(48)
    corr(0,i) = 0.01d0*6d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(48))) write(6,16) i,pTdata(i),data(i)
  end do
 close(11)
 ncount=ncount+npoints(48)
 !49JLab_PRC80_F2p
 text(49) = "49JLab_PRC80_F2p              ;S. Malace et al.,Phys. Rev. C80 (2009) 035207"
 npoints(49) = 261
 ncorrm(49) = 1
 touse(49) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 49JLab_PRC80_F2p data:"
 end if
 open(11,file="../../.dato/49JLab_PRC80_F2p.dato")
 do i = ncount+1,ncount+npoints(49)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),corr(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(49)
       corr(0,i) = 0.01d0*1.75d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(49))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(49))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(49)
 !50JLab_PRC80_F2d
 text(50) = "50JLab_PRC80_F2d              ;S. Malace et al.,Phys. Rev. C80 (2009) 035207"
 npoints(50) = 265
 ncorrm(50) = 1
 touse(50) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 50JLab_PRC80_F2d data:"
 end if
 open(11,file="../../.dato/50JLab_PRC80_F2d.dato")
 do i = ncount+1,ncount+npoints(50)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),corr(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(50)
       corr(0,i) = 0.01d0*1.75d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(50))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(50))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(50)
 !51NMC_NPB483_F2p_90
 text(51) = "51NMC_NPB483_F2p_90           ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(51) = 73
 touse(51) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 51NMC_NPB483_F2p_90 data:"
 end if
 open(11,file="../../.dato/51NMC_NPB483_F2p_90.dato")
 do i = ncount+1,ncount+npoints(51)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(51)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(51))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(51))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(51)
 !52NMC_NPB483_F2_120p
 text(52) = "52NMC_NPB483_F2_120p          ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(52) = 65
 touse(52) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 52NMC_NPB483_F2p_120 data:"
 end if
 open(11,file="../../.dato/52NMC_NPB483_F2p_120.dato")
 do i = ncount+1,ncount+npoints(52)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(52)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(52))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(52))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(52)
 !53NMC_NPB483_F2p_200
 text(53) = "53NMC_NPB483_F2p_200          ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(53) = 75
 touse(53) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 53NMC_NPB483_F2p_200 data:"
 end if
 open(11,file="../../.dato/53NMC_NPB483_F2p_200.dato")
 do i = ncount+1,ncount+npoints(53)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(53)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(53))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(53))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(53)
 !54NMC_NPB483_F2p_280
 text(54) = "54NMC_NPB483_F2p_280          ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(54) = 79
 touse(54) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 54NMC_NPB483_F2p_280 data:"
 end if
 open(11,file="../../.dato/54NMC_NPB483_F2p_280.dato")
 do i = ncount+1,ncount+npoints(54)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(54)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(54))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(54))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(54)
 !55SLAC_PLB282_sigrpCO
 text(55) = "55SLAC_PLB282_sigrpCO         ; L. W. Whitlow et al., Phys. Lett., B282 (1992) 475"
 npoints(55) = 661
 ncorrm(55) = 25
 touse(55) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 55SLAC_PLB282_sigrpCO data:"
 end if
 open(11,file="../../.dato/55SLAC_PLB282_sigrpCO.dato")
 do i = ncount+1,ncount+npoints(55)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),unc(1,i),corr(1:25,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(55)
       corr(0,i) = 0.01d0*2.1d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(56))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(56))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(55)
 !56NMC_NPB483_sigp_90
 text(56) = "56NMC_NPB483_sigp_90          ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(56) = 73
 touse(56) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 56NMC_NPB483_sigp_90 data:"
 end if
 open(11,file="../../.dato/56NMC_NPB483_sigp_90.dato")
 do i = ncount+1,ncount+npoints(56)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(56)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(56))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(56))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(56)
 !57NMC_NPB483_sig_120p
 text(57) = "57NMC_NPB483_sig_120p         ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(57) = 65
 touse(57) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 57NMC_NPB483_sigp_120 data:"
 end if
 open(11,file="../../.dato/57NMC_NPB483_sigp_120.dato")
 do i = ncount+1,ncount+npoints(57)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(57)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(57))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(57))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(57)
 !58NMC_NPB483_sigp_200
 text(58) = "58NMC_NPB483_sigp_200         ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(58) = 75
 touse(58) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 58NMC_NPB483_sigp_200 data:"
 end if
 open(11,file="../../.dato/58NMC_NPB483_sigp_200.dato")
 do i = ncount+1,ncount+npoints(58)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(58)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(58))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(58))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(58)
 !59NMC_NPB483_sigp_280
 text(59) = "59NMC_NPB483_sigp_280         ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(59) = 79
 touse(59) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 59NMC_NPB483_sigp_280 data:"
 end if
 open(11,file="../../.dato/59NMC_NPB483_sigp_280.dato")
 do i = ncount+1,ncount+npoints(59)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(59)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(59))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(59))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(59)
 !60E866_PRD64_DYd2p
 text(60) = "60E866_PRD64_DYd2p            ;R. S. Towell et al., Phys. Rev., D64 (2001) 052002;Separated masses for systematics"
 npoints(60) = 39
 ncorrm(60) = 0
 touse(60) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 60E866_PRD64_DYd2p data:"
 end if
 open(11,file="../../.dato/60E866_PRD64_DYd2p.dato")
 do i = ncount+1,ncount+npoints(60)
    read(11,*) x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
    used(i) = touse(60)
    corr(0,i) = 0d0
    if ((ncount<i).and.(i<=ncount+15)) then
       unc(1,i) = 0.01d0*0.97d0*data(i)
!        corr(1,i) = 0.01d0*0.69d0*data(i)
!        corr(2,i) = 0.01d0*0.2d0*data(i)
!        corr(3,i) = 0.01d0*0.1d0*data(i)
!        corr(4,i) = 0.01d0*0.2d0*data(i)
!        corr(5,i) = 0.01d0*0.61d0*data(i)
    else if ((ncount+15<i).and.(i<=ncount+29)) then
       unc(1,i) = 0.01d0*0.94d0*data(i)
!        corr(1,i) = 0.01d0*0.89d0*data(i)
!        corr(2,i) = 0.01d0*0.2d0*data(i)
!        corr(3,i) = 0.01d0*0.1d0*data(i)
!        corr(4,i) = 0.01d0*0.2d0*data(i)
!        corr(5,i) = 0.01d0*0d0*data(i)
    else if ((ncount+29<i).and.(i<=ncount+39)) then
       unc(1,i) = 0.01d0*0.87d0*data(i)
!        corr(1,i) = 0.01d0*0.82d0*data(i)
!        corr(2,i) = 0.01d0*0.2d0*data(i)
!        corr(3,i) = 0.01d0*0.1d0*data(i)
!        corr(4,i) = 0.01d0*0.2d0*data(i)
!        corr(5,i) = 0.01d0*0d0*data(i)
    end if
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(60))) write(6,14) i,x1data(i),x2data(i),m2data(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(60)
 !61NMC_NPB483_F2d_90
 text(61) = "61NMC_NPB483_F2d_90           ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(61) = 73
 touse(61) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 61NMC_NPB483_F2d_90 data:"
 end if
 open(11,file="../../.dato/61NMC_NPB483_F2d_90.dato")
 do i = ncount+1,ncount+npoints(61)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(61)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(61))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(61))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(61)
 !62NMC_NPB483_F2d_120
 text(62) = "62NMC_NPB483_F2d_120          ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(62) = 65
 touse(62) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 62NMC_NPB483_F2d_120 data:"
 end if
 open(11,file="../../.dato/62NMC_NPB483_F2d_120.dato")
 do i = ncount+1,ncount+npoints(62)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(62)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(62))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(62))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(62)
 !63NMC_NPB483_F2d_200
 text(63) = "63NMC_NPB483_F2d_200          ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(63) = 75
 touse(63) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 63NMC_NPB483_F2d_200 data:"
 end if
 open(11,file="../../.dato/63NMC_NPB483_F2d_200.dato")
 do i = ncount+1,ncount+npoints(63)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(63)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(63))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(63))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(63)
 !64NMC_NPB483_F2d_280
 text(64) = "64NMC_NPB483_F2d_280          ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(64) = 79
 touse(64) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 64NMC_NPB483_F2d_280 data:"
 end if
 open(11,file="../../.dato/64NMC_NPB483_F2d_280.dato")
 do i = ncount+1,ncount+npoints(64)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(64)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(64))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(64))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(64)
 !65SLAC_PLB282_sigrdCO
 text(65) = "65SLAC_PLB282_sigrdCO         ; L. W. Whitlow et al., Phys. Lett., B282 (1992) 475"
 npoints(65) = 691
 ncorrm(65) = 33
 touse(65) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 65SLAC_PLB282_sigrdCO data:"
 end if
 open(11,file="../../.dato/65SLAC_PLB282_sigrdCO.dato")
 do i = ncount+1,ncount+npoints(65)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),unc(1,i),corr(1:33,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(65)
       corr(0,i) = 0.01d0*1.7d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(67))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(65))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(65)
 !66NMC_NPB483_sigd_90
 text(66) = "66NMC_NPB483_sigd_90          ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(66) = 73
 touse(66) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 66NMC_NPB483_sigd_90 data:"
 end if
 open(11,file="../../.dato/66NMC_NPB483_sigd_90.dato")
 do i = ncount+1,ncount+npoints(66)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(66)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(66))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(66))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(66)
 !67NMC_NPB483_sigd_120
 text(67) = "67NMC_NPB483_sigd_120         ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(67) = 65
 touse(67) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 67NMC_NPB483_sigd_120 data:"
 end if
 open(11,file="../../.dato/67NMC_NPB483_sigd_120.dato")
 do i = ncount+1,ncount+npoints(67)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(67)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(67))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(67))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(67)
 !68NMC_NPB483_sigd_200
 text(68) = "68NMC_NPB483_sigd_200         ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(68) = 75
 touse(68) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 68NMC_NPB483_sigd_200 data:"
 end if
 open(11,file="../../.dato/68NMC_NPB483_sigd_200.dato")
 do i = ncount+1,ncount+npoints(68)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(68)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(68))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(68))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(68)
 !69NMC_NPB483_sigd_280
 text(69) = "69NMC_NPB483_sigd_280         ;M. Arneodo et al. Nucl. Phys., B483 (1997) 3"
 npoints(69) = 79
 touse(69) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 69NMC_NPB483_sigd_280 data:"
 end if
 open(11,file="../../.dato/69NMC_NPB483_sigd_280.dato")
 do i = ncount+1,ncount+npoints(69)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(69)
       corr(0,i) = 0.01d0*2d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(69))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(69))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(69)
 !70SLAC_PLB282_F2d
 text(70) = "70SLAC_PLB282_F2d             ;L. W. Whitlow et al., Phys. Lett., B282 (1992) 475"
 npoints(70) = 211
 touse(70) = .false.
 if (oflag==2) then
     write(6,*)
     write(6,*) " 70SLAC_PLB282_F2d data:"
 end if
 open(11,file="../../.dato/70SLAC_PLB282_F2d.dato")
 do i = ncount+1,ncount+npoints(70)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(70)
       corr(0,i) = 0.01d0*1.7d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(70))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(70))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(70)
 !71NuTeV_PRL99_sigplnu
 text(71) = "71NuTeV_PRL99_sigplnu         ;D. Mason et al. Phys. Rev. Let. 99 (2007) 192001"
 npoints(71) = 45
 touse(71) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 71NuTeV_PRL99_sigplnu:"
 end if
 open(11,file="../../.dato/71NuTeV_PRL99_sigplnu.dato")
 do i = ncount+1,ncount+npoints(71)
    read(11,*) xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
    used(i) = touse(71)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(71))) write(6,17) i,xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
  end do
 close(11)
 ncount=ncount+npoints(71)
 !72NuTeV_PRL99_sigplnub
 text(72) = "72NuTeV_PRL99_sigplnub        ;D. Mason et al. Phys. Rev. Let. 99 (2007) 192001"
 npoints(72) = 45
 touse(72) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 72NuTeV_PRL99_sigplnub:"
 end if
 open(11,file="../../.dato/72NuTeV_PRL99_sigplnub.dato")
 do i = ncount+1,ncount+npoints(72)
    read(11,*) xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
    used(i) = touse(72)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(72))) write(6,17) i,xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
  end do
 close(11)
 ncount=ncount+npoints(72)
 !73CCFR_PRD64_sigplnu
 text(73) = "73CCFR_PRD64_sigplnu          ;M. Goncharov et al. Phys. Rev. D64 (2001) 112006"
 npoints(73) = 45
 touse(73) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 73CCFR_PRD64_sigplnu:"
 end if
 open(11,file="../../.dato/73CCFR_PRD64_sigplnu.dato")
 do i = ncount+1,ncount+npoints(73)
    read(11,*) xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
    used(i) = touse(73)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(73))) write(6,17) i,xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
  end do
 close(11)
 ncount=ncount+npoints(73)
 !74CCFR_PRD64_sigplnub
 text(74) = "74CCFR_PRD64_sigplnub         ;M. Goncharov et al. Phys. Rev. D64 (2001) 112006"
 npoints(74) = 45
 touse(74) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 74CCFR_PRD64_sigplnub:"
 end if
 open(11,file="../../.dato/74CCFR_PRD64_sigplnub.dato")
 do i = ncount+1,ncount+npoints(74)
    read(11,*) xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
    used(i) = touse(74)
    corr(0,i) = 0.01d0*0d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(74))) write(6,17) i,xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
  end do
 close(11)
 ncount=ncount+npoints(74)
 !75BCDMS_PLB237_F2d
 text(75) = "75BCDMS_PLB237_F2d            ;A. C. Benvenuti et al., Phys. Lett., B237 (1990) 592"
 npoints(75) = 159
 touse(75) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 75BCDMS_PLB237_F2d data:"
 end if
 open(11,file="../../.dato/75BCDMS_PLB237_F2d.dato")
 do i = ncount+1,ncount+npoints(75)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(75)
       corr(0,i) = 0.01d0*3d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(75))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(75))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(75)
 !76HERA_JHEP0110_sigrNCp
 text(76) = "76HERA_JHEP0110_sigrNCp       ;F. D. Aaron et al. JHEP01(2010) 109"
 npoints(76) = 528
 touse(76) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 76HERA_JHEP0110_sigrNCp data:"
 end if
 open(11,file="../../.dato/76HERA_JHEP0110_sigrNCp.dato")
 do i = ncount+1,ncount+npoints(76)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(76)
       corr(0,i) = 0.01d0*0.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(76))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(76))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(76)
 !77HERA_JHEP0110_sigrNCm
 text(77) = "77HERA_JHEP0110_sigrNCm       ;F.D. Aaron et al. JHEP01(2010) 109"
 npoints(77) = 145
 touse(77) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 77HERA_JHEP0110_sigrNCm data:"
 end if
 open(11,file="../../.dato/77HERA_JHEP0110_sigrNCm.dato")
 do i = ncount+1,ncount+npoints(77)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(77)
       corr(0,i) = 0.01d0*0.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(77))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(77))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(77)
 !78HERA_JHEP0110_sigrCCp
 text(78) = "78HERA_JHEP0110_sigrCCp       ;F. D. Aaron et al. JHEP01(2010) 109"
 npoints(78) = 34
 touse(78) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 78HERA_JHEP0110_sigrCCp data:"
 end if
 open(11,file="../../.dato/78HERA_JHEP0110_sigrCCp.dato")
 do i = ncount+1,ncount+npoints(78)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(78)
       corr(0,i) = 0.01d0*0.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(78))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(78))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(78)
 !79HERA_JHEP0110_sigrCCm
 text(79) = "79HERA_JHEP0110_sigrCCm       ;F. D. Aaron et al. JHEP01(2010) 109"
 npoints(79) = 34
 touse(79) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 79HERA_JHEP0110_sigrCCm data:"
 end if
 open(11,file="../../.dato/79HERA_JHEP0110_sigrCCm.dato")
 do i = ncount+1,ncount+npoints(79)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(79)
       corr(0,i) = 0.01d0*0.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(79))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(79))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(79)
 !80E665_PRD54_F2d
 text(80) = "80E665_PRD54_F2d              ;M. R. Adams et al. Phys. Rev., D54 (1996) 3006"
 npoints(80) = 91
 touse(80) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 80E665_PRD54_F2d data:"
 end if
 open(11,file="../../.dato/80E665_PRD54_F2d.dato")
 do i = ncount+1,ncount+npoints(80)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(80)
       corr(0,i) = 0.01d0*1.9d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(80))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(80))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(80)
 !81HERA_JHEP0110_sigrCO
 text(81) = "81HERA_JHEP0110_sigrCO        ;F. D. Aaron et al. JHEP01(2010) 109;Sets 76-79 combined for correlations"
 npoints(81) = 741
 ncorrm(81) = 113
 touse(81) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 81HERA_JHEP0110_sigrCO data:"
 end if
 open(11,file="../../.dato/81HERA_JHEP0110_sigrCO.dato")
 do i = ncount+1,ncount+npoints(81)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),unc(1,i),corr(1:113,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(81)
       corr(0,i) = 0.01d0*0.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(81))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(81))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(81)
 !82E665_PRD54_F2CO
 text(82) = "82E665_PRD54_F2CO             ;M. R. Adams et al. Phys. Rev., D54 (1996) 3006;Sets 3,80 combined for correlations"
 npoints(82) = 182
 ncorrm(82) = 7
 touse(82) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 82E665_PRD54_F2CO data:"
 end if
 open(11,file="../../.dato/82E665_PRD54_F2CO.dato")
 do i = ncount+1,ncount+npoints(82)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),corr(1:7,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(82)
       if (i<=ncount+91) then
          corr(0,i) = 0.01d0*1.8d0*data(i)
       else if (i>ncount+91) then
          corr(0,i) = 0.01d0*1.9d0*data(i)
       end if
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(82))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(82))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(82)
 !83NMC_NPB483_sigrCO
 text(83) = "83NMC_NPB483_sigrCO           ;Arneodo et al. Nucl. Phys., B483 (1997) 3;Sets 56-59,66-69 combined for correlations"
 npoints(83) = 584
 ncorrm(83) = 19
 touse(83) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 83NMC_NPB483_sigrCO data:"
 end if
 open(11,file="../../.dato/83NMC_NPB483_sigrCO.dato")
 do i = ncount+1,ncount+npoints(83)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(8:19,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(83)
       if ((ncount<i).and.(i<=ncount+npoints(56))) then
          corr(0,i) = 0.01d0*2d0*data(i) !N90p
       else if ((ncount+npoints(56)<i).and.(i<=ncount+npoints(56)+npoints(57))) then
          corr(1,i) = 0.01d0*2d0*data(i) !N120p
       else if ((ncount+npoints(56)+npoints(57)<i).and.(i<=ncount+npoints(56)+npoints(57)+npoints(58))) then
          corr(2,i) = 0.01d0*2d0*data(i) !N200p
       else if ((ncount+npoints(56)+npoints(57)+npoints(58)<i).and.(i<=ncount+npoints(56)+npoints(57)+npoints(58)+npoints(59))) then
          corr(3,i) = 0.01d0*2d0*data(i) !N280p
       else if ((ncount+292<i).and.(i<=ncount+292+npoints(66))) then
          corr(4,i) = 0.01d0*2d0*data(i) !N90d
       else if ((ncount+292+npoints(66)<i).and.(i<=ncount+292+npoints(66)+npoints(67))) then
          corr(5,i) = 0.01d0*2d0*data(i) !N120d
       else if ((ncount+292+npoints(66)+npoints(67)<i).and.(i<=ncount+292+npoints(66)+npoints(67)+npoints(68))) then
          corr(6,i) = 0.01d0*2d0*data(i) !N200d
       else if ((ncount+292+npoints(66)+npoints(67)+npoints(68)<i).and.(i<=ncount+npoints(83))) then
          corr(7,i) = 0.01d0*2d0*data(i) !N280d
       end if
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(83))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(83))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(83)
 !84BCDMS_PLB223_sigrpCO
 text(84) = "84BCDMS_PLB223_sigrpCO        ;A. C. Benvenuti et al., Phys. Lett., B223 (1989) 485;Separated energies for correlation"
 npoints(84) = 351
 ncorrm(84) = 9
 touse(84) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 84BCDMS_PLB223_F2pCO data:"
 end if
 open(11,file="../../.dato/84BCDMS_PLB223_sigrpCO.dato")
 do i = ncount+1,ncount+npoints(84)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(5:9,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(84)
       corr(0,i) = 0.01d0*3d0*data(i)
       if ((ncount<i).and.(i<=ncount+97)) then
          corr(1,i) = 0.01d0*1d0*data(i) !Relative 100
       else if ((ncount+97<i).and.(i<=ncount+196)) then
          corr(2,i) = 0.01d0*1d0*data(i) !Relative 120
       else if ((ncount+196<i).and.(i<=ncount+275)) then
          corr(3,i) = 0.01d0*0d0*data(i) !Relative 200 (reference)
       else if ((ncount+275<i).and.(i<=ncount+351)) then
          corr(4,i) = 0.01d0*1d0*data(i) !Relative 280
       end if
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(84))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(84))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(84)
 !85BCDMS_PLB237_sigrdCO
 text(85) = "85BCDMS_PLB237_sigrdCO        ;A. C. Benvenuti et al., Phys. Lett., B237 (1990) 592;Separated energies for correlation"
 npoints(85) = 254
 ncorrm(85) = 8
 touse(85) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 85BCDMS_PLB237_F2dCO data:"
 end if
 open(11,file="../../.dato/85BCDMS_PLB237_sigrdCO.dato")
 do i = ncount+1,ncount+npoints(85)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(4:8,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(85)
       corr(0,i) = 0.01d0*3d0*data(i)
       if ((ncount<i).and.(i<=ncount+99)) then
          corr(1,i) = 0.01d0*1d0*data(i) !Relative 120
       else if ((ncount+99<i).and.(i<=ncount+178)) then
          corr(2,i) = 0.01d0*0d0*data(i) !Relative 200 (reference)
       else if ((ncount+178<i).and.(i<=ncount+254)) then
          corr(3,i) = 0.01d0*1.5d0*data(i) !Relative 280
       end if
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(85))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(85))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(85)
 !86NMC_NPB487_F2dpCO
 text(86) = "86NMC_NPB487_F2dpCO           ;M. Arneodo et al, Nucl. Phys., B487 (1997) 3"
 npoints(86) = 260
 ncorrm(86) = 5
 touse(86) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 86NMC_NPB487_F2dpCO data:"
 end if
 open(11,file="../../.dato/86NMC_NPB487_F2dpCO.dato")
 do i = ncount+1,ncount+npoints(86)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i),corr(1:5,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(86)
       corr(0,i) = 0.01d0*0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(16))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(16))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(86)
 !87H1_EPJC71_F2p
 text(87) = "87H1_EPJC71_F2p               ;F.D. Aaron et al., Eur. Phys. J., C71 (2011) 1579"
 npoints(87) = 64
 ncorrm(87) = 1
 touse(87) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 87H1_EPJC71_F2p data:"
 end if
 open(11,file="../../.dato/87H1_EPJC71_F2p.dato")
 do i = ncount+1,ncount+npoints(87)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i),corr(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(87)
       corr(0,i) = 0.01d0*0.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(87))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(87))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(87)
 !88H1_EPJC71_FLp
 text(88) = "88H1_EPJC71_FLp               ;F.D. Aaron et al., Eur. Phys. J., C71 (2011) 1579"
 npoints(88) = 64
 ncorrm(88) = 1
 touse(88) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 88H1_EPJC71_FLp data:"
 end if
 open(11,file="../../.dato/88H1_EPJC71_FLp.dato")
 do i = ncount+1,ncount+npoints(88)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i),corr(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(88)
       corr(0,i) = 0.01d0*0.5d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(88))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(88))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(88)
 !89H1EPJC71_F2pc
 text(89) = "89H1_EPJC71_F2pc              ;F.D. Aaron et al., Eur. Phys. J., C71 (2011) 1769"
 npoints(89) = 25
 ncorrm(89) = 1
 touse(89) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 89H1_EPJC71_F2pc data:"
 end if
 open(11,file="../../.dato/89H1_EPJC71_F2pc.dato")
 do i = ncount+1,ncount+npoints(89)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i),corr(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(89)
       corr(0,i) = 0.01d0*0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(89))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(89))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(89)
 !90combined_dimuon_sigpl
 text(90) = "90combined_dimuon_sigpl       ;sets 71,72,73,74 combined for correlations"
 npoints(90) = npoints(71)+npoints(72)+npoints(73)+npoints(74)!180
 ncorrm(90) = 8
 touse(90) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 90combined_dimuon_sigpl:"
 end if
 open(11,file="../../.dato/71NuTeV_PRL99_sigplnu.dato")
 do i = ncount+1,ncount+npoints(71)
    read(11,*) xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i),corr(1:8,i)
    used(i) = touse(90)
    corr(0,i) = 0.01d0*12.1212d0*data(i)!Bc error 0.012/0.099
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(90))) write(6,17) i,xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
  end do
 close(11)
 open(11,file="../../.dato/72NuTeV_PRL99_sigplnub.dato")
 do i = ncount+npoints(71)+1,ncount+npoints(71)+npoints(72)
    read(11,*) xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i),corr(1:8,i)
    used(i) = touse(90)
    corr(0,i) = 0.01d0*12.1212d0*data(i)!Bc error 0.012/0.099
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(90))) write(6,17) i,xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
  end do
 close(11)
 open(11,file="../../.dato/73CCFR_PRD64_sigplnu.dato")
 do i = ncount+npoints(71)+npoints(72)+1,ncount+npoints(71)+npoints(72)+npoints(73)
    read(11,*) xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i),unc(1,i)
    used(i) = touse(90)
    corr(0,i) = 0.01d0*12.1212d0*data(i)!Bc error 0.012/0.099
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(90))) write(6,17) i,xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
  end do
 close(11)
 open(11,file="../../.dato/74CCFR_PRD64_sigplnub.dato")
 do i = ncount+npoints(71)+npoints(72)+npoints(73)+1,ncount+npoints(90)
    read(11,*) xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i),unc(1,i)
    used(i) = touse(90)
    corr(0,i) = 0.01d0*12.1212d0*data(i)!Bc error 0.012/0.099
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(90))) write(6,17) i,xdata(i),ydata(i),Edata(i),aceptance(i),data(i),unc(0,i)
  end do
 close(11)
 ncount=ncount+npoints(90)
 !91JLab_PRC80_sigp
 text(91) = "91JLab_PRC80_sigp             ;S. Malace et al.,Phys. Rev. C80 (2009) 035207"
 npoints(91) = 261
 ncorrm(91) = 0
 touse(91) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 91JLab_PRC80_sigp data:"
 end if
 open(11,file="../../.dato/91JLab_PRC80_sigp.dato")
 do i = ncount+1,ncount+npoints(91)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(91)
       corr(0,i) = 0.01d0*1.75d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(91))) write(6,12) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(91))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(91)
 !92JLab_PRC80_sigd
 text(92) = "92JLab_PRC80_sigd             ;S. Malace et al.,Phys. Rev. C80 (2009) 035207"
 npoints(92) = 261
 ncorrm(92) = 0
 touse(92) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 92JLab_PRC80_sigd data:"
 end if
 open(11,file="../../.dato/92JLab_PRC80_sigd.dato")
 do i = ncount+1,ncount+npoints(92)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(92)
       corr(0,i) = 0.01d0*1.75d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(92))) write(6,12) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(92))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(92)
 !93fastNLO_fnh2001
 text(93) = "93fastNLO_fnh2001             ;S. Chekanov et al., Nucl. Phys. B765 (2007) 1"
 npoints(93) = 30
 ncorrm(93) = 1
 touse(93) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 93fastNLO_fnh2001 data:"
 end if
 open(11,file="../../.dato/93fastNLO_fnh2001.dato")
 do i = ncount+1,ncount+npoints(93)
    read(11,*) ETdata(i),data(i),unc(0,i),unc(1,i),corr(1,i)
    used(i) = touse(93)
    corr(0,i) = 0.01d0*2.2d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(93))) write(6,16) ETdata(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(93)
 !94fastNLO_fnh2003
 text(94) = "94fastNLO_fnh2003             ; A. Aktas et al., Phys. Lett. B653 (2007) 134"
 npoints(94) = 24
 ncorrm(94) = 4
 touse(94) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 94fastNLO_fnh2003 data:"
 end if
 open(11,file="../../.dato/94fastNLO_fnh2003.dato")
 do i = ncount+1,ncount+npoints(94)
    read(11,*) ETdata(i),data(i),unc(0,i),unc(1,i),corr(1:4,i)
    used(i) = touse(94)
    corr(0,i) = 0.01d0*1.5d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(94))) write(6,16) i,ETdata(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(94)
 !95fastNLO_fnt2007
 text(95) = "95fastNLO_fnt2007             ;T. Aaltonen et al., Phys. Rev. D78 (2008) 052006"
 npoints(95) = 77
 ncorrm(95) = 24
 touse(95) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 95fastNLO_fnt2007 data:"
 end if
 open(11,file="../../.dato/95fastNLO_fnt2007.dato")
 do i = ncount+1,ncount+npoints(95)
    if ((i-ncount == 1).or.(i-ncount == 18).or.(i-ncount == 35).or.(i-ncount == 51).or.(i-ncount == 66)) cycle !do not exist but are calculated by fastNLO
    read(11,*) pTdata(i),data(i),unc(0,i),corr(1:24,i)
    used(i) = touse(95)
    if ((i-ncount == 16).or.(i-ncount == 17).or.(i-ncount == 33).or.(i-ncount == 34).or.(i-ncount == 50)) used(i) = .false. !large errors
    if ((i-ncount == 64).or.(i-ncount == 65).or.(i-ncount == 77)) used(i) = .false. !large errors
    corr(0,i) = 0.01d0*6d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(95))) write(6,16) i,pTdata(i),data(i),unc(0,i)
 end do
 close(11)
 ncount=ncount+npoints(95)
 !96fastNLO_fnt2009
 text(96) = "96fastNLO_fnt2009             ;V. M. Abazov et al., Phys. Rev. Lett. 101 (2008) 062001"
 npoints(96) = 110
 ncorrm(96) = 23
 touse(96) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 96fastNLO_fnt2009 data:"
 end if
 open(11,file="../../.dato/96fastNLO_fnt2009.dato")
 do i = ncount+1,ncount+npoints(96)
    read(11,*) pTdata(i),data(i),unc(0,i),unc(1,i),corr(1:23,i)
    used(i) = touse(96)
    if ((i-ncount == 21).or.(i-ncount == 22).or.(i-ncount == 23).or.(i-ncount == 43).or.(i-ncount == 44)) used(i) = .false. !large errors
    if ((i-ncount == 45).or.(i-ncount == 64).or.(i-ncount == 65).or.(i-ncount == 81).or.(i-ncount == 82)) used(i) = .false. !large errors
    if ((i-ncount == 96).or.(i-ncount == 97).or.(i-ncount == 109).or.(i-ncount == 110)) used(i) = .false. !large errors
    corr(0,i) = 0.01d0*6.1d0*data(i)
    if(used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(96))) write(6,16) i,pTdata(i),data(i),unc(0,i)
  end do
 close(11)
 ncount=ncount+npoints(96)
 !97HERA_EPJC73_sigrc
 text(97) = "97HERA_EPJC73_sigrc              ;Eur. Phys. J. C73 (2013) 2311"
 npoints(97) = 52
 ncorrm(97) = 2
 touse(97) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 97HERA_EPJC73_sigrc data:"
 end if
 open(11,file="../../.dato/97HERA_EPJC73_sigrc.dato")
 do i = ncount+1,ncount+npoints(97)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(1,i),corr(2,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(97)
       corr(0,i) = 0.01d0*0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(97))) write(6,12) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(97))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(97)
 !Empty 98-100
 !101SLAC_PRL51_Apap
 text(101) = "101SLAC_PRL51_Apap            ;G. Baum et al., Phys. Lett., 51 (1983) 1135"
 npoints(101) = 35
 touse(101) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 101SLAC_PRL51_Apap data:"
 end if
 open(11,file="../../.dato/101SLAC_PRL51_Apap.dato")
 do i = ncount+1,ncount+npoints(101)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(101)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(101))) write(6,16) i,xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(101))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(101)
 !102EMC_NPB328_A1p
 text(102) = "102EMC_NPB328_A1p             ;J. Ashman et al., Nucl. Phys., B328 (1989) 1"
 npoints(102) = 10
 ncorra(102) = 1
 ncorrm(102) = 2
 touse(102) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 102EMC_NPB328_A1p data:"
 end if
 open(11,file="../../.dato/102EMC_NPB328_A1p.dato")
 do i = ncount+1,ncount+npoints(102)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(-1,i),unc(1,i),corr(-1,i),corr(1,i),corr(2,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(102)
       corr(0,i) = 0.01d0*9.6d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(102))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(102))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(102)
 !103SMC_PRD58_A1p
 text(103) = "103SMC_PRD58_A1p              ;B. Adeva et al., Phys. Rev., D58 (1998) 112001"
 npoints(103) = 15
 ncorrm(103) = 3
 touse(103) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 103SMC_PRD58_A1p data:"
 end if
 open(11,file="../../.dato/103SMC_PRD58_A1p.dato")
 do i = ncount+1,ncount+npoints(103)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(-1,i),corr(0,i),corr(1,i),corr(2,i),corr(3,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(103)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(103))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(103))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(103)
 !104SMC_PRD60_A1p
 text(104) = "104SMC_PRD60_A1p              ;B. Adeva et al., Phys. Rev., D60 (1999) 072004"
 npoints(104) = 15
 ncorrm(104) = 3
 touse(104) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 104SMC_PRD60_A1p data:"
 end if
 open(11,file="../../.dato/104SMC_PRD60_A1p.dato")
 do i = ncount+1,ncount+npoints(104)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(-1,i),corr(0,i),corr(1,i),corr(2,i),corr(3,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(104)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(104))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(104))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(104)
 !105COMPASS_PLB690_A1p
 text(105) = "105COMPASS_PLB690_A1p         ;M. G. Alekseev et al., Phys. Lett., B690 (2010) 466"
 npoints(105) = 15
 touse(105) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 105COMPASS_PLB690_A1p data:"
 end if
 open(11,file="../../.dato/105COMPASS_PLB690_A1p.dato")
 do i = ncount+1,ncount+npoints(105)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(-1,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(105)
       corr(0,i) = 0.01d0*6d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(105))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(105))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(105)
 !106SLAC_PRD58_Apap
 text(106) = "106SLAC_PRD58_Apap            ;K. Abe et al., Phys. Rev., D58 (1998) 112003"
 npoints(106) = 159
 touse(106) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 106SLAC_PRD58_Apap data:"
 end if
 open(11,file="../../.dato/106SLAC_PRD58_Apap.dato")
 do i = ncount+1,ncount+npoints(106)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(106)
       corr(0,i) = 0.01d0*3.7d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(106))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(106))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(106)
 !107SLAC_PRD58_Apep
 text(107) = "107SLAC_PRD58_Apep            ;K. Abe et al., Phys. Rev., D58 (1998) 112003"
 npoints(107) = 50
 touse(107) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 107SLAC_PRD58_Apep data:"
 end if
 open(11,file="../../.dato/107SLAC_PRD58_Apep.dato")
 do i = ncount+1,ncount+npoints(107)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(107)
       corr(0,i) = 0.01d0*3.7d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(107))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(107))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(107)
 !108SLAC_PLB553_Apep
 text(108) = "108SLAC_PLB553_ApeE155xp      ;P.L.Anthony et al. Phys.Lett.B553(2003)18"
 npoints(108) = 133
 touse(108) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 108SLAC_PLB553_ApeE155xp data:"
 end if
 open(11,file="../../.dato/108SLAC_PLB553_ApeE155xp.dato")
 do i = ncount+1,ncount+npoints(108)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),unc(-1,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(108)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(108))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(108))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(108)
 !109HERMES_PRD75_Apap
 text(109) = "109HERMES_PRD75_Apap          ;A. Airapetian et al., Phys. Rev., D75 (2007) 012007"
 npoints(109) = 45
 touse(109) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 109HERMES_PRD75_Apap data:"
 end if
 open(11,file="../../.dato/109HERMES_PRD75_Apap.dato")
 do i = ncount+1,ncount+npoints(109)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(109)
       corr(0,i) = 0.01d0*0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(109))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(109))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(109)
 !110JLabHallB_PLB672_A1p
 text(110) = "110JLabHallB_PLB672_A1p       ;Y. Prok et al., Phys. Lett., B672 (2009) 12"
 npoints(110) = 6993
 touse(110) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 110JLabHallB_PLB672_A1p data:"
 end if
 open(11,file="../../.dato/110JLabHallB_PLB672_A1p.dato")
 do i = ncount+1,ncount+npoints(110)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(110)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(110))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(110))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(110)
 !111SMC_PRD58_A1d
 text(111) = "111SMC_PRD58_A1d              ;B. Adeva et al., Phys. Rev., D58 (1998) 112001"
 npoints(111) = 15
 ncorrm(111) = 3
 touse(111) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 111SMC_PRD58_A1d data:"
 end if
 open(11,file="../../.dato/111SMC_PRD58_A1d.dato")
 do i = ncount+1,ncount+npoints(111)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(-1,i),corr(0,i),corr(1,i),corr(2,i),corr(3,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(111)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(111))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(111))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(111)
 !112SMC_PRD60_A1d
 text(112) = "112SMC_PRD60_A1d              ;B. Adeva et al., Phys. Rev., D60 (1999) 072004"
 npoints(112) = 15
 ncorrm(112) = 3
 touse(112) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 112SMC_PRD60_A1d data:"
 end if
 open(11,file="../../.dato/112SMC_PRD60_A1d.dato")
 do i = ncount+1,ncount+npoints(112)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(-1,i),corr(0,i),corr(1,i),corr(2,i),corr(3,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(112)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(112))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(112))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(112)
 !113COMPASS_PLB647_A1d
 text(113) = "113COMPASS_PLB647_A1d         ;V.Yu. Alexakhin et al., Phys. Lett., B647 (2007) 8"
 npoints(113) = 17
 touse(113) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 113COMPASS_PLB647_A1d data:"
 end if
 open(11,file="../../.dato/113COMPASS_PLB647_A1d.dato")
 do i = ncount+1,ncount+npoints(113)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(-1,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(113)
       corr(0,i) = 0.01d0*10d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(113))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(113))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(113)
 !114SLAC_PRD58_Apad
 text(114) = "114SLAC_PRD58_Apad            ;K. Abe et al., Phys. Rev., D58 (1998) 112003"
 npoints(114) = 156
 touse(114) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 114SLAC_PRD58_Apad data:"
 end if
 open(11,file="../../.dato/114SLAC_PRD58_Apad.dato")
 do i = ncount+1,ncount+npoints(114)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(114)
       corr(0,i) = 0.01d0*4.9d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(114))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(114))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(114)
 !115SLAC_PRD58_Aped
 text(115) = "115SLAC_PRD58_Aped            ;K. Abe et al., Phys. Rev., D58 (1998) 112003"
 npoints(115) = 50
 touse(115) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 115SLAC_PRD58_Aped data:"
 end if
 open(11,file="../../.dato/115SLAC_PRD58_Aped.dato")
 do i = ncount+1,ncount+npoints(115)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(115)
       corr(0,i) = 0.01d0*4.9d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(115))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(115))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(115)
 !116SLAC_PLB553_Aped
 text(116) = "116SLAC_PLB553_ApeE155xd      ;P.L.Anthony et al. Phys.Lett.B553(2003)18"
 npoints(116) = 133
 touse(116) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 116SLAC_PLB553_ApeE155xd data:"
 end if
 open(11,file="../../.dato/116SLAC_PLB553_ApeE155xd.dato")
 do i = ncount+1,ncount+npoints(116)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),unc(-1,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(116)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(116))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(116))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(116)
 !117HERMES_PRD75_Apad
 text(117) = "117HERMES_PRD75_Apad          ;A. Airapetian et al., Phys. Rev., D75 (2007) 012007"
 npoints(117) = 45
 touse(117) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 117SLAC_PRD75_Apad data:"
 end if
 open(11,file="../../.dato/117HERMES_PRD75_Apad.dato")
 do i = ncount+1,ncount+npoints(117)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(117)
       corr(0,i) = 0.01d0*0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(117))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(117))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(117)
 !118JLabHallB_PLB672_A1d
 text(118) = "118JLabHallB_PLB672_A1d       ;Y. Prok et al., Phys. Lett., B672 (2009) 12"
 npoints(118) = 7038
 touse(118) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 118JLabHallB_PLB672_A1d data:"
 end if
 open(11,file="../../.dato/118JLabHallB_PLB672_A1d.dato")
 do i = ncount+1,ncount+npoints(118)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(118)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(118))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(118))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(118)
 !119SU2_baryon decay constraints
 text(119) = "119SU2_baryon decay           ;Reference to numbers"
 npoints(119) = 1
 touse(119) = .true.
 data(ncount+1) = 1.269d0
 unc(0,ncount+1) = 0.003d0
 used(ncount+1) = touse(119)
 if(used(ncount+1)) nused = nused + 1
 ncount=ncount+npoints(119)
 !120SU3_baryon decay constraints
 text(120) = "120SU3_baryon decay           ;Reference to numbers"
 npoints(120) = 1
 touse(120) = .true.
 data(ncount+1) = 0.586d0
 unc(0,ncount+1) = 0.031d0
 used(ncount+1) = touse(120)
 if(used(ncount+1)) nused = nused + 1
 ncount=ncount+npoints(120)
 !121SLAC_PRD54_A1He
 text(121) = "121SLAC_PRD54_A1He            ;P. L. Anthony et al., Phys. Rev., D54 (1996) 6620"
 npoints(121) = 8
 touse(121) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 121SLAC_PRD54_A1He data:"
 end if
 open(11,file="../../.dato/121SLAC_PRD54_A1He.dato")
 do i = ncount+1,ncount+npoints(121)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(121)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(121))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(121))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(121)
 !122SLAC_PRD54_A2He
 text(122) = "122SLAC_PRD54_A2He            ;P. L. Anthony et al., Phys. Rev., D54 (1996) 6620"
 npoints(122) = 8
 touse(122) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 122SLAC_PRD54_A1He data:"
 end if
 open(11,file="../../.dato/122SLAC_PRD54_A2He.dato")
 do i = ncount+1,ncount+npoints(122)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(122)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(122))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(122))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(122)
 !123SLAC_PRL79_ApaHe
 text(123) = "123SLAC_PRL79_ApaHe           ;K. Abe et al., Phys. Rev. Lett., 54 (1997) 26"
 npoints(123) = 18
 touse(123) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 123SLAC_PRL79_ApaHe data:"
 end if
 open(11,file="../../.dato/123SLAC_PRL79_ApaHe.dato")
 do i = ncount+1,ncount+npoints(123)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(123)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(123))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(123))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(123)
 !124SLAC_PRL79_ApeHe
 text(124) = "124SLAC_PRL79_ApeHe           ;K. Abe et al., Phys. Rev. Lett., 54 (1997) 26"
 npoints(124) = 18
 touse(124) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 124SLAC_PRL79_ApeHe data:"
 end if
 open(11,file="../../.dato/124SLAC_PRL79_ApeHe.dato")
 do i = ncount+1,ncount+npoints(124)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(124)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(124))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(124))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(124)
 !125HERMES_PLB404_A1n
 text(125) = "125HERMES_PLB404_A1n          ;K. Ackerstaff et al., Phys. Lett., B404 (1997) 383"
 npoints(125) = 9
 touse(125) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 125HERMES_PLB404_A1n data:"
 end if
 open(11,file="../../.dato/125HERMES_PLB404_A1n.dato")
 do i = ncount+1,ncount+npoints(125)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(125)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(125))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(125))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(125)
 !126JLabHallA_PRL92_ApaHe
 text(126) = "126JLabHallA_PRL92_ApaHe      ;X. Zhang et al., Phys. Rev. Lett., 92 (2004) 012004"
 npoints(126) = 3
 touse(126) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 126JLabHallA_PRL92_ApaHe data:"
 end if
 open(11,file="../../.dato/126JLabHallA_PRL92_ApaHe.dato")
 do i = ncount+1,ncount+npoints(126)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(126)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(126))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(126))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(126)
 !127JLabHallA_PRL92_ApeHe
 text(127) = "127JLabHallA_PRL92_ApeHe      ;X. Zhang et al., Phys. Rev. Lett., 92 (2004) 012004"
 npoints(127) = 3
 touse(127) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 127JLabHallA_PRL92_ApeHe data:"
 end if
 open(11,file="../../.dato/127JLabHallA_PRL92_ApeHe.dato")
 do i = ncount+1,ncount+npoints(127)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(127)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(127))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(127))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(127)
 !128JLabHallA_PRL95_ApaHe
 text(128) = "128JLabHallA_PRL95_ApaHe      ;K. Kramer et al., Phys. Rev. Lett., 95 (2005) 142002"
 npoints(128) = 5
 touse(128) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 128JLabHallA_PRL95_ApaHe data:"
 end if
 open(11,file="../../.dato/128JLabHallA_PRL95_ApaHe.dato")
 do i = ncount+1,ncount+npoints(128)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(128)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(128))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(128))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(128)
 !129JLabHallA_PRL95_ApeHe
 text(129) = "129JLabHallA_PRL95_ApeHe      ;K. Kramer et al., Phys. Rev. Lett., 95 (2005) 142002"
 npoints(129) = 5
 touse(129) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 129JLabHallA_PRL95_ApeHe data:"
 end if
 open(11,file="../../.dato/129JLabHallA_PRL95_ApeHe.dato")
 do i = ncount+1,ncount+npoints(129)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(129)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(129))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(129))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(129)
 !130JLabHallA_PRL101_ApaHe
 text(130) = "130JLabHallA_PRL101_ApaHe     ;P. Solvignon et al., Phys. Rev. Lett., 101 (2008) 182502"
 npoints(130) = 168
 touse(130) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 130JLabHallA_PRL101_ApaHe data:"
 end if
 open(11,file="../../.dato/130JLabHallA_PRL101_ApaHe.dato")
 do i = ncount+1,ncount+npoints(130)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(130)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(130))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(130))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 ncount=ncount+npoints(130)
 !131SLAC_PLB493_Apap
 text(131) = "131SLAC_PLB493_Apap           ;P.L.Anthony et al., Phys. Lett., B493 (2000) 19"
 npoints(131) = 75
 touse(131) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 131SLAC_PLB493_Apap data:"
 end if
 open(11,file="../../.dato/131SLAC_PLB493_Apap.dato")
 do i = ncount+1,ncount+npoints(131)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(131)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(131))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(131))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(131)
 !132SLAC_PLB463_Apad
 text(132) = "132SLAC_PLB463_Apad           ;P.L.Anthony et al., Phys. Lett., B463 (1999) 399"
 npoints(132) = 75
 touse(132) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 132SLAC_PLB63_Apad data:"
 end if
 open(11,file="../../.dato/132SLAC_PLB463_Apad.dato")
 do i = ncount+1,ncount+npoints(132)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i),corr(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(132)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(132))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(132))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(132)
 !133SLAC_PLB493_Apep
 text(133) = "133SLAC_PLB493_Apep           ;P.L.Anthony et al., Phys. Lett., B493 (2000) 19"
 npoints(133) = 71
 touse(133) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 133SLAC_PLB493_Apep data:"
 end if
 open(11,file="../../.dato/133SLAC_PLB493_Apep.dato")
 do i = ncount+1,ncount+npoints(133)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(133)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(133))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(133))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(133)
 !134SLAC_PLB463_Aped
 text(134) = "134SLAC_PLB463_Aped           ;P.L.Anthony et al., Phys. Lett., 463 (1999) 339"
 npoints(134) = 71
 touse(134) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 134SLAC_PLB463_Aped data:"
 end if
 open(11,file="../../.dato/134SLAC_PLB463_Aped.dato")
 do i = ncount+1,ncount+npoints(134)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(134)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(134))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(134))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(134)
 !135HERMES_EPJC72_A2p
 text(135) = "135HERMES_EPJC72_A2p          ;A. Airepetian et al., Eur. Phys. J. C72 (2012) 1921"
 npoints(135) = 23
 touse(135) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 135HERMES_EPJC72_A2p data:"
 end if
 open(11,file="../../.dato/135HERMES_EPJC72_A2p.dato")
 do i = ncount+1,ncount+npoints(135)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i),unc(1,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(135)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(135))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(135))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(135)
 !136_COMPASS_12116849_pgg
 text(136) = "136COMPASS_12116849_pgg       ;COMPASS arXiv:1211.6849 [hep-ex]"
 npoints(136) = 1
 touse(136) = .true.
 xdata(ncount+1) = 0.2d0
 Q2data(ncount+1) = 13d0
 data(ncount+1) = -0.13d0
 unc(0,ncount+1) = 0.15d0
 unc(-1,ncount+1) = 0.15d0
 used(ncount+1) = touse(136)
 if(used(ncount+1)) nused = nused + 1
 ncount=ncount+npoints(136)
 !137UPLUS_dominance constraint
 text(137) = "137UPLUS_dominance"
 npoints(137) = 1
 touse(137) = .false.
 xdata(ncount+1) = 0.99d0
 Q2data(ncount+1) = 1d0
 data(ncount+1) = 1d0
 unc(0,ncount+1) = 0.01d0
 used(ncount+1) = touse(137)
 if(used(ncount+1)) nused = nused + 1
 ncount=ncount+npoints(137)
 !138UPLUS_dominance constraint
 text(138) = "138DPLUS_dominance"
 npoints(138) = 1
 touse(138) = .false.
 xdata(ncount+1) = 0.99d0
 Q2data(ncount+1) = 1d0
 data(ncount+1) = 1d0
 unc(0,ncount+1) = 0.01d0
 used(ncount+1) = touse(138)
 if(used(ncount+1)) nused = nused + 1
 ncount=ncount+npoints(138)
 !139DUB_secondmoment
 text(139) = "139DUB_secondmoment"
 npoints(139) = 1
 touse(139) = .true.
 data(ncount+1) = 1d0
 unc(0,ncount+1) = 0.25d0
 used(ncount+1) = touse(139)
 if(used(ncount+1)) nused = nused + 1
 ncount=ncount+npoints(139)
 !140DDB_secondmoment
 text(140) = "140DDB_secondmoment"
 npoints(140) = 1
 touse(140) = .true.
 data(ncount+1) = 1d0
 unc(0,ncount+1) = 0.25d0
 used(ncount+1) = touse(140)
 if(used(ncount+1)) nused = nused + 1
 ncount=ncount+npoints(140)
 !141BCDMS_PRL_F2p
 text(141) = "141BCDMS_PRL_F2p              ;Monahan et al. arXiv: 1209.4542"
 npoints(141) = 10
 touse(141) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 141BCDMS_PRL_F2p data:"
 end if
 open(11,file="../../.dato/141BCDMS_PRL_F2p.dato")
 do i = ncount+1,ncount+npoints(141)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(141)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(141))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(141))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(141)
 !142BCDMS_PRL_FLp
 text(142) = "142BCDMS_PRL_FLp              ;Monahan et al. arXiv: 1209.4542"
 npoints(142) = 10
 touse(142) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 142BCDMS_PRL_FLp data:"
 end if
 open(11,file="../../.dato/142BCDMS_PRL_FLp.dato")
 do i = ncount+1,ncount+npoints(142)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(142)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(142))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(142))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(142)
 !143SLAC140x_PRL_F2p
 text(143) = "143SLAC140x_PRL_F2p           ;Monahan et al. arXiv: 1209.4542"
 npoints(143) = 4
 touse(143) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 143SLAC140x_PRL_F2p data:"
 end if
 open(11,file="../../.dato/143SLAC140x_PRL_F2p.dato")
 do i = ncount+1,ncount+npoints(143)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(143)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(143))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(143))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(143)
 !144SLAC140x_PRL_FLp
 text(144) = "144SLAC140x_PRL_FLp           ;Monahan et al. arXiv: 1209.4542"
 npoints(144) = 4
 touse(144) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 144SLAC140x_PRL_FLp data:"
 end if
 open(11,file="../../.dato/144SLAC140x_PRL_FLp.dato")
 do i = ncount+1,ncount+npoints(144)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(144)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(144))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(144))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(144)
 !145EMC_PRL_F2p
 text(145) = "145EMC_PRL_F2p                ;Monahan et al. arXiv: 1209.4542"
 npoints(145) = 28
 touse(145) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 145EMC_PRL_F2p data:"
 end if
 open(11,file="../../.dato/145EMC_PRL_F2p.dato")
 do i = ncount+1,ncount+npoints(145)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(145)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(145))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(145))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(145)
 !146EMC_PRL_FLp
 text(146) = "146EMC_PRL_FLp                ;Monahan et al. arXiv: 1209.4542"
 npoints(146) = 28
 touse(146) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 146EMC_PRL_FLp data:"
 end if
 open(11,file="../../.dato/146EMC_PRL_FLp.dato")
 do i = ncount+1,ncount+npoints(146)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(146)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(146))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(146))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(146)
 !147JLab94110_PRL_F2p
 text(147) = "147JLab94110_PRL_F2p          ;Monahan et al. arXiv: 1209.4542"
 npoints(147) = 167
 touse(147) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 147JLab94110_PRL_F2p data:"
 end if
 open(11,file="../../.dato/147JLab94110_PRL_F2p.dato")
 do i = ncount+1,ncount+npoints(147)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(147)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(147))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(147))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(147)
 !148JLab94110_PRL_FLp
 text(148) = "148JLab94110_PRL_FLp          ;Monahan et al. arXiv: 1209.4542"
 npoints(148) = 167
 touse(148) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 148JLab94110_PRL_FLp data:"
 end if
 open(11,file="../../.dato/148JLab94110_PRL_FLp.dato")
 do i = ncount+1,ncount+npoints(148)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(148)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(148))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(148))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(148)
 !149JLab99118_PRL_F2p
 text(149) = "149JLab99118_PRL_F2p          ;Monahan et al. arXiv: 1209.4542"
 npoints(149) = 8
 touse(149) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 149JLab99118_PRL_F2p data:"
 end if
 open(11,file="../../.dato/149JLab99118_PRL_F2p.dato")
 do i = ncount+1,ncount+npoints(149)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(149)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(149))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(149))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(149)
 !150JLab99118_PRL_FLp
 text(150) = "150JLab99118_PRL_FLp          ;Monahan et al. arXiv: 1209.4542"
 npoints(150) = 8
 touse(150) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 150JLab99118_PRL_FLp data:"
 end if
 open(11,file="../../.dato/150JLab99118_PRL_FLp.dato")
 do i = ncount+1,ncount+npoints(150)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= Q2cut).and.(W2(xdata(i),Q2data(i)) >= W2cut)) then
       used(i) = touse(150)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(150))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(150))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 close(11)
 ncount=ncount+npoints(150)
 !151JLabHallA_E1206122_A1n
 text(151) = "151JLabHallA_E1206122_A1n     ;Pseudodata"
 npoints(151) = 16
 touse(151) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 151JLabHallA_E1206122_A1n:"
 end if
 open(11,file="../../.dato/151JLabHallA_E1206122_A1n.dato")
 do i = ncount+1,ncount+npoints(151)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(151)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(151))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(151))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 ncount=ncount+npoints(151)
 !152JLabHallB_E1206109_Apap
 text(152) = "152JLabHallB_E1206109_Apap    ;Pseudodata"
 npoints(152) = 76
 touse(152) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 152JLabHallB_E1206109_Apap:"
 end if
 open(11,file="../../.dato/152JLabHallB_E1206109_Apap.dato")
 do i = ncount+1,ncount+npoints(152)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(152)
       corr(0,i) = 0.01d0*4d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(152))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(152))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 ncount=ncount+npoints(152)
 !153JLabHallB_E1206109_Apad
 text(153) = "153JLabHallB_E1206109_Apad    ;Pseudodata"
 npoints(153) = 76
 touse(153) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 153JLabHallB_E1206109_Apad:"
 end if
 open(11,file="../../.dato/153JLabHallB_E1206109_Apad.dato")
 do i = ncount+1,ncount+npoints(153)
    read(11,*) xdata(i),ydata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(153)
       corr(0,i) = 0.01d0*6d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(153))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(153))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 ncount=ncount+npoints(153)
 !154JLabHallC_E1206110_A1n
 text(154) = "154JLabHallC_E1206110_A1n     ;Pseudodata"
 npoints(154) = 11
 touse(154) = .false.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 154JLabHallC_E1206110_A1n:"
 end if
 open(11,file="../../.dato/154JLabHallC_E1206110_A1n.dato")
 do i = ncount+1,ncount+npoints(154)
    read(11,*) xdata(i),Q2data(i),data(i),unc(0,i)
    if ((Q2data(i) >= pQ2cut).and.(W2(xdata(i),Q2data(i)) >= pW2cut)) then
       used(i) = touse(154)
       corr(0,i) = 0.01d0*0.0d0*data(i)
       if(used(i)) nused = nused + 1
       if ((oflag==2).and.(touse(154))) write(6,12) i,xdata(i),Q2data(i),data(i),unc(0,i)
    else
       if ((oflag==2).and.(touse(154))) write(6,11) " Data rejected: ",i,Q2data(i),W2(xdata(i),Q2data(i))
    end if
 end do
 ncount=ncount+npoints(154)
 !155PHENIX_PRD79_ALLpi0
 text(155) = "155PHENIX_PRD79_ALLpi0        ;A. Adare et al., PRD79(2009)012003"
 npoints(155) = 5
 touse(155) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 155PHENIX_PRD79_ALLpi0:"
 end if
 open(11,file="../../.dato/155PHENIX_PRD79_ALLpi0.dato")
 do i = ncount+1,ncount+npoints(155)
    read(11,*) pTdata(i),data(i),unc(0,i)
    used(i) = touse(155)
    corr(0,i) = 0.01d0*13d0*data(i)
    if (used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(155))) write(6,12) i,pTdata(i),data(i),unc(0,i),corr(0,i)
 end do
 ncount=ncount+npoints(155)
 !156PHENIX_14026296_ALLpi0
 text(156) = "156PHENIX_14026296_ALLpi0     ;A. Adare et al., ArXiv:1402.6296"
 npoints(156) = 12
 ncorra(156) = 2
 ncorrm(156) = 1
 touse(156) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 156PHENIX_14026296_ALLpi0:"
 end if
 open(11,file="../../.dato/156PHENIX_14026296_ALLpi0.dato")
 do i = ncount+1,ncount+npoints(156)
    read(11,*) pTdata(i),data(i),unc(0,i),corr(-1,i),corr(1,i)
    corr(0,i) = 0.01d0*4.8d0*data(i) 
    corr(-2,i) = 4.2d0
    used(i) = touse(156)
    if (used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(156))) write(6,12) i,pTdata(i),data(i),unc(0,i),corr(0,i)
 end do
 ncount=ncount+npoints(156)
 !157STAR_PRD80_ALLpi0
 text(157) = "157STAR_PRD80_ALLpi0          ;B.I. Abelev et al., PRD80(2009)111108(R)"
 npoints(157) = 4
 touse(157) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 157STAR_PRD80_ALLpi0:"
 end if
 open(11,file="../../.dato/157STAR_PRD80_ALLpi0.dato")
 do i = ncount+1,ncount+npoints(157)
    read(11,*) pTdata(i),data(i),unc(0,i),unc(-1,i)
    used(i) = touse(157)
    corr(0,i) = 0.01d0*9.4d0*data(i)
    if (used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(157))) write(6,12) i,pTdata(i),data(i),unc(0,i),corr(0,i)
 end do
 ncount=ncount+npoints(157)
 !158STAR_PRD89_ALLpi0
 text(158) = "158STAR_PRD89_ALLpi0          ;L. Adamczyk et al., PRD89(2014)012001"
 npoints(158) = 6
 touse(158) = .true.
 if (oflag==2) then
    write(6,*)
    write(6,*) " 158STAR_PRD89_ALLpi0:"
 end if
 open(11,file="../../.dato/158STAR_PRD89_ALLpi0.dato")
 do i = ncount+1,ncount+npoints(158)
    read(11,*) pTdata(i),data(i),unc(0,i),unc(-1,i)
    used(i) = touse(158)
    corr(0,i) = 0.01d0*6d0*data(i)
    if (used(i)) nused = nused + 1
    if ((oflag==2).and.(touse(158))) write(6,12) i,pTdata(i),data(i),unc(0,i),corr(0,i)
 end do
 ncount=ncount+npoints(158)
 if ((ncount==ntotal).and.(nused==sum(merge(1,0,used)))) then
    ncumul(0)=0
    ncumul(1:nsets)=(/(sum(npoints(1:i)),i=1,nsets)/)
    write(6,18) " DATER: from ",ntotal," points ",nused," used (lmcount = ",&
                nused + sum(merge(ncorra,0,touse)) + sum(merge(1,0,touse)) + sum(merge(ncorrm,0,touse)),")"
 else
    write(6,*) "DATER: data error, counters of total points:",ntotal,ncount
    write(6,*) "DATER: data error, counters of used points:",nused,sum(merge(1,0,used))
    stop
 end if
 return
end subroutine dater
